/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package core;
import Jama.Matrix;
/**
 *
 * @author pchr
 */
public class Element {
    private int id;
    private Node Node1;
    private Node Node2;
    
    public Element(){}
    
    public Element(int id, Node n1, Node n2){
        this.id=id;
        this.Node1=n1;
        this.Node2=n2;
    }
    
    public int getId(){
        return this.id;
    }
    
    public double getL(){
        double L=0.;
        L=Math.sqrt(  (Node2.getX()-Node1.getX())*(Node2.getX()-Node1.getX()) + (Node2.getY()-Node1.getY())*(Node2.getY()-Node1.getY())  );
        return L;
    }
    
    public Matrix getT() {
            Matrix TrMatrix = new Matrix(6,6);
            double L=this.getL();
            double x1=Node1.getX();
            double x2=Node2.getX();
            double y1=Node1.getY();
            double y2=Node2.getY();
            
            double c=(x2-x1)/L;
            double s=(y2-y1)/L;
            
            TrMatrix.putVal(0, 0,c);
            TrMatrix.putVal(1, 0,-s);
            TrMatrix.putVal(2, 0,0.);
            TrMatrix.putVal(3, 0,0.);
            TrMatrix.putVal(4, 0,0.);
            TrMatrix.putVal(5, 0,0.);
            
            TrMatrix.putVal(0, 1,s);
            TrMatrix.putVal(1, 1,c);
            TrMatrix.putVal(2, 1,0.);
            TrMatrix.putVal(3, 1,0.);
            TrMatrix.putVal(4, 1,0.);
            TrMatrix.putVal(5, 1,0.);
            
            TrMatrix.putVal(0, 2,0.);
            TrMatrix.putVal(1, 2,0.);
            TrMatrix.putVal(2, 2,1.);
            TrMatrix.putVal(3, 2,0.);
            TrMatrix.putVal(4, 2,0.);
            TrMatrix.putVal(5, 2,0.);
            
            TrMatrix.putVal(0, 3,0.);
            TrMatrix.putVal(1, 3,0.);
            TrMatrix.putVal(2, 3,0.);
            TrMatrix.putVal(3, 3,c);
            TrMatrix.putVal(4, 3,-s);
            TrMatrix.putVal(5, 3,0.);
            
            TrMatrix.putVal(0, 4,0.);
            TrMatrix.putVal(1, 4,0.);
            TrMatrix.putVal(2, 4,0.);
            TrMatrix.putVal(3, 4,s);
            TrMatrix.putVal(4, 4,c);
            TrMatrix.putVal(5, 4,0.);
            
            TrMatrix.putVal(0, 5,0.);
            TrMatrix.putVal(1, 5,0.);
            TrMatrix.putVal(2, 5,0.);
            TrMatrix.putVal(3, 5,0.);
            TrMatrix.putVal(4, 5,0.);
            TrMatrix.putVal(5, 5,1.);
            
            return TrMatrix;
    }
    
    public Node getN1(){
        return this.Node1;
    }
    
    public Node getN2(){
        return this.Node2;
    }
    
    public Matrix getDef(double u1, double v1, double f1,
                           double u2, double v2, double f2,
                           double xt){
        Matrix def= new Matrix(2,1);
        Matrix cor = new Matrix(2,1);
        double L=this.getL();
        double x=L*(xt+1.)/2.;
        def.addVal(0, 0, 
                (1.-x/L)*u1+x/L*u2 );
        def.addVal(1, 0, 
                (1.-3.*x*x/(L*L)+2.*x*x*x/(L*L*L))*v1+
                (x-2.*x*x/(L)+x*x*x/(L*L))*f1+
                (3.*x*x/(L*L)-2.*x*x*x/(L*L*L))*v2+
                (-x*x/L+x*x*x/(L*L))*f2 );
        
        double x1=Node1.getX();
        double x2=Node2.getX();
        double y1=Node1.getY();
        double y2=Node2.getY();
        
        cor.addVal(0, 0,  
                (1.-x/L)*x1+x/L*x2 );
        cor.addVal(1, 0,  
                (1.-x/L)*y1+x/L*y2 );

        double c=(x2-x1)/L;
        double s=(y2-y1)/L;
        Matrix tempT = new Matrix(2,2);
        tempT.addVal(0, 0, c);
        tempT.addVal(1, 0, -s);
        tempT.addVal(0, 1, s);
        tempT.addVal(1, 1, c);
        //tempT = tempT.inverse();
        //def = tempT.times(def);
        def=def.plus(cor);
        return def;
    }
}
