/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package core;

import Jama.EigenvalueDecomposition;
import Jama.Matrix;

/**
 *
 * @author pchr
 */
public class Frame extends Structure{
    private boolean stiffFrame=false;
    
    private double h1,h2,h3;
    private double m1,m2,m3;
    private double b1,b2,b3;
    private double d1,d2,d3;
    private double L,Elast;
    double I1,I2,I3;
    double A1,A2,A3;
    
    private boolean BaseIsolated=false;
    
    private double Kb,Cb,Mb,Zb,omegaB;
    
    
    public Frame(){
        this.type=1;
        nElems=9;
        nNodes=8;
        this.FrameElements = new Element[nElems];
        this.FrameNodes = new Node[nNodes];
        this.numDOFS=3;
        this.setDOFS();
    }
    
    public Frame(int numStories){
        this.type=1;
        if(numStories==1){
            nElems=3;
            nNodes=4;
        }else if(numStories==2){
            nElems=6;
            nNodes=6;
        }else if(numStories==3){
            nElems=9;
            nNodes=8;
        }else{
            System.out.println("ΛΑΘΟΣ ΑΡΙΘΜΟΣ ΟΡΟΦΩΝ");
        }
        this.numDOFS=numStories;
        this.FrameElements = new Element[nElems];
        this.FrameNodes = new Node[nNodes];
        this.setDOFS();
    }
    
    public void setBaseIsolated(boolean is){
        this.BaseIsolated=is;
    }
    
    public void setK(){
        double cf;
        if(this.stiffFrame){
            cf=12;
            switch(this.numDOFS){
                case 1:
                    K = new Matrix(1,1);
                    K.init();
                    K.addVal(0, 0, 2.*cf*Elast*I1/(h1*h1*h1));
                    break;
                case 2:
                    K = new Matrix(2,2);
                    K.init();
                    K.addVal(0, 0, 2.*cf*Elast*I1/(h1*h1*h1)+2.*cf*Elast*I2/(h2*h2*h2));
                    K.addVal(1, 0, -2.*cf*Elast*I2/(h2*h2*h2));
                    K.addVal(0, 1, -2.*cf*Elast*I2/(h2*h2*h2));
                    K.addVal(1, 1, 2.*cf*Elast*I2/(h2*h2*h2));
                    break;
                case 3:
                    K = new Matrix(3,3);
                    K.init();
                    K.addVal(0, 0, 2.*cf*Elast*I1/(h1*h1*h1)+2.*cf*Elast*I2/(h2*h2*h2));
                    K.addVal(1, 0, -2.*cf*Elast*I2/(h2*h2*h2));
                    K.addVal(2, 0, 0.0);
                    K.addVal(0, 1, -2.*cf*Elast*I2/(h2*h2*h2));
                    K.addVal(1, 1, 2.*cf*Elast*I3/(h3*h3*h3)+2.*cf*Elast*I2/(h2*h2*h2));
                    K.addVal(2, 1, -2.*cf*Elast*I3/(h3*h3*h3));
                    K.addVal(0, 2, 0.0);
                    K.addVal(1, 2, -2.*cf*Elast*I3/(h3*h3*h3));
                    K.addVal(2, 2, 2.*cf*Elast*I3/(h3*h3*h3));
                    break;
            }
        }else{
            switch(this.numDOFS){
                case 1:
                    K = new Matrix(1,1);
                    K.init();
                    K.addVal(0, 0,2.*3.*Elast*I1/(h1*h1*h1));break;
                case 2:
                    K = new Matrix(2,2);
                    K.init();
                    K.addVal(0, 0,2.*12.*Elast*I1*(h2*h2*h2*I1+h1*h1*h1*I2+3.*h1*h2*(h1+h2)*I2)/(h1*h1*h1*h2*h2*(4.*h2*I1+3.*h1*I2))  );
                    K.addVal(1, 0,-2.*6.*Elast*(2.*h1+3.*h2)*I1*I2/(h1*h2*h2*(4.*h2*I1+3.*h1*I2)));
                    K.addVal(0, 1,-2.*6.*Elast*(2.*h1+3.*h2)*I1*I2/(h1*h2*h2*(4.*h2*I1+3.*h1*I2)));
                    K.addVal(1, 1,2.*12.*Elast*I1*I2/(h2*h2*(4.*h2*I1+3.*h1*I2)));
                    break;
                case 3:
                    K = new Matrix(3,3);
                    K.init();
                    K.addVal(0, 0,2.*3.*Elast*(3.*h2*h2*h2*h2*I1*I1*I3+12.*h1*h1*h2*I1*I2*(h3*I2+h1*I3)+4.*h2*h2*h2*I1*I2*(h3*I1+3.*h1*I3)+h1*h1*h1*I2*I2*(4*h3*I1+3*h1*I3)+6*h1*h2*h2*I1*I2*(2*h3*I2+3*h1*I3))/(h1*h1*h1*h2*h2*(h3*I2*(4*h2*I1+3*h1*I2)+3*h2*(h2*I1+h1*I2)*I3)));
                    K.addVal(1, 0,-2.*3*Elast*I2*(4*h1*h3*h3*I1*I2+6*h1*h2*(h2+2*h3)*I1*I3+3*h1*h1*(h2+h3)*I2*I3+3*h2*I1*(2*h3*h3*I2+h2*(h2+3*h3)*I3))/(h1*h2*h2*h3*(h3*I2*(4*h2*I1+3*h1*I2) +3*h2*(h2*I1+h1*I2)*I3)) );
                    K.addVal(2, 0,2.*9*Elast*I2*(h2*(2*h1+h2)*I1+h1*h1*I2)*I3/(h1*h2*h3*(h3*I2*(4*h2*I1+3*h1*I2)+3*h2*(h2*I1+h1*I2)*I3)) );
                    K.addVal(0, 1,-2.*3*Elast*I2*(4*h1*h3*h3*I1*I2+6*h1*h2*(h2+2*h3)*I1*I3+3*h1*h1*(h2+h3)*I2*I3+3*h2*I1*(2*h3*h3*I2+h2*(h2+3*h3)*I3))/(h1*h2*h2*h3*(h3*I2*(4*h2*I1+3*h1*I2) +3*h2*(h2*I1+h1*I2)*I3))  );
                    K.addVal(1, 1,2.*3*Elast*I2*(4*h3*h3*h3*I1*I2+6*h2*h3*(2*h2*I1+h1*I2)*I3+3*h3*h3*(4*h2*I1+h1*I2)*I3+h2*h2*(4*h2*I1+3*h1*I2)*I3)/(h2*h2*h3*h3*(h3*I2*(4*h2*I1+3*h1*I2)+3*h2*(h2*I1+h1*I2)*I3)) );
                    K.addVal(2, 1,-2.*3*Elast*I2*(2*h2*(2*h2+3*h3)*I1+3*h1*(h2+h3)*I2)*I3/(h2*h3*h3*(h3*I2*(4*h2*I1+3*h1*I2)+3*h2*(h2*I1+h1*I2)*I3)) );
                    K.addVal(0, 2,2.*9*Elast*I2*(h2*(2*h1+h2)*I1+h1*h1*I2)*I3/(h1*h2*h3*(h3*I2*(4*h2*I1+3*h1*I2)+3*h2*(h2*I1+h1*I2)*I3))  );
                    K.addVal(1, 2,-2.*3*Elast*I2*(2*h2*(2*h2+3*h3)*I1+3*h1*(h2+h3)*I2)*I3/(h2*h3*h3*(h3*I2*(4*h2*I1+3*h1*I2)+3*h2*(h2*I1+h1*I2)*I3))  );
                    K.addVal(2, 2,2.*3*Elast*I2*(4*h2*I1+3*h1*I2)*I3/(h3*h3*(h3*I2*(4*h2*I1+3*h1*I2)+3*h2*(h2*I1+h1*I2)*I3)));
                    break;
            }
        }
    }
    
    public void setC(double zeta){
        Matrix Cd;
        int numStories1=numDOFS;
        switch(numStories1){
            case 1:
                C = new Matrix(1,1);
                Cd = new Matrix(1,1);
                C.init(); Cd.init();
                Cd.set(0, 0, 2*zeta*2.*Math.PI/(this.getEigPeriod(1))*this.getEigMass(1));
                C=(((this.eigenMat.transpose()).inverse()).times(Cd)).times(this.eigenMat.inverse());
                break;
            case 2:
                C = new Matrix(2,2);
                Cd = new Matrix(2,2);
                C.init(); Cd.init();
                Cd.set(0, 0, 2*zeta*2.*Math.PI/(this.getEigPeriod(1))*this.getEigMass(1));
                Cd.set(1, 1, 2*zeta*2.*Math.PI/(this.getEigPeriod(2))*this.getEigMass(2));
                C=(((this.eigenMat.transpose()).inverse()).times(Cd)).times(this.eigenMat.inverse());
                break;
            case 3:
                C = new Matrix(3,3);
                Cd = new Matrix(3,3);
                C.init(); Cd.init();
                Cd.set(0, 0, 2*zeta*2.*Math.PI/(this.getEigPeriod(1))*this.getEigMass(1));
                Cd.set(1, 1, 2*zeta*2.*Math.PI/(this.getEigPeriod(2))*this.getEigMass(2));
                Cd.set(2, 2, 2*zeta*2.*Math.PI/(this.getEigPeriod(3))*this.getEigMass(3));
                C=(((this.eigenMat.transpose()).inverse()).times(Cd)).times(this.eigenMat.inverse());
                break;
        }
    }
    
    public void setM(){
        switch(this.numDOFS){
            case 1:
                M = new Matrix(1,1);
                M.init();
                M.addVal(0, 0, m1);
               break;
            case 2:
                M = new Matrix(2,2);
                M.init();
                M.addVal(0, 0, m1);
                M.addVal(1, 1, m2);
               break;
            case 3:
                M = new Matrix(3,3);
                M.init();
                M.addVal(0, 0, m1);
                M.addVal(1, 1, m2);
                M.addVal(2, 2, m3);
               break;
        }
    }
    
    protected void setDOFS(){
        dofs= new int[9][6];
        dofs[0][0]=1; dofs[0][1]=2; dofs[0][2]=3; dofs[0][3]=7; dofs[0][4]=8; dofs[0][5]=9;
        dofs[1][0]=4; dofs[1][1]=5; dofs[1][2]=6; dofs[1][3]=10; dofs[1][4]=11; dofs[1][5]=12;
        dofs[2][0]=7; dofs[2][1]=8; dofs[2][2]=9; dofs[2][3]=10; dofs[2][4]=11; dofs[2][5]=12;
        dofs[3][0]=7; dofs[3][1]=8; dofs[3][2]=9; dofs[3][3]=13; dofs[3][4]=14; dofs[3][5]=15;
        dofs[4][0]=10; dofs[4][1]=11; dofs[4][2]=12; dofs[4][3]=16; dofs[4][4]=17; dofs[4][5]=18;
        dofs[5][0]=13; dofs[5][1]=14; dofs[5][2]=15; dofs[5][3]=16; dofs[5][4]=17; dofs[5][5]=18;
        dofs[6][0]=13; dofs[6][1]=14; dofs[6][2]=15; dofs[6][3]=19; dofs[6][4]=20; dofs[6][5]=21;
        dofs[7][0]=16; dofs[7][1]=17; dofs[7][2]=18; dofs[7][3]=22; dofs[7][4]=23; dofs[7][5]=24;
        dofs[8][0]=19; dofs[8][1]=20; dofs[8][2]=21; dofs[8][3]=22; dofs[8][4]=23; dofs[8][5]=24;

    }
    
    private void equal(Matrix a, Matrix b){
        for(int i=0;i<a.getRowDimension();i++){b.set(i, 0, a.get(i, 0));}
    }
    
    private void equal(Matrix a, Matrix b, int row){
        for(int i=0;i<a.getRowDimension();i++){b.set(i, row, a.get(i, 0));}
    }
    
    public double getL(){
        return L;
    }
    
    public double geth1(){
        return h1;
    }
    
    public double geth2(){
        return h2;
    }
    
    public double geth3(){
        return h3;
    }
    
    public Matrix getDefElement(int elemId, double x0, int sit, boolean isoFlag){
        // x0 e [-1,1]
        int numstories1=numDOFS;
        if(isoFlag){numstories1=numDOFS+1;}
        double u1,v1,f1,u2,v2,f2;
        u1=0.;v1=0.;f1=0.;u2=0.;v2=0.;f2=0.;
        double[] vec = new double[24];
        double[] send_vec ;
        if(isoFlag) {send_vec = new double[4];}else{send_vec = new double[3];}
        
        if(isoFlag){
            send_vec[0]=this.disp0[this.step];
            send_vec[1]=this.disp1[this.step];
            send_vec[2]=this.disp2[this.step];
            send_vec[3]=this.disp3[this.step];
        }else{
            send_vec[0]=this.disp1[this.step];
            send_vec[1]=this.disp2[this.step];
            send_vec[2]=this.disp3[this.step];
        }
        
        double max=this.maxU;
        //for(int i=0;i<3;i++){
        //    if(Math.abs(send_vec[i])>max){max=Math.abs(send_vec[i]);}
        //}
        
        for(int i=0;i<numstories1;i++){
            send_vec[i]=scale*send_vec[i]/max;
        }
        for(int i=0;i<vec.length;i++){vec[i]=0.;}
        
        if(isoFlag){
            vec[0]=send_vec[0]; vec[3]=send_vec[0];
            vec[6]=send_vec[1]; vec[9]=send_vec[1];
            vec[12]=send_vec[2]; vec[15]=send_vec[2];
            vec[18]=send_vec[3]; vec[21]=send_vec[3];
        }else{
            vec[6]=send_vec[0]; vec[9]=send_vec[0];
            vec[12]=send_vec[1]; vec[15]=send_vec[1];
            vec[18]=send_vec[2]; vec[21]=send_vec[2];
        }
        
        u1=vec[dofs[elemId-1][0]-1];
        v1=vec[dofs[elemId-1][1]-1];
        f1=vec[dofs[elemId-1][2]-1];
        u2=vec[dofs[elemId-1][3]-1];
        v2=vec[dofs[elemId-1][4]-1];
        f2=vec[dofs[elemId-1][5]-1];
        /*if(elemId==1 || elemId==2){
            f2=-(u2-u1)/this.getL();
        }else{
            f1=-(u2-u1)/this.getL();
            f2=f1;
        }*/
        return this.FrameElements[elemId-1].getDef(u1, v1, f1, u2, v2, f2, x0);
    }
    
    
    @Override
    public void setGeometry(double[] data ){
        h1=data[0]; h2=data[1]; h3=data[2];
        m1=data[3]; m2=data[4]; m3=data[5];
        b1=data[6]; b2=data[7]; b3=data[8];
        d1=data[9]; d2=data[10]; d3=data[11];
        L=data[12]; Elast=data[13];
        A1=b1*d1; A2=b2*d2; A3=b3*d3;
        I1=b1*d1*d1*d1/12.; I2=b2*d2*d2*d2/12.; I3=b3*d3*d3*d3/12.;
    }
    
    public void setStiff(boolean st){
        this.stiffFrame=st;
    }
    
    ////////////////////////////////////////////////////////////////
    // FOR ISOLATED FRAME
    ////////////////////////////////////////////////////////////////
    
    public void setIsolation(double Kb, double Zb, double Mb){
        this.Kb=Kb;
        this.Mb=Mb; if(this.Mb<0.1e-12)this.Mb=0.1e-12;
        
        double Mt=m1;
        if(this.numDOFS>1)Mt+=m2;
        if(this.numDOFS>2)Mt+=m3;
        this.omegaB=Math.sqrt(Kb/(Mb+Mt));
        
        this.Zb=Zb;
        this.Cb=Zb*2.*(Mt+Mb)*omegaB;
    }
    
    public void setKiso(){
        double cf;
        if(this.stiffFrame){
            cf=12;
            switch(this.numDOFS){
                case 1:
                    K = new Matrix(2,2);
                    K.init();
                    K.addVal(0, 0, 2.*this.Kb+2.*cf*Elast*I1/(h1*h1*h1));
                    K.addVal(1, 0, -2.*cf*Elast*I1/(h1*h1*h1));
                    K.addVal(0, 1, -2.*cf*Elast*I1/(h1*h1*h1));
                    
                    K.addVal(1, 1, 2.*cf*Elast*I1/(h1*h1*h1));
                    break;
                case 2:
                    K = new Matrix(3,3);
                    K.init();
                    K.addVal(0, 0, 2.*this.Kb+2.*cf*Elast*I1/(h1*h1*h1));
                    K.addVal(1, 0, -2.*cf*Elast*I1/(h1*h1*h1));
                    K.addVal(0, 1, -2.*cf*Elast*I1/(h1*h1*h1));
                    
                    K.addVal(1, 1, 2.*cf*Elast*I1/(h1*h1*h1)+2.*cf*Elast*I2/(h2*h2*h2));
                    K.addVal(2, 1, -2.*cf*Elast*I2/(h2*h2*h2));
                    K.addVal(1, 2, -2.*cf*Elast*I2/(h2*h2*h2));
                    K.addVal(2, 2, 2.*cf*Elast*I2/(h2*h2*h2));
                    break;
                case 3:
                    K = new Matrix(4,4);
                    K.init();
                    K.addVal(0, 0, 2.*this.Kb+2.*cf*Elast*I1/(h1*h1*h1));
                    K.addVal(1, 0, -2.*cf*Elast*I1/(h1*h1*h1));
                    K.addVal(0, 1, -2.*cf*Elast*I1/(h1*h1*h1));
                    ;
                    K.addVal(1, 1, 2.*cf*Elast*I1/(h1*h1*h1)+2.*cf*Elast*I2/(h2*h2*h2));
                    K.addVal(2, 1, -2.*cf*Elast*I2/(h2*h2*h2));
                    K.addVal(3, 1, 0.0);
                    K.addVal(1, 2, -2.*cf*Elast*I2/(h2*h2*h2));
                    K.addVal(2, 2, 2.*cf*Elast*I3/(h3*h3*h3)+2.*cf*Elast*I2/(h2*h2*h2));
                    K.addVal(3, 2, -2.*cf*Elast*I3/(h3*h3*h3));
                    K.addVal(1, 3, 0.0);
                    K.addVal(2, 3, -2.*cf*Elast*I3/(h3*h3*h3));
                    K.addVal(3, 3, 2.*cf*Elast*I3/(h3*h3*h3));
                    break;
            }
        }else{
            switch(this.numDOFS){
                case 1:
                    K = new Matrix(2,2);
                    K.init();
                    K.addVal(0, 0, 2.*this.Kb+2.*3.*Elast*I1/(h1*h1*h1));
                    K.addVal(1, 0, -2.*3.*Elast*I1/(h1*h1*h1));
                    K.addVal(0, 1, -2.*3.*Elast*I1/(h1*h1*h1));
                    
                    K.addVal(1, 1,2.*3.*Elast*I1/(h1*h1*h1));break;
                case 2:
                    K = new Matrix(3,3);
                    K.init();
                    K.addVal(0, 0, 2.*this.Kb+2.*3.*Elast*I1/(h1*h1*h1));
                    K.addVal(1, 0, -2.*3.*Elast*I1/(h1*h1*h1));
                    K.addVal(0, 1, -2.*3.*Elast*I1/(h1*h1*h1));
                    
                    K.addVal(1, 1,2.*12.*Elast*I1*(h2*h2*h2*I1+h1*h1*h1*I2+3.*h1*h2*(h1+h2)*I2)/(h1*h1*h1*h2*h2*(4.*h2*I1+3.*h1*I2))  );
                    K.addVal(2, 1,-2.*6.*Elast*(2.*h1+3.*h2)*I1*I2/(h1*h2*h2*(4.*h2*I1+3.*h1*I2)));
                    K.addVal(1, 2,-2.*6.*Elast*(2.*h1+3.*h2)*I1*I2/(h1*h2*h2*(4.*h2*I1+3.*h1*I2)));
                    K.addVal(2, 2,2.*12.*Elast*I1*I2/(h2*h2*(4.*h2*I1+3.*h1*I2)));
                    break;
                case 3:
                    K = new Matrix(4,4);
                    K.init();
                    K.addVal(0, 0, 2.*this.Kb+2.*3.*Elast*I1/(h1*h1*h1));
                    K.addVal(1, 0, -2.*3.*Elast*I1/(h1*h1*h1));
                    K.addVal(0, 1, -2.*3.*Elast*I1/(h1*h1*h1));
                    
                    K.addVal(1, 1,2.*3.*Elast*(3.*h2*h2*h2*h2*I1*I1*I3+12.*h1*h1*h2*I1*I2*(h3*I2+h1*I3)+4.*h2*h2*h2*I1*I2*(h3*I1+3.*h1*I3)+h1*h1*h1*I2*I2*(4*h3*I1+3*h1*I3)+6*h1*h2*h2*I1*I2*(2*h3*I2+3*h1*I3))/(h1*h1*h1*h2*h2*(h3*I2*(4*h2*I1+3*h1*I2)+3*h2*(h2*I1+h1*I2)*I3)));
                    K.addVal(2, 1,-2.*3*Elast*I2*(4*h1*h3*h3*I1*I2+6*h1*h2*(h2+2*h3)*I1*I3+3*h1*h1*(h2+h3)*I2*I3+3*h2*I1*(2*h3*h3*I2+h2*(h2+3*h3)*I3))/(h1*h2*h2*h3*(h3*I2*(4*h2*I1+3*h1*I2) +3*h2*(h2*I1+h1*I2)*I3)) );
                    K.addVal(3, 1,2.*9*Elast*I2*(h2*(2*h1+h2)*I1+h1*h1*I2)*I3/(h1*h2*h3*(h3*I2*(4*h2*I1+3*h1*I2)+3*h2*(h2*I1+h1*I2)*I3)) );
                    K.addVal(1, 2,-2.*3*Elast*I2*(4*h1*h3*h3*I1*I2+6*h1*h2*(h2+2*h3)*I1*I3+3*h1*h1*(h2+h3)*I2*I3+3*h2*I1*(2*h3*h3*I2+h2*(h2+3*h3)*I3))/(h1*h2*h2*h3*(h3*I2*(4*h2*I1+3*h1*I2) +3*h2*(h2*I1+h1*I2)*I3))  );
                    K.addVal(2, 2,2.*3*Elast*I2*(4*h3*h3*h3*I1*I2+6*h2*h3*(2*h2*I1+h1*I2)*I3+3*h3*h3*(4*h2*I1+h1*I2)*I3+h2*h2*(4*h2*I1+3*h1*I2)*I3)/(h2*h2*h3*h3*(h3*I2*(4*h2*I1+3*h1*I2)+3*h2*(h2*I1+h1*I2)*I3)) );
                    K.addVal(3, 2,-2.*3*Elast*I2*(2*h2*(2*h2+3*h3)*I1+3*h1*(h2+h3)*I2)*I3/(h2*h3*h3*(h3*I2*(4*h2*I1+3*h1*I2)+3*h2*(h2*I1+h1*I2)*I3)) );
                    K.addVal(1, 3,2.*9*Elast*I2*(h2*(2*h1+h2)*I1+h1*h1*I2)*I3/(h1*h2*h3*(h3*I2*(4*h2*I1+3*h1*I2)+3*h2*(h2*I1+h1*I2)*I3))  );
                    K.addVal(2, 3,-2.*3*Elast*I2*(2*h2*(2*h2+3*h3)*I1+3*h1*(h2+h3)*I2)*I3/(h2*h3*h3*(h3*I2*(4*h2*I1+3*h1*I2)+3*h2*(h2*I1+h1*I2)*I3))  );
                    K.addVal(3, 3,2.*3*Elast*I2*(4*h2*I1+3*h1*I2)*I3/(h3*h3*(h3*I2*(4*h2*I1+3*h1*I2)+3*h2*(h2*I1+h1*I2)*I3)));
                    break;
            }
        }
    }
    
    public void setMiso(){
        switch(this.numDOFS){
            case 1:
                M = new Matrix(2,2);
                M.init();
                M.addVal(0, 0, this.Mb);
                
                M.addVal(1, 1, m1);
               break;
            case 2:
                M = new Matrix(3,3);
                M.init();
                M.addVal(0, 0, this.Mb);
                
                M.addVal(1, 1, m1);
                M.addVal(2, 2, m2);
               break;
            case 3:
                M = new Matrix(4,4);
                M.init();
                M.addVal(0, 0, this.Mb);
                
                M.addVal(1, 1, m1);
                M.addVal(2, 2, m2);
                M.addVal(3, 3, m3);
               break;
        }
    }
    
    public void setCiso(){
        Matrix Cd;
        int numStories1=numDOFS+1;
        Cd = new Matrix(numStories1,numStories1);
        Cd.init();
        for(int i=0;i<numDOFS;i++){
            for(int j=0;j<numDOFS;j++){
                Cd.set(i+1, j+1, C.get(i, j));
            }
        }
        Cd.set(0, 0, this.Cb);
        C = new Matrix(numStories1,numStories1);
        for(int i=0;i<numStories1;i++){
            for(int j=0;j<numStories1;j++){
                C.set(i, j, Cd.get(i, j));
            }
        }
    }
    
    public void EigenRuniso(){
        //thelei ftiaximo
        int numStories1=numDOFS+1;
        Matrix eVec = new Matrix(numStories1,1);
        Matrix delta = new Matrix(numStories1,1);
        delta.init();
        switch(numStories1){
            case 2:
                delta.set(0, 0, 1.);
                delta.set(1, 0, 1.);
                break;
            case 3:
                delta.set(0, 0, 1.);
                delta.set(1, 0, 1.);
                delta.set(2, 0, 1.);
                break;
           case 4:
                delta.set(0, 0, 1.);
                delta.set(1, 0, 1.);
                delta.set(2, 0, 1.);
                delta.set(3, 0, 1.);
                break;
        }
        
         K=K.inverse();
         M=K.times(M);  
         EVofInvM_A = new EigenvalueDecomposition(M);
         eig_vals = new double[numStories1];
         eigenMat = new Matrix(numStories1,numStories1);
         this.setKiso();
         this.setMiso();
         for(int i=0;i<numStories1;i++){
             eig_vals[i]=EVofInvM_A.getRealEigenvalues()[i];
             for(int j=0;j<numStories1;j++){
                 eigenMat.set(j, i, EVofInvM_A.getV().get(0, i));
             }
         }
         //eig_vals=EVofInvM_A.getRealEigenvalues();
         //eigenMat=EVofInvM_A.getV();
         // SORT
         int e1,e2,e3,e4;
         
         double max=eig_vals[0];
         e1=0;e2=0;e3=0;e4=0;
         for(int i=0;i<numStories1;i++){
             if(eig_vals[i]>max){max=eig_vals[i]; e1=i;}
         }
         
         double[] eig_sort = new double[eig_vals.length];for(int i=0;i<eig_vals.length;i++){eig_sort[i]=eig_vals[i];}
         //for(int i=0;i<eig_sort.length;i++){System.out.println(eig_sort[i]);}
         //System.out.println("======");
         //Arrays.sort(eig_sort);
         //for(int i=0;i<eig_sort.length;i++){System.out.println(eig_sort[i]);}
         int[] esort;
         boolean swap=true;
        double temp;
        int itemp;
        int cc=0;
         switch(numDOFS){
            case 1:
                esort=new int[3]; for(int i=0;i<esort.length;i++){esort[i]=i;}
                swap=true;
                cc=0;
                while(swap){
                    swap=false;
                    for(int i=0;i<eig_sort.length-1;i++){
                        if(eig_sort[i]>eig_sort[i+1]){
                            temp=eig_sort[i]; itemp=esort[i];
                            eig_sort[i]=eig_sort[i+1]; esort[i]=esort[i+1];
                            eig_sort[i+1]=temp; esort[i+1]=itemp;
                            swap=true;
                        }
                    }
                    cc+=1;
                    if(cc>100) System.exit(cc);
                }
                e1=esort[1]; e2=esort[0];
                
                eig_vals[0]=EVofInvM_A.getRealEigenvalues()[e1];
                eig_vals[1]=EVofInvM_A.getRealEigenvalues()[e2];
                
                eigenMat.set(0, 0, EVofInvM_A.getV().get(0, e1)/EVofInvM_A.getV().get(1, e1));
                eigenMat.set(1, 0, EVofInvM_A.getV().get(1, e1)/EVofInvM_A.getV().get(1, e1));
                
                eigenMat.set(0, 1, EVofInvM_A.getV().get(0, e2)/EVofInvM_A.getV().get(1, e2));
                eigenMat.set(1, 1, EVofInvM_A.getV().get(1, e2)/EVofInvM_A.getV().get(1, e2));
                break;
             case 2:
                esort=new int[3]; for(int i=0;i<esort.length;i++){esort[i]=i;}
                swap=true;
                cc=0;
                while(swap){
                    swap=false;
                    for(int i=0;i<eig_sort.length-1;i++){
                        if(eig_sort[i]>eig_sort[i+1]){
                            temp=eig_sort[i]; itemp=esort[i];
                            eig_sort[i]=eig_sort[i+1]; esort[i]=esort[i+1];
                            eig_sort[i+1]=temp; esort[i+1]=itemp;
                            swap=true;
                        }
                    }
                    cc+=1;
                    if(cc>100) System.exit(cc);
                }
                e1=esort[2]; e2=esort[1]; e3=esort[0];
                
                 eig_vals[0]=EVofInvM_A.getRealEigenvalues()[e1];
                 eig_vals[1]=EVofInvM_A.getRealEigenvalues()[e2];
                 eig_vals[2]=EVofInvM_A.getRealEigenvalues()[e3];
                 
                
                 eigenMat.set(0, 0, EVofInvM_A.getV().get(0, e1)/EVofInvM_A.getV().get(2, e1));
                 eigenMat.set(1, 0, EVofInvM_A.getV().get(1, e1)/EVofInvM_A.getV().get(2, e1));
                 eigenMat.set(2, 0, EVofInvM_A.getV().get(2, e1)/EVofInvM_A.getV().get(2, e1));

                 eigenMat.set(0, 1, EVofInvM_A.getV().get(0, e2)/EVofInvM_A.getV().get(2, e2));
                 eigenMat.set(1, 1, EVofInvM_A.getV().get(1, e2)/EVofInvM_A.getV().get(2, e2));
                 eigenMat.set(2, 1, EVofInvM_A.getV().get(2, e2)/EVofInvM_A.getV().get(2, e2));

                 eigenMat.set(0, 2, EVofInvM_A.getV().get(0, e3)/EVofInvM_A.getV().get(2, e3));
                 eigenMat.set(1, 2, EVofInvM_A.getV().get(1, e3)/EVofInvM_A.getV().get(2, e3));
                 eigenMat.set(2, 2, EVofInvM_A.getV().get(2, e3)/EVofInvM_A.getV().get(2, e3));
                 break;
            case 3:
                esort=new int[4]; for(int i=0;i<esort.length;i++){esort[i]=i;}
                swap=true;
                cc=0;
                while(swap){
                    swap=false;
                    for(int i=0;i<eig_sort.length-1;i++){
                        if(eig_sort[i]>eig_sort[i+1]){
                            temp=eig_sort[i]; itemp=esort[i];
                            eig_sort[i]=eig_sort[i+1]; esort[i]=esort[i+1];
                            eig_sort[i+1]=temp; esort[i+1]=itemp;
                            swap=true;
                        }
                    }
                    cc+=1;
                    if(cc>100) System.exit(cc);
                }
                e1=esort[3]; e2=esort[2]; e3=esort[1]; e4=esort[0];
                
                 eig_vals[0]=EVofInvM_A.getRealEigenvalues()[e1];
                 eig_vals[1]=EVofInvM_A.getRealEigenvalues()[e2];
                 eig_vals[2]=EVofInvM_A.getRealEigenvalues()[e3];
                 eig_vals[3]=EVofInvM_A.getRealEigenvalues()[e4];
                
                 eigenMat.set(0, 0, EVofInvM_A.getV().get(0, e1)/EVofInvM_A.getV().get(3, e1));
                 eigenMat.set(1, 0, EVofInvM_A.getV().get(1, e1)/EVofInvM_A.getV().get(3, e1));
                 eigenMat.set(2, 0, EVofInvM_A.getV().get(2, e1)/EVofInvM_A.getV().get(3, e1));
                 eigenMat.set(3, 0, EVofInvM_A.getV().get(3, e1)/EVofInvM_A.getV().get(3, e1));

                 eigenMat.set(0, 1, EVofInvM_A.getV().get(0, e2)/EVofInvM_A.getV().get(3, e2));
                 eigenMat.set(1, 1, EVofInvM_A.getV().get(1, e2)/EVofInvM_A.getV().get(3, e2));
                 eigenMat.set(2, 1, EVofInvM_A.getV().get(2, e2)/EVofInvM_A.getV().get(3, e2));
                 eigenMat.set(3, 1, EVofInvM_A.getV().get(3, e2)/EVofInvM_A.getV().get(3, e2));

                 eigenMat.set(0, 2, EVofInvM_A.getV().get(0, e3)/EVofInvM_A.getV().get(3, e3));
                 eigenMat.set(1, 2, EVofInvM_A.getV().get(1, e3)/EVofInvM_A.getV().get(3, e3));
                 eigenMat.set(2, 2, EVofInvM_A.getV().get(2, e3)/EVofInvM_A.getV().get(3, e3));
                 eigenMat.set(3, 2, EVofInvM_A.getV().get(3, e3)/EVofInvM_A.getV().get(3, e3));
                 
                 eigenMat.set(0, 3, EVofInvM_A.getV().get(0, e4)/EVofInvM_A.getV().get(3, e4));
                 eigenMat.set(1, 3, EVofInvM_A.getV().get(1, e4)/EVofInvM_A.getV().get(3, e4));
                 eigenMat.set(2, 3, EVofInvM_A.getV().get(2, e4)/EVofInvM_A.getV().get(3, e4));
                 eigenMat.set(3, 3, EVofInvM_A.getV().get(3, e4)/EVofInvM_A.getV().get(3, e4));
                 break;
         }
         
         
         
         
         this.EigenMasses = new double[numStories1];
         this.ContributionCoefs = new double[numStories1];
         
         for(int i_eig=0; i_eig<numStories1; i_eig++){
             eVec = eigenMat.getMatrix(0, numStories1-1, i_eig, i_eig);
             EigenMasses[i_eig]=eVec.transpose().times(M).times(eVec).get(0, 0);
             ContributionCoefs[i_eig]=eVec.transpose().times(M).times(delta).get(0, 0)/EigenMasses[i_eig];
         }
     }
    
    public double[] getEigenVectoriso(int which){
        double[] vec = new double[this.numDOFS+1];
        vec[0]=this.eigenMat.get(0, which-1);
        vec[1]=this.eigenMat.get(1, which-1);
        if(this.numDOFS>1)vec[2]=this.eigenMat.get(2, which-1);
        if(this.numDOFS>2)vec[3]=this.eigenMat.get(3, which-1);
        return vec;
    }
    
    @Override
    public boolean isIsolated(){
        return this.BaseIsolated;
    }
    
    public double getOmegaB(){
        return this.omegaB;
    }

    @Override
    public double getXLength() {
        return getL()/2.;
    }

    @Override
    public double getYLength() {
        double H=geth1()+geth2()+geth3();
        switch(getNumDOFS()){
            case 1:
               H=geth1();
               break;
            case 2:
               H=geth1()+geth2();
               break;
            case 3:
               H=geth1()+geth2()+geth3();
               break;
        }
        return H;
    }
    
    public Matrix getEigElement(int elemId, double x0, int sit, boolean isoFlag){
        // x0 e [-1,1]
        int numstories1=numDOFS;
        if(isoFlag){numstories1=numDOFS+1;}
        double u1,v1,f1,u2,v2,f2;
        u1=0.;v1=0.;f1=0.;u2=0.;v2=0.;f2=0.;
        double[] vec = new double[24];
        double[] send_vec = new double[4];
        if(sit<=numstories1){
            for(int i=0;i<numstories1;i++){
                send_vec[i]=eigenMat.get(i, sit-1);
            }
        }
        double max=0.;
        for(int i=0;i<numstories1;i++){
            if(Math.abs(send_vec[i])>max){max=Math.abs(send_vec[i]);}
        }
        
        for(int i=0;i<numstories1;i++){
            send_vec[i]=scale*send_vec[i]/max;
        }
        
        for(int i=0;i<vec.length;i++){vec[i]=0.;}
        
        if(isoFlag){
            vec[0]=send_vec[0]; vec[3]=send_vec[0];
            vec[6]=send_vec[1]; vec[9]=send_vec[1];
            vec[12]=send_vec[2]; vec[15]=send_vec[2];
            vec[18]=send_vec[3]; vec[21]=send_vec[3];
        }else{
            vec[6]=send_vec[0]; vec[9]=send_vec[0];
            vec[12]=send_vec[1]; vec[15]=send_vec[1];
            vec[18]=send_vec[2]; vec[21]=send_vec[2];
        }
        
        
        u1=vec[dofs[elemId-1][0]-1];
        v1=vec[dofs[elemId-1][1]-1];
        f1=vec[dofs[elemId-1][2]-1];
        u2=vec[dofs[elemId-1][3]-1];
        v2=vec[dofs[elemId-1][4]-1];
        f2=vec[dofs[elemId-1][5]-1];
        /*if(elemId==1 || elemId==2){
            f2=-(u2-u1)/this.getL();
        }else{
            f1=-(u2-u1)/this.getL();
            f2=f1;
        }*/
        return this.FrameElements[elemId-1].getDef(u1, v1, f1, u2, v2, f2, x0);
    }
}
