/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package core;
import org.nfunk.jep.JEP;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
/**
 *
 * @author pchr
 */
public class FunctionParser {
    String FunctionString;
    JEP jep;
    double totalTime;
    double timestep;
    
    // constructor
    public FunctionParser(){
        //jep = new Jep();
        //jep.getFunctionTable().addFunction("h", new Heaviside());
    }
    
    // methods
    public void setFunction(String FunctionString){
        this.FunctionString=FunctionString;
    }
    
    public void setTime(double TotalTime){
        this.totalTime=TotalTime;
    }
    
    public void setTimeStep(double TotalTime){
        this.timestep=TotalTime;
    }
    
    public double[] getFunctionAnalytic(){
        int steps = (int) Math.round(totalTime/timestep)+1;
        double[] f = new double[steps];
        double t=0.0;
        double result;
        jep = new JEP();
        jep.initFunTab();
        jep.addStandardFunctions();
        jep.addFunction("h", new Heaviside());
        int j=0;
        for(int i=0; i<steps ; i++){
            ++j;
            t=i*timestep;
            try {
                jep.addVariable("t",t);
            } catch (Exception ex) {
                Logger.getLogger(FunctionParser.class.getName()).log(Level.SEVERE, null, ex);
            }
            try {
                jep.parseExpression(FunctionString);
                result = jep.getValue();
                // If the evaluation succeeds, the result will be saved
                f[i]=result;
            } catch (Exception e) {
                // If an exception is thrown while parsing or evaluating
                // information about the error is printed here
                System.out.println("An error occured: " + e.getMessage());
            }
            
        }
        return f;
    }
    
    public double[] getFunctionFromFile(File theFile){
        int steps = (int) Math.round(totalTime/timestep)+1;
        double[] f = new double[steps];
        for(int i=0;i<f.length;i++){f[i]=0.0;}
        try {
            BufferedReader in = new BufferedReader(new FileReader(theFile.getPath()));
            String str;
            int n=0;
            //while ((str = in.readLine()) != null) {
            //    ++n;
            //}
            //in.close();
            //in = new BufferedReader(new FileReader(theFile.getPath()));
            n=0;
            while ((str = in.readLine()) != null) {
                if(n<f.length && isDouble(str) ){f[n]=Double.parseDouble(str);}
                ++n;
            }
            in.close();
        } catch (IOException e) {
        }
        return f;
    }
    
    public boolean isDouble( String input ){
        boolean theb=false;
        try{
            Double.parseDouble( input );
            theb= true;
        }catch(Exception e){
            theb= false;
        }
        return theb;
  }
    
    public double getTimeStep(){return this.timestep;}
    
    public double getTotalTime(){return this.totalTime;}

}
