/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package core;

import Jama.Matrix;

/**
 *
 * @author pchr
 */
public class SDOF extends Structure{
    private double k,m;
    
    public SDOF(){
        this.type=0;
        nElems=1;
        nNodes=2;
        this.FrameElements = new Element[nElems];
        this.FrameNodes = new Node[nNodes];
        this.numDOFS=1;
    }

    @Override
    public void setK() {
        K = new Matrix(1,1);
        K.init();
        K.addVal(0, 0, k);
    }

    @Override
    public void setM() {
        M = new Matrix(1,1);
        M.init();
        M.addVal(0, 0, m);
    }

    @Override
    public void setC(double zeta) {
        C = new Matrix(1,1);
        C.init();
        C.set(0, 0, 2*zeta*m*Math.sqrt(k/m));
    }

    @Override
    public double getXLength() {
        return getYLength()/2.;
    }

    @Override
    public double getYLength() {
        return 1.;
    }

    @Override
    public Matrix getDefElement(int elemId, double x0, int sit, boolean isoFlag) {
        // x0 e [-1,1]
        int numstories1=numDOFS;
        double u1,v1,f1,u2,v2,f2;
        u1=0.;v1=0.;f1=0.;u2=0.;v2=0.;f2=0.;
        double[] vec = new double[6];
        double[] send_vec ;
        send_vec = new double[1];
        
        send_vec[0]=this.disp1[this.step];
        
        double max=this.maxU;
        //for(int i=0;i<3;i++){
        //    if(Math.abs(send_vec[i])>max){max=Math.abs(send_vec[i]);}
        //}
        
        for(int i=0;i<numstories1;i++){
            send_vec[i]=scale*send_vec[i]/max;
        }
        for(int i=0;i<vec.length;i++){vec[i]=0.;}
        
        vec[0]=send_vec[0];
        
        u1=0.0;
        v1=0.0;
        f1=0.0;
        u2=vec[0];
        v2=0.0;
        f2=0.0;
        /*if(elemId==1 || elemId==2){
            f2=-(u2-u1)/this.getL();
        }else{
            f1=-(u2-u1)/this.getL();
            f2=f1;
        }*/
        return this.FrameElements[elemId-1].getDef(u1, v1, f1, u2, v2, f2, x0);
    }

    @Override
    public Matrix getEigElement(int elemId, double x0, int sit, boolean isoFlag) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    
    @Override
    public void setGeometry(double[] data ){
        k=data[0]; m=data[1];
    }
    
    @Override
    public double getEigPeriod(int which){
        double ep=0.;
        ep=2.*Math.PI/Math.sqrt(k/m);
        return ep;
    }
}
