/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package core;

import Jama.EigenvalueDecomposition;
import Jama.Matrix;
import java.util.HashMap;
import java.util.Map;

/**
 *
 * @author pchr
 */
abstract public class Structure {
    protected int type; // 0 for sdof, 1 for frame, 2 for storey
    private double[] Sa;
    protected int[][] dofs;
    protected Matrix K;
    protected Matrix M;
    protected Matrix C;
    protected int numDOFS;
    protected double[] eig_vals;
    protected Matrix eigenMat;
    protected double[] ContributionCoefs;
    
    protected EigenvalueDecomposition EVofInvM_A ;
    
    protected double[] EigenMasses;
    protected  int nElems;
    protected  int nNodes;
    protected Element[] FrameElements;
    protected Node[] FrameNodes;
    protected Map<Integer,StoreyElement> StoreyElements = new HashMap<Integer,StoreyElement>();
    
    protected double scale=1.00;
    protected int step=0;
    
    protected double[] disp0;
    protected double[] disp1;
    protected double[] disp2;
    protected double[] disp3;
    protected double maxU=0.;
    
    public int getType(){
        return type;
    }
    
    public Matrix getC(){
        return this.C;
    }
    
    public Matrix getK(){
        return this.K;
    }
    
    public Matrix getM(){
        return this.M;
    }
    
    public void EigenRun(){
        Matrix eVec = new Matrix(numDOFS,1);
        Matrix unit_vec = new Matrix(numDOFS,1);
        unit_vec.init();
        switch(numDOFS){
            case 1:
                unit_vec.set(0, 0, 1.);
                break;
            case 2:
                unit_vec.set(0, 0, 1.);
                unit_vec.set(1, 0, 1.);
                break;
            case 3:
                unit_vec.set(0, 0, 1.);
                unit_vec.set(1, 0, 1.);
                unit_vec.set(2, 0, 1.);
                break;
        }
        
         K=K.inverse();
         M=K.times(M);  
         this.EVofInvM_A = new EigenvalueDecomposition(M);
         eig_vals = new double[numDOFS];
         eigenMat = new Matrix(numDOFS,numDOFS);
         this.setK();
         this.setM();
         for(int i=0;i<numDOFS;i++){
             eig_vals[i]=EVofInvM_A.getRealEigenvalues()[i];
             for(int j=0;j<numDOFS;j++){
                 eigenMat.set(j, i, EVofInvM_A.getV().get(0, i));
             }
         }
         //eig_vals=EVofInvM_A.getRealEigenvalues();
         //eigenMat=EVofInvM_A.getV();
         // SORT
         int e1,e2,e3;
         double max=eig_vals[0];
         e1=0;e2=0;e3=0;
         for(int i=0;i<numDOFS;i++){
             if(eig_vals[i]>max){max=eig_vals[i]; e1=i;}
         }
         
         switch(this.numDOFS){
            case 1:
                eig_vals[0]=EVofInvM_A.getRealEigenvalues()[e1];
                eigenMat.set(0, 0, EVofInvM_A.getV().get(0, e1)/EVofInvM_A.getV().get(0, e1));
                break;
             case 2:
                if(e1==0){
                     e2=1;
                 }
                 if(e1==1){
                     e2=0;
                 }
                 eig_vals[0]=EVofInvM_A.getRealEigenvalues()[e1];
                 eig_vals[1]=EVofInvM_A.getRealEigenvalues()[e2];

                 eigenMat.set(0, 0, EVofInvM_A.getV().get(0, e1)/EVofInvM_A.getV().get(1, e1));
                 eigenMat.set(1, 0, EVofInvM_A.getV().get(1, e1)/EVofInvM_A.getV().get(1, e1));

                 eigenMat.set(0, 1, EVofInvM_A.getV().get(0, e2)/EVofInvM_A.getV().get(1, e2));
                 eigenMat.set(1, 1, EVofInvM_A.getV().get(1, e2)/EVofInvM_A.getV().get(1, e2));
                 break;
            case 3:
                if(e1==0){
                     if(eig_vals[1]>eig_vals[2]){e2=1;e3=2;}
                     if(eig_vals[2]>eig_vals[1]){e2=2;e3=1;}
                 }
                 if(e1==1){
                     if(eig_vals[0]>eig_vals[2]){e2=0;e3=2;}
                     if(eig_vals[2]>eig_vals[0]){e2=2;e3=0;}
                 }
                 if(e1==2){
                     if(eig_vals[0]>eig_vals[1]){e2=0;e3=1;}
                     if(eig_vals[1]>eig_vals[0]){e2=1;e3=0;}
                 }
                 eig_vals[0]=EVofInvM_A.getRealEigenvalues()[e1];
                 eig_vals[1]=EVofInvM_A.getRealEigenvalues()[e2];
                 eig_vals[2]=EVofInvM_A.getRealEigenvalues()[e3];

                 eigenMat.set(0, 0, EVofInvM_A.getV().get(0, e1)/EVofInvM_A.getV().get(2, e1));
                 eigenMat.set(1, 0, EVofInvM_A.getV().get(1, e1)/EVofInvM_A.getV().get(2, e1));
                 eigenMat.set(2, 0, EVofInvM_A.getV().get(2, e1)/EVofInvM_A.getV().get(2, e1));

                 eigenMat.set(0, 1, EVofInvM_A.getV().get(0, e2)/EVofInvM_A.getV().get(2, e2));
                 eigenMat.set(1, 1, EVofInvM_A.getV().get(1, e2)/EVofInvM_A.getV().get(2, e2));
                 eigenMat.set(2, 1, EVofInvM_A.getV().get(2, e2)/EVofInvM_A.getV().get(2, e2));

                 eigenMat.set(0, 2, EVofInvM_A.getV().get(0, e3)/EVofInvM_A.getV().get(2, e3));
                 eigenMat.set(1, 2, EVofInvM_A.getV().get(1, e3)/EVofInvM_A.getV().get(2, e3));
                 eigenMat.set(2, 2, EVofInvM_A.getV().get(2, e3)/EVofInvM_A.getV().get(2, e3));
                 break;
         }
         
         this.EigenMasses = new double[numDOFS];
         this.ContributionCoefs = new double[numDOFS];
         
         for(int i_eig=0; i_eig<numDOFS; i_eig++){
             eVec = eigenMat.getMatrix(0, numDOFS-1, i_eig, i_eig);
             EigenMasses[i_eig]=eVec.transpose().times(M).times(eVec).get(0, 0);
             ContributionCoefs[i_eig]=eVec.transpose().times(M).times(unit_vec).get(0, 0)/EigenMasses[i_eig];
         }
     }
    
    public void addElement(int wElem, Element anElement){
        this.FrameElements[wElem-1]=anElement;
    }
    
    public void addNode(int wNode, Node aNode){
        this.FrameNodes[wNode-1]=aNode;
    }
    
    public Element getElement(int wElem){
        return this.FrameElements[wElem-1];
    }
    
    public Element[] getElements(){
        return this.FrameElements;
    }
    
    public Node getNode(int wNode){
        return this.FrameNodes[wNode-1];
    }
    
    public Node[] getNodes(){
        return this.FrameNodes;
    }
    
    public double getEigPeriod(int which){
        double ep=0.;
        if(eig_vals!=null){
            ep=1./eig_vals[which-1];
            ep=Math.sqrt(ep);
            ep=2.*Math.PI/ep;
        }
        return ep;
    }
    
    public void setStep(int step){
        this.step=step;
    }
    
    public double getEigMass(int which){
        double ep=0.;
        ep=this.EigenMasses[which-1];
        return ep;
    }
    
    public double getEigContribution(int which){
        double ep=0.;
        ep=this.ContributionCoefs[which-1];
        return ep;
    }
    
    public double getScale(){
        return this.scale;
    }
    
    public void setScale(double scale){
        this.scale=scale;
    }
    
    public double[] getEigenValues(){
        //eigenMat.print(12, 6);
        return this.eig_vals;
    }
    
    public int getNumDOFS(){
        return this.numDOFS;
    }
    
    public double[] getEigenVector(int which){
        double[] vec = new double[this.numDOFS];
        vec[0]=this.eigenMat.get(0, which-1);
        if(this.numDOFS>1)vec[1]=this.eigenMat.get(1, which-1);
        if(this.numDOFS>2)vec[2]=this.eigenMat.get(2, which-1);
        return vec;
    }
    
    public void setSa(double[] vals){
        Sa = new double[vals.length];
        for(int i=0;i<Sa.length;i++){this.Sa[i]=vals[i];}
    }
    
    public double getSa(int which){
        double val;
        val=Sa[which-1];
        return val;
    }
    
    public double getSd(int which){
        double val;
        val=Sa[which-1]/((2.*Math.PI/getEigPeriod(which))*(2.*Math.PI/getEigPeriod(which)));
        return val;
    }
    
    public double getSv(int which){
        double val;
        val=Sa[which-1]/((2.*Math.PI/getEigPeriod(which)));
        return val;
    }
    
    public void clearElements(){
        this.StoreyElements.clear();
        new StoreyElement().clear(); 
    }
    
    
    
    public void putStElement(StoreyElement anElement){
        this.StoreyElements.put(anElement.getId(), anElement);
    }
    
    public void putStElements(Map<Integer,StoreyElement> theElements){
        this.StoreyElements=theElements;
    }
    
    public Map getStElements(){
        return this.StoreyElements;
    }
    
    public void clearStElements(){
        this.StoreyElements.clear();
        new StoreyElement().clear(); 
    }
    
    public StoreyElement getStElement(int id){
        return this.StoreyElements.get(id);
    }
    
    public int getSizeStElems(){
        int s=this.StoreyElements.size();
        return s;
    }
    
    abstract public void setK();
    abstract public void setM();
    abstract public void setC(double zeta);
    
    abstract public double getXLength();
    abstract public double getYLength();
    
    abstract public Matrix getDefElement(int elemId, double x0, int sit, boolean isoFlag);
    abstract public Matrix getEigElement(int elemId, double x0, int sit, boolean isoFlag);
    
    abstract public void setGeometry(double[] data );
    
    public boolean isIsolated(){
        return false;
    }
    
    public void setDisp0(double[] d){
        this.disp0=d;
    }
    
    public void setDisp1(double[] d){
        this.disp1=d;
    }
    
    public void setDisp2(double[] d){
        this.disp2=d;
    }
    
    public void setDisp3(double[] d){
        this.disp3=d;
    }
    
    public void setMax(){
        double max=0.;
        //for(int i=0;i<3;i++){
        //    if(Math.abs(send_vec[i])>max){max=Math.abs(send_vec[i]);}
        //}
        for(int i=0;i<disp0.length;i++){
            if(Math.abs(disp0[i])>max){max=Math.abs(disp0[i]);}
        }
        for(int i=0;i<disp1.length;i++){
            if(Math.abs(disp1[i])>max){max=Math.abs(disp1[i]);}
        }
        for(int i=0;i<disp2.length;i++){
            if(Math.abs(disp2[i])>max){max=Math.abs(disp2[i]);}
        }
        for(int i=0;i<disp3.length;i++){
            if(Math.abs(disp3[i])>max){max=Math.abs(disp3[i]);}
        }
        this.maxU=max;
    }
    
    public double getDisp1(int wtime){
        return this.disp1[wtime]*scale/this.maxU;
    }
    
    public double getDisp2(int wtime){
        return this.disp2[wtime]*scale/this.maxU;
    }
    
    public double getDisp3(int wtime){
        return this.disp3[wtime]*scale/this.maxU;
    }
}
