/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package gui;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.geom.AffineTransform;
import java.awt.geom.Point2D;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.nio.file.Path;
import java.text.DecimalFormat;
import java.text.DecimalFormatSymbols;
import javax.imageio.ImageIO;
import javax.swing.JFileChooser;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPopupMenu;

import java.util.Locale;
import java.util.ResourceBundle;

/**
 *
 * @author pchr
 */
public class DrawPanelGraph extends DrawPanel{
    private int xm,ym;
    private int x0,y0;
    private AffineTransform at;
    private double xscale,yscale;
    private MainGUI toFrame;
    private double[] xvar;
    private double[] yvar;
    int xind;
    int yind;
    private boolean isRespAnalysed;
    private boolean isSpecAnalysed;
    
    public int wstep=0;
    public int NumSteps=0;
    public double timeStep=0.;
    public JPopupMenu popup;
    TextTransfer theTextTr = new TextTransfer();
    private File outFile;
    final JFileChooser fc = new JFileChooser();
    
    String lang="en";
    Locale local;
    ResourceBundle resb; 
    
    
    public DrawPanelGraph() {
        super();
        local=new Locale(lang);
        resb = ResourceBundle.getBundle("misc.bundle", local);
        isRespAnalysed=false;
        isSpecAnalysed=false;
        popup = new JPopupMenu();
        final String theName=resb.getString("name_000");
        final String theName2=resb.getString("name_001");
        final String theName3=resb.getString("name_002");
        
        ActionListener menuListener = new ActionListener() {
            public void actionPerformed(ActionEvent event) {
                if(event.getActionCommand().equals(theName)){
                    saveFileSelection();
                }
                if(event.getActionCommand().equals(theName2)){
                    saveImageSelection();
                }
                if(event.getActionCommand().equals(theName3)){
                    copySelection();
                }
            }
        };
        
        
        JMenuItem item= new JMenuItem(theName);
        popup.add(item);
        JMenuItem item2= new JMenuItem(theName2);
        popup.add(item2);
        JMenuItem item3= new JMenuItem(theName3);
        popup.add(item3);
        item.addActionListener(menuListener);
        item2.addActionListener(menuListener);
        item3.addActionListener(menuListener);
        addMouseListener(new MousePopupListener());
    }
    
    // An inner class to check whether mouse events are the popup trigger
    class MousePopupListener extends MouseAdapter {
        public void mousePressed(MouseEvent e) {
            checkPopup(e);
        }
        
        public void mouseClicked(MouseEvent e) {
            checkPopup(e);
        }
        
        public void mouseReleased(MouseEvent e) {
            checkPopup(e);
        }
        
        private void checkPopup(MouseEvent e) {
            if (e.isPopupTrigger()) {
                popup.show(DrawPanelGraph.this, e.getX(), e.getY());
            }
        }
    }
    
    @Override
    public void paintComponent(Graphics g) {
        // Define graphics
        Graphics2D g2 = (Graphics2D) g;
        // Get dimensions
	//g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
        int width  = this.getWidth();
	int height = this.getHeight();
	// Clear window
	g2.setBackground(Color.WHITE);
	g2.clearRect(0, 0, width, height);
        
        xm=width/2;
        xs=width/20;
        xe=width-width/20;
        ym=height/2;
        ys=height/20;
        ye=height-height/20;
        
        if(this.isRespAnalysed || this.isSpecAnalysed){
            int stories;
            xind=toFrame.getXindex();
            yind=toFrame.getYindex();
            boolean invalid=false;
            if(toFrame.RespPlotSelected()){
                if(toFrame.NullStructure()){
                    invalid=true;
                }else{
                    stories=this.toFrame.getNumStories();
                    if(stories<3){
                        if(xind==4||xind==8||xind==12||xind==16||xind==20)invalid=true;
                        if(yind==4||yind==8||yind==12||yind==16||yind==20)invalid=true;
                    }
                    if(stories<2){
                        if(xind==3||xind==7||xind==11||xind==15||xind==19)invalid=true;
                        if(yind==3||yind==7||yind==11||yind==15||yind==19)invalid=true;
                    }
                    if( this.toFrame.isIsolated()==false )
                    {
                        if(xind==1||xind==5||xind==9||xind==13||xind==17)invalid=true;
                    }
                }
            }
            if(toFrame.SpecPlotSelected()){
                if(toFrame.NullSpecCalc()&&toFrame.NullGroundCalc())invalid=true;
                if( xind==0 & yind>0 && !toFrame.NullSpecCalc())invalid=true;
                if( xind==1 & yind<1 && !toFrame.NullSpecCalc())invalid=true;
            }
            if(!invalid){
                if(toFrame.RespPlotSelected()){
                    xvar=toFrame.getHistory(xind);
                    yvar=toFrame.getHistory(yind);
                }else{
                    xvar=toFrame.getHistoryX(xind);
                    yvar=toFrame.getHistoryY(yind);
                }

                double minx=this.getMin(xvar);
                double miny=this.getMin(yvar);
                double maxx=this.getMax(xvar);
                double maxy=this.getMax(yvar);

    //========================================
                if(toFrame.RespPlotSelected()){
                    this.xscale=Math.abs(xs-xe)/(Math.abs(maxx-minx));
                    this.yscale=Math.abs(ys-ye)/(Math.abs(maxy-miny));
                    x0=(int) (xe-maxx*(xs-xe)/(minx-maxx));
                    y0=(int) (ys-maxy*(ye-ys)/(miny-maxy));
                    at = new AffineTransform();
                    at.translate(x0, y0);
                    at.rotate(Math.PI);
                    at.scale(xscale, yscale);
//                     if(xind!=0 && yind!=0){
//                        this.yscale=Math.min(Math.abs(ys-ye)/(2.0*Math.abs(maxy)),Math.abs(ys-ye)/(2.0*Math.abs(miny)));
//                        this.xscale=Math.min(Math.abs(xs-xe)/(2.0*Math.abs(maxx)),Math.abs(xs-xe)/(2.0*Math.abs(minx)));
//                        at = new AffineTransform();
//                        at.translate(xm, ym);
//                        at.rotate(Math.PI);
//                        at.scale(xscale, yscale);                
//                    }else if(xind==0 && yind!=0){
//                        this.yscale=Math.min(Math.abs(ys-ye)/(2.0*Math.abs(maxy)),Math.abs(ys-ye)/(2.0*Math.abs(miny)));
//                        this.xscale=Math.abs(xs-xe)/(Math.abs(maxx-minx));
//                        at = new AffineTransform();
//                        at.translate(xs, ym);
//                        at.rotate(Math.PI);
//                        at.scale(xscale, yscale); 
//                    }else if(xind!=0 && yind==0){
//                        this.yscale=Math.abs(ys-ye)/(Math.abs(maxy-miny));
//                        this.xscale=Math.min(Math.abs(xs-xe)/(2.0*Math.abs(maxx)),Math.abs(xs-xe)/(2.0*Math.abs(minx)));
//                        at = new AffineTransform();
//                        at.translate(xm, ym);
//                        at.rotate(Math.PI);
//                        at.scale(xscale, yscale);
//                    }else if(xind==0 && yind==0){
//                        this.yscale=Math.abs(ys-ye)/(Math.abs(maxy-miny));
//                        this.xscale=Math.abs(xs-xe)/(Math.abs(maxx-minx));
//                        at = new AffineTransform();
//                        at.translate(xs, ye);
//                        at.rotate(Math.PI);
//                        at.scale(xscale, yscale);                
//                    }
                }else{
                    this.xscale=Math.abs(xs-xe)/(Math.abs(maxx-minx));
                    this.yscale=Math.abs(ys-ye)/(Math.abs(maxy-miny));
                    x0=(int) (xe-maxx*(xs-xe)/(minx-maxx));
                    y0=(int) (ys-maxy*(ye-ys)/(miny-maxy));
                    at = new AffineTransform();
                    at.translate(x0, y0);
                    at.rotate(Math.PI);
                    at.scale(xscale, yscale);
//                    if(xind==0){
//                        this.yscale=Math.min(Math.abs(ys-ye)/(2*Math.abs(maxy)),Math.abs(ys-ye)/(2*Math.abs(miny)));
//                        this.xscale=Math.abs(xs-xe)/(Math.abs(maxx-minx));
//                        at = new AffineTransform();
//                        at.translate(xs, ym);
//                        at.rotate(Math.PI);
//                        at.scale(xscale, yscale);                
//                    }else{
////                        this.yscale=Math.min(Math.abs(ys-ye)/(2*Math.abs(maxy)),Math.abs(ys-ye)/(2*Math.abs(miny)));
////                        this.xscale=Math.min(Math.abs(xs-xe)/(2*Math.abs(maxx)),Math.abs(xs-xe)/(2*Math.abs(minx)));
//                        this.yscale=Math.abs(ys-ye)/(Math.abs(maxy-miny));
//                        this.xscale=Math.abs(xs-xe)/(Math.abs(maxx-minx));
//                        at = new AffineTransform();
//                        at.translate(xe, ye);
//                        at.rotate(Math.PI);
//                        at.scale(xscale, yscale); 
//                    }
                }
//========================================
                g2.drawLine(xs, ye, xe, ye);
                g2.drawLine(xs, ye, xs, ys);
                //g2.drawLine(xe, ye, xe-Math.abs(xe-xs)/100, ye+Math.abs(xe-xs)/100);
                //g2.drawLine(xe, ye, xe-Math.abs(xe-xs)/100, ye-Math.abs(xe-xs)/100);
                g2.drawString(toFrame.getXparameter(), xe-8*toFrame.getXparameter().length(), ye+Math.abs(ye-ys)/40);
                //g2.drawLine(xs, ys, xs-Math.abs(xe-xs)/100, ys+Math.abs(xe-xs)/100);
                //g2.drawLine(xs, ys, xs+Math.abs(xe-xs)/100, ys+Math.abs(xe-xs)/100);
                g2.drawString(toFrame.getΥparameter(), xs-Math.abs(xe-xs)/20, ys-Math.abs(ye-ys)/40);

                int grstep=100;
                int count=0;
                DecimalFormatSymbols comma =new DecimalFormatSymbols();
                comma.setDecimalSeparator('.');
                DecimalFormat Places = new DecimalFormat("0.000E0",comma);
                String sd;
                g2.setColor(Color.RED);
                sd=Places.format(miny);
                g2.drawString(sd, 0, ye);
                sd=Places.format(minx);
                g2.drawString(sd, xs, height);
                for(int i=1;i<=grstep;i++){
                    ++count;
                    if (count==grstep/10){
                       g2.setColor(Color.RED);
                       sd=Places.format(miny+i*Math.abs(maxy-miny)/grstep);
                       g2.drawString(sd, 0, ye-i*Math.abs(ye-ys)/grstep);
                       sd=Places.format(minx+i*Math.abs(maxx-minx)/grstep);
                       g2.drawString(sd, xs+i*Math.abs(xe-xs)/grstep, height);
                       g2.setColor(Color.DARK_GRAY);
                       count=0;
                    }else{g2.setColor(Color.LIGHT_GRAY);}
                    g2.drawLine(xs+i*Math.abs(xe-xs)/grstep, ye, xs+i*Math.abs(xe-xs)/grstep, ys);
                    g2.drawLine(xs, ye-i*Math.abs(ye-ys)/grstep, xe, ye-i*Math.abs(ye-ys)/grstep);
                }

                int x1,x2,y1,y2;
                Point2D.Double pointb,pointa;
//                System.out.println("----------------------------");
                for(int i=0;i<xvar.length-1;i++){
                    pointa = new Point2D.Double();
                    pointb = new Point2D.Double(xvar[i],yvar[i]);
                    at.transform(pointb, pointa);

                    x1=(int) pointa.getX(); x1=mirrorX(x1);
                    y1=(int) pointa.getY(); 

                    pointb = new Point2D.Double(xvar[i+1],yvar[i+1]);
                    at.transform(pointb, pointa);

                    x2=(int) pointa.getX(); x2=mirrorX(x2);
                    y2=(int) pointa.getY();

                    g2.setColor(Color.BLUE);
                    g2.drawLine(x1, y1, x2, y2);
//                    System.out.println(x1+" "+ y1+" "+  x2+" "+ y2);
                }
                // motion
                pointa = new Point2D.Double();
                pointb = new Point2D.Double(xvar[wstep],yvar[wstep]);
                at.transform(pointb, pointa);

                x1=(int) pointa.getX(); x1=mirrorX(x1);
                y1=(int) pointa.getY();
                g2.setColor(Color.GREEN);
                //g2.drawOval(x1, y1, 20, 20);
                if(toFrame.RespPlotSelected())g2.fillOval(x1-width/100, y1-height/100, width/50, height/50);
                // end motion
                g2.setColor(Color.BLACK);
            }else{
                g2.drawLine(xs, ym, xe, ym);
                g2.drawLine(xs, ys, xs, ye);
                g2.drawLine(xe, ym, xe-Math.abs(xe-xs)/100, ym+Math.abs(xe-xs)/100);
                g2.drawLine(xe, ym, xe-Math.abs(xe-xs)/100, ym-Math.abs(xe-xs)/100);
                g2.drawString(toFrame.getXparameter(), xe-8*toFrame.getXparameter().length(), ye+Math.abs(ye-ys)/40);
                g2.drawLine(xs, ys, xs-Math.abs(xe-xs)/100, ys+Math.abs(xe-xs)/100);
                g2.drawLine(xs, ys, xs+Math.abs(xe-xs)/100, ys+Math.abs(xe-xs)/100);
                g2.drawString(toFrame.getΥparameter(), xs-Math.abs(xe-xs)/20, ys-Math.abs(ye-ys)/40);
            }
        }else{
            g2.drawLine(xs, ym, xe, ym);
            g2.drawLine(xs, ys, xs, ye);
            g2.drawLine(xe, ym, xe-Math.abs(xe-xs)/100, ym+Math.abs(xe-xs)/100);
            g2.drawLine(xe, ym, xe-Math.abs(xe-xs)/100, ym-Math.abs(xe-xs)/100);
            g2.drawString("X-PARAMETER", xe-8*"X-PARAMETER".length(), ym+Math.abs(ye-ys)/20);
            g2.drawLine(xs, ys, xs-Math.abs(xe-xs)/100, ys+Math.abs(xe-xs)/100);
            g2.drawLine(xs, ys, xs+Math.abs(xe-xs)/100, ys+Math.abs(xe-xs)/100);
            g2.drawString("Y-PARAMETER", xs+Math.abs(xe-xs)/60, ys+10);
        }
        
    }
    
    public void setRespAnalysed(boolean theBool){
        this.isRespAnalysed=theBool;
    }
    
    public void setSpecAnalysed(boolean theBool){
        this.isSpecAnalysed=theBool;
    }
    public double getMin(double[] vals){
        double min=vals[0];
        for(int i=0;i<vals.length;i++){
            if(min>vals[i]){min=vals[i];}
        }
        if(Math.abs(min)<1.e-16)min=Math.signum(min)*1.e-16;
        return min;
    }
    
    public double getMax(double[] vals){
        double max=vals[0];
        for(int i=0;i<vals.length;i++){
            if(max<vals[i]){max=vals[i];}
        }
        if(Math.abs(max)<1.e-16)max=Math.signum(max)*1.e-16;
        return max;
    }
    
    public void setFrame(MainGUI toFrame){
        this.toFrame=toFrame;
        this.resb=toFrame.getResourceBundle();
    }
    
    private int mirrorX(int x){
        int mir=0;
//        if(xind!=0){mir=2*xm-x;}else if(xind==0 && yind!=0){mir=2*xs-x;}else if(xind==0 && yind==0){mir=2*xs-x;}
        mir=2*x0-x;
        return mir;
    }
    
    public void setNumStep(int s){
        NumSteps=s;
    }
    
    public void setTimeStep(double s){
        timeStep=s;
    }
    
    public void setWhichStep(int w){
        this.wstep=w;
    }
    
    private void copySelection(){
        StringBuilder selected = new StringBuilder();
        for(int i=0;i<xvar.length;i++){
            selected.append(xvar[i]);
            selected.append(" ");
            selected.append(yvar[i]);
            selected.append('\n');
        }
        theTextTr.setClipboardContents(selected.toString());
    }
    
    private void saveFileSelection(){
        System.out.println("inside");
        int action = fc.showSaveDialog(this);
        if (action != JFileChooser.APPROVE_OPTION) {
            // User has canceled, or an error occurred.
            return;
        }
        outFile = fc.getSelectedFile();
        if (outFile.exists()) {
            // If file already exists, ask before replacing it.
            action = JOptionPane.showConfirmDialog(this,
                    "Replace existing file?");
            if (action != JOptionPane.YES_OPTION)
                return;
        }
        try {
            // Create a PrintWriter for writing to the specified
            // file and write the text from the window to that stream.
            PrintWriter out = new PrintWriter(new FileWriter(outFile));
            //String contents = text.getText();
            for(int i=0;i<xvar.length;i++){
                out.append(Double.toString(xvar[i]));
                out.append(" ");
                out.append(Double.toString(yvar[i]));
                out.append('\n');
            }
            //out.print(contents);
            if (out.checkError())
                throw new IOException("Error while writing to file.");
            out.close();
        }catch (IOException e) {
            // Some error has occurred while trying to write.
            // Show an error message
            JOptionPane.showMessageDialog(this,
                    "Sorry, an error has occurred:\n" + e.getMessage());
        }
    }
    
    private void saveImageSelection(){
//        from http://stackoverflow.com/questions/15565328/save-jpanel-into-jpg-png-image
        BufferedImage image = new BufferedImage(this.getWidth(), this.getHeight(), BufferedImage.TYPE_INT_RGB);
        Graphics2D graphics2D = image.createGraphics();
        
        this.paint(graphics2D);
        jFile.showSaveDialog(this);
        Path pth = null;
        if(jFile.getSelectedFile()==null) {
        } else {
            pth = jFile.getSelectedFile().toPath();
            JOptionPane.showMessageDialog(null, pth.toString());
            try {
                ImageIO.write(image, "png", new File(pth.toString()));
            } catch (IOException ox) {
                // TODO: handle exception
                ox.printStackTrace();
            }
        }
    }
}
