/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package gui;

import core.Element;
import core.Node;
import gui.DrawPanelGraph.MousePopupListener;
import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.nio.file.Path;
import java.text.DecimalFormat;
import java.text.DecimalFormatSymbols;
import java.util.Iterator;
import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.imageio.ImageIO;
import javax.swing.JFileChooser;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPopupMenu;

/**
 *
 * @author pchr
 */
public class DrawPanelInput extends DrawPanel implements Runnable{
    private boolean def=false;
    private int sit=1;
    //private RunInfo theRunInfo;
    private DrawPanelGraph seeGraph;
    
    public Thread runner;
    public long Dt=1;
    public long Dts=1;
    public boolean init=false;
    public int wstep=0;
    public int NumSteps=0;
    public double timeStep=0.;
    
    private boolean forIsolation=false;
    public JPopupMenu popup;

    public DrawPanelInput() {
        super();
        popup = new JPopupMenu();
        final String theName2="save picture";
        ActionListener menuListener = new ActionListener() {
            public void actionPerformed(ActionEvent event) {
                if(event.getActionCommand().equals(theName2)){
                    saveImageSelection();
                }
            }
        };
        
        JMenuItem item;
        popup.add(item = new JMenuItem(theName2));
        item.addActionListener(menuListener);
        addMouseListener(new MousePopupListener());
    }
    
    // An inner class to check whether mouse events are the popup trigger
    class MousePopupListener extends MouseAdapter {
        public void mousePressed(MouseEvent e) {
            checkPopup(e);
        }
        
        public void mouseClicked(MouseEvent e) {
            checkPopup(e);
        }
        
        public void mouseReleased(MouseEvent e) {
            checkPopup(e);
        }
        
        private void checkPopup(MouseEvent e) {
            if (e.isPopupTrigger()) {
                popup.show(DrawPanelInput.this, e.getX(), e.getY());
            }
        }
    }
    
   public void setSeeGraph(DrawPanelGraph seeGraph){
        this.seeGraph=seeGraph;
    }
    
    public void start(){
        runner = new Thread(this);
        runner.start();
    }
    
    public void stop(){
        runner=null;
    }
    
    
    @Override
    public void paintComponent(Graphics g) {
        //System.out.println("paintComponent");
	// Define graphics
        Graphics2D g2 = (Graphics2D) g;
        // Get dimensions
        int width  = this.getWidth();
        int height = this.getHeight();
        // Clear window
        g2.setBackground(Color.WHITE);
        g2.clearRect(0, 0, width, height);
        xs=width/10;
        xe=width-width/10;
        ye=height/10;
        ys=height-height/10;
        g2.setColor(Color.GRAY);
        g2.setStroke(new BasicStroke(1));
        if(init){
            if(wstep!=NumSteps-1){wstep++;}else{wstep=0;}
            switch(theStructure.getType()){
                case 1: drawElements(g2); drawNodes(g2); drawDefElements(g2); break;
                case 0: drawSDOF(g2); drawDefSDOF(g2);break;
                case 2: drawStElements(g2);drawDefStElements(g2);
                break;
            }
        }else{
            if(this.theStructure!=null){
                switch(theStructure.getType()){
                    case 1: drawElements(g2); this.drawNodes(g2); 
                    if(def){this.drawEigElements(g2);} 
                    break;
                    case 0: drawSDOF(g2); break;
                    case 2: drawStElements(g2); if(def){this.drawEigStElements(g2);} 
                    break;
                }
            }
        }
    }
    
    public void drawElements(Graphics2D g2){
        int x1,x2,y1,y2;
        Element[] theElements  = this.theStructure.getElements();
        for(int i=0; i<theElements.length; i++){
            Element theElement = theElements[i];
            x1=this.xTransformation(theElement.getN1().getX());
            x2=this.xTransformation(theElement.getN2().getX());
            y1=this.yTransformation(theElement.getN1().getY());
            y2=this.yTransformation(theElement.getN2().getY());

            g2.setColor(Color.BLUE);
            g2.setStroke(new BasicStroke(1));
            g2.drawLine(x1, y1, x2, y2);
            g2.setStroke(new BasicStroke(1));
            int elid=theElement.getId();
            int storey=0;
            if(elid==3 || elid==6 || elid==9){
                if(elid==3)storey=1;if(elid==6)storey=2;if(elid==9)storey=3;
                g2.drawString(Integer.toString(storey), (x1+x2)/2-15, (y1+y2)/2-15);
            }
        }
    }
    
    public void drawEigElements(Graphics2D g2){
        int x1,x2,y1,y2;
        double x0,x01;
        int split=1;
        //Element[] theElements  = this.theStructure.getElements();
        for(int i=0; i<this.theStructure.getElements().length; i++){
            g2.setColor(Color.RED);
            g2.setStroke(new BasicStroke(1));
            //Element theElement = theElements[i];
            
            x1=this.xTransformation(this.theStructure.getEigElement(i+1, -1., sit,forIsolation).get(0, 0));
            y1=this.yTransformation(this.theStructure.getEigElement(i+1, -1., sit,forIsolation).get(1, 0));
            x0= -1.+ (double)1*2./split;
            x2=this.xTransformation(this.theStructure.getEigElement(i+1, x0, sit,forIsolation).get(0, 0));
            y2=this.yTransformation(this.theStructure.getEigElement(i+1, x0, sit,forIsolation).get(1, 0));
            g2.drawLine(x1, y1, x2, y2);
            if(split>2){
                for(int j=1; j<split-1; j++){
                    x0= -1.+ (double)j*2./split;
                    x01= -1.+ (double)(j+1)*2./split;
                    x1=this.xTransformation(this.theStructure.getEigElement(i+1, x01, sit,forIsolation).get(0, 0));
                    y1=this.yTransformation(this.theStructure.getEigElement(i+1, x01, sit,forIsolation).get(1, 0));
                    x2=this.xTransformation(this.theStructure.getEigElement(i+1, x0, sit,forIsolation).get(0, 0));
                    y2=this.yTransformation(this.theStructure.getEigElement(i+1, x0, sit,forIsolation).get(1, 0));
                    g2.drawLine(x1, y1, x2, y2);
                }
            }
            x0= -1.+ (double)(split-1)*2./split;
            x1=this.xTransformation(this.theStructure.getEigElement(i+1, x0, sit,forIsolation).get(0, 0));
            y1=this.yTransformation(this.theStructure.getEigElement(i+1, x0, sit,forIsolation).get(1, 0));
            x2=this.xTransformation(this.theStructure.getEigElement(i+1, 1., sit,forIsolation).get(0, 0));
            y2=this.yTransformation(this.theStructure.getEigElement(i+1, 1., sit,forIsolation).get(1, 0));
            g2.drawLine(x1, y1, x2, y2);
            
            ///////////////////////////////////
            if(theStructure.isIsolated()){
                g2.setColor(Color.RED);
                Element theElement  = this.theStructure.getElement(1);
                x1=this.xTransformation(theElement.getN1().getX());
                y1=this.yTransformation(theElement.getN1().getY());
            
                x2=this.xTransformation(this.theStructure.getEigElement(1, -1., sit,theStructure.isIsolated()).get(0, 0));
                y2=this.yTransformation(this.theStructure.getEigElement(1, -1., sit,theStructure.isIsolated()).get(1, 0));
                g2.drawLine(x1, y1, x2, y2);
                
                theElement  = this.theStructure.getElement(2);
                x1=this.xTransformation(theElement.getN1().getX());
                y1=this.yTransformation(theElement.getN1().getY());
            
                x2=this.xTransformation(this.theStructure.getEigElement(2, -1., sit,theStructure.isIsolated()).get(0, 0));
                y2=this.yTransformation(this.theStructure.getEigElement(2, -1., sit,theStructure.isIsolated()).get(1, 0));
                g2.drawLine(x1, y1, x2, y2);
            }
            ///////////////////////////////////
            
            g2.setColor(Color.BLACK);
            DecimalFormatSymbols comma =new DecimalFormatSymbols();
            comma.setDecimalSeparator('.');
            DecimalFormat Places = new DecimalFormat("0.000",comma);
            String sd1,sd2;
            sd1=Places.format(theStructure.getEigPeriod(sit));
            sd2=Places.format(2.*Math.PI/theStructure.getEigPeriod(sit));
            g2.drawString("Eigenmode "+Integer.toString(sit)+", T="+sd1+", ω="+sd2, 10, 20);
            }
    }
    
    public void drawDefElements(Graphics2D g2){
        int x1,x2,y1,y2;
        double x0,x01;
        int split=1;
        this.theStructure.setStep(wstep);
        //Element[] theElements  = this.theStructure.getElements();
        for(int i=0; i<this.theStructure.getElements().length; i++){
            g2.setColor(Color.RED);
            g2.setStroke(new BasicStroke(1));
            //Element theElement = theElements[i];
            
            x1=this.xTransformation(this.theStructure.getDefElement(i+1, -1., wstep,theStructure.isIsolated()).get(0, 0));
            y1=this.yTransformation(this.theStructure.getDefElement(i+1, -1., wstep,theStructure.isIsolated()).get(1, 0));
            x0= -1.+ (double)1*2./split;
            x2=this.xTransformation(this.theStructure.getDefElement(i+1, x0, wstep,theStructure.isIsolated()).get(0, 0));
            y2=this.yTransformation(this.theStructure.getDefElement(i+1, x0, wstep,theStructure.isIsolated()).get(1, 0));
            g2.drawLine(x1, y1, x2, y2);
            if(split>2){
                for(int j=1; j<split-1; j++){
                    x0= -1.+ (double)j*2./split;
                    x01= -1.+ (double)(j+1)*2./split;
                    x1=this.xTransformation(this.theStructure.getDefElement(i+1, x01, wstep,theStructure.isIsolated()).get(0, 0));
                    y1=this.yTransformation(this.theStructure.getDefElement(i+1, x01, wstep,theStructure.isIsolated()).get(1, 0));
                    x2=this.xTransformation(this.theStructure.getDefElement(i+1, x0,  wstep,theStructure.isIsolated()).get(0, 0));
                    y2=this.yTransformation(this.theStructure.getDefElement(i+1, x0,  wstep,theStructure.isIsolated()).get(1, 0));
                    g2.drawLine(x1, y1, x2, y2);
                }
            }
            x0= -1.+ (double)(split-1)*2./split;
            x1=this.xTransformation(this.theStructure.getDefElement(i+1, x0, wstep,theStructure.isIsolated()).get(0, 0));
            y1=this.yTransformation(this.theStructure.getDefElement(i+1, x0, wstep,theStructure.isIsolated()).get(1, 0));
            x2=this.xTransformation(this.theStructure.getDefElement(i+1, 1., wstep,theStructure.isIsolated()).get(0, 0));
            y2=this.yTransformation(this.theStructure.getDefElement(i+1, 1., wstep,theStructure.isIsolated()).get(1, 0));
            g2.drawLine(x1, y1, x2, y2);
            
            ///////////////////////////////////
            if(theStructure.isIsolated()){
                g2.setColor(Color.RED);
                Element theElement  = this.theStructure.getElement(1);
                x1=this.xTransformation(theElement.getN1().getX());
                y1=this.yTransformation(theElement.getN1().getY());
            
                x2=this.xTransformation(this.theStructure.getDefElement(1, -1., wstep,theStructure.isIsolated()).get(0, 0));
                y2=this.yTransformation(this.theStructure.getDefElement(1, -1., wstep,theStructure.isIsolated()).get(1, 0));
                g2.drawLine(x1, y1, x2, y2);
                
                theElement  = this.theStructure.getElement(2);
                x1=this.xTransformation(theElement.getN1().getX());
                y1=this.yTransformation(theElement.getN1().getY());
            
                x2=this.xTransformation(this.theStructure.getDefElement(2, -1., wstep,theStructure.isIsolated()).get(0, 0));
                y2=this.yTransformation(this.theStructure.getDefElement(2, -1., wstep,theStructure.isIsolated()).get(1, 0));
                g2.drawLine(x1, y1, x2, y2);
            }
            ///////////////////////////////////
            g2.setColor(Color.BLACK);
            DecimalFormatSymbols comma =new DecimalFormatSymbols();
            comma.setDecimalSeparator('.');
            DecimalFormat Places = new DecimalFormat("0.000",comma);
            String sd1,sd2,sd3;
            sd1=Places.format(NumSteps*timeStep);
            sd2=Places.format(wstep*timeStep);
            sd3=Places.format(NumSteps);
//            g2.drawString("Αριθμός Διακριτών Βημάτων="+sd3+", Συνολικός Χρόνος="+sd1+", Διακριτός Χρόνος="+sd2, 10, 20);
            g2.drawString("Number of discrete steps="+sd3+", Total time="+sd1+", time step="+sd2, 10, 20);
            }
    }
    
    public void drawNodes(Graphics2D g2){
        int x1,y1;
        Node[] theNodes  = this.theStructure.getNodes();
        g2.setColor(Color.ORANGE);
        g2.setStroke(new BasicStroke(1));
        for(int i=0; i<theNodes.length; i++){
            Node theNode = theNodes[i];
            x1=this.xTransformation(theNode.getX());
            y1=this.yTransformation(theNode.getY());
            //g2.drawLine(x1-5, y1-5, x1+5, y1+5);
            //g2.drawLine(x1-5, y1+5, x1+5, y1-5);
            g2.fillArc(x1-1, y1-1, 4, 4, 0, 360);
            g2.drawString(Integer.toString(theNode.getId()), x1-10, y1+20);
        }
    }
    
    public void setDef(boolean flag){
        def=flag;
    }
    
    public void setSit(int sit){
        this.sit=sit;
    }
    
    public int getSit(){
        return this.sit;
    }

    public void run() {
        while(init){
            this.seeGraph.setWhichStep(this.wstep);
            repaint();
            this.seeGraph.repaint();
            try {
                Thread.sleep(Dts);
            } catch (InterruptedException ex) {
                Logger.getLogger(DrawPanelInput.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }
    
    
    public void setInit(boolean theBool){
        this.init=theBool;
    }
    
    public void setDt(long s){
        long nn=10;
        s=100-s;
        if(s<50){
            Dts=s*Dt/50;
        }else if(s>50){
            Dts=(s*(nn-1)/50+(2-nn))*Dt;
        }else{
            Dts=Dt;
        }
        //runner.interrupt();
        //System.out.println(s+" "+Dts);
    }
    
    public void setNumStep(int s){
        NumSteps=s;
        this.seeGraph.setNumStep(s);
    }
    
    public void setTimeStep(double s){
        timeStep=s;
        this.seeGraph.setTimeStep(s);
        long milliDt=(long) (s * 1000);
        Dt=milliDt; Dts=milliDt;
    }
    
    public void setWhichStep(int w){
        this.wstep=w;
    }
    
    public boolean getInit(){
        return this.init;
    }
    
    public void setForIsolataion(boolean b){
        this.forIsolation=b;
    }
    
    public void drawSDOF(Graphics2D g2){
        int x1,x2,y1,y2,width;
        Element[] theElements  = this.theStructure.getElements();
        for (Element theElement : theElements) {
            x1=this.xTransformation(theElement.getN1().getX());
            x2=this.xTransformation(theElement.getN2().getX());
            y1=this.yTransformation(theElement.getN1().getY());
            y2=this.yTransformation(theElement.getN2().getY());
            width=this.yTransformation(theStructure.getXLength())/10;

            g2.setColor(Color.BLACK);
            g2.setStroke(new BasicStroke(1));
            g2.drawLine(x1, y1, x2, y2);
            g2.drawLine(x1, y1, x1-width, y1);
            g2.drawLine(x1, y1, x1+width, y1);
            g2.fillArc(x2-width/2, y2-width/2, width, width, 0, 360);
        }
    }
    
    public void drawDefSDOF(Graphics2D g2){
        int x1,x2,y1,y2,width;
        Element[] theElements  = this.theStructure.getElements();
        for (Element theElement : theElements) {
            x1=this.xTransformation(theElement.getN1().getX());
            y1=this.yTransformation(theElement.getN1().getY());
            
            x2=this.xTransformation(theElement.getN2().getX()+theStructure.getDisp1(wstep));
            y2=this.yTransformation(theElement.getN2().getY());
            width=this.yTransformation(theStructure.getXLength())/10;

            g2.setColor(Color.RED);
            g2.setStroke(new BasicStroke(1));
            g2.drawLine(x1, y1, x2, y2);
            g2.drawLine(x1, y1, x1-width, y1);
            g2.drawLine(x1, y1, x1+width, y1);
            g2.fillArc(x2-width/2, y2-width/2, width, width, 0, 360);
        }
    }
    
    private void drawStElements(Graphics2D g2){
        core.Structure thePlate = this.theStructure;
        
        // Get dimensions
	int width  = this.getWidth();
	int height = this.getHeight();
	// Clear window
//	g2.setBackground(Color.BLACK);
	g2.clearRect(0, 0, width, height);
        
//        g2.setColor(Color.GRAY);
        
        xs=width/10;
        xe=width-width/10;
        ye=height/10;
        ys=height-height/10;
        
        g2.setStroke(new BasicStroke(1));
        g2.drawLine(xs, (ys+ye)/2, xe, (ys+ye)/2);
        g2.drawLine(xe, (ys+ye)/2, xe-10, (ys+ye)/2-8);
        g2.drawLine(xe, (ys+ye)/2, xe-10, (ys+ye)/2+8);
        g2.drawString("x", xe+10, (ys+ye)/2+10);
        g2.drawLine((xs+xe)/2, ye, (xs+xe)/2, ys);
        g2.drawLine((xs+xe)/2, ye, (xs+xe)/2-8, ye+10);
        g2.drawLine((xs+xe)/2, ye, (xs+xe)/2+8, ye+10);
        g2.drawString("y", (xs+xe)/2-10, ye-10);
        
        if(thePlate!=null){
            int x1,x2,y1,y2;
            g2.setStroke(new BasicStroke(2));
            g2.setColor(Color.blue);
            
            x1=this.xTransformation(-thePlate.getXLength()/2.);
            x2=this.xTransformation(thePlate.getXLength()/2.);
            y1=this.yTransformation(-thePlate.getYLength()/2.);
            y2=this.yTransformation(-thePlate.getYLength()/2.);
            g2.drawLine(x1, y1, x2, y2);
            x1=this.xTransformation(-thePlate.getXLength()/2.);
            x2=this.xTransformation(thePlate.getXLength()/2.);
            y1=this.yTransformation(thePlate.getYLength()/2.);
            y2=this.yTransformation(thePlate.getYLength()/2.);
            g2.drawLine(x1, y1, x2, y2);
            x1=this.xTransformation(thePlate.getXLength()/2.);
            x2=this.xTransformation(thePlate.getXLength()/2.);
            y1=this.yTransformation(-thePlate.getYLength()/2.);
            y2=this.yTransformation(thePlate.getYLength()/2.);
            g2.drawLine(x1, y1, x2, y2);
            x1=this.xTransformation(-thePlate.getXLength()/2.);
            x2=this.xTransformation(-thePlate.getXLength()/2.);
            y1=this.yTransformation(-thePlate.getYLength()/2.);
            y2=this.yTransformation(thePlate.getYLength()/2.);
            g2.drawLine(x1, y1, x2, y2);
            
            if(((core.Storey)thePlate).isMass()&&((core.Storey)thePlate).isElastic()){
                g2.setColor(Color.ORANGE);
                x1=this.xTransformation(((core.Storey)thePlate).getMassPoint().getX());
                y1=this.yTransformation(((core.Storey)thePlate).getMassPoint().getY());
                x2=this.xTransformation(((core.Storey)thePlate).getElastPoint().getX());
                y2=this.yTransformation(((core.Storey)thePlate).getElastPoint().getY());
                g2.drawLine(x1, y1, x2, y2);
            }
            if(((core.Storey)thePlate).isElastic()){
                g2.setColor(Color.ORANGE);
                x1=this.xTransformation(((core.Storey)thePlate).getElastPoint().getX())-2;
                y1=this.yTransformation(((core.Storey)thePlate).getElastPoint().getY())-2;
                x2=this.xTransformation(((core.Storey)thePlate).getElastPoint().getX())+2;
                y2=this.yTransformation(((core.Storey)thePlate).getElastPoint().getY())+2;
                g2.drawLine(x1, y1, x2, y2);
                g2.setColor(Color.BLACK);
                g2.drawString("Κ", x2+3, y2-3);
                g2.setColor(Color.ORANGE);
                x1=this.xTransformation(((core.Storey)thePlate).getElastPoint().getX())+2;
                y1=this.yTransformation(((core.Storey)thePlate).getElastPoint().getY())-2;
                x2=this.xTransformation(((core.Storey)thePlate).getElastPoint().getX())-2;
                y2=this.yTransformation(((core.Storey)thePlate).getElastPoint().getY())+2;
                g2.drawLine(x1, y1, x2, y2);
            }
            if(((core.Storey)thePlate).isMass()){
                g2.setColor(Color.ORANGE);
                x1=this.xTransformation(((core.Storey)thePlate).getMassPoint().getX())-2;
                y1=this.yTransformation(((core.Storey)thePlate).getMassPoint().getY())-2;
                x2=this.xTransformation(((core.Storey)thePlate).getMassPoint().getX())+2;
                y2=this.yTransformation(((core.Storey)thePlate).getMassPoint().getY())+2;
                g2.drawLine(x1, y1, x2, y2);
                g2.setColor(Color.BLACK);
                g2.drawString("Μ", x2+3, y2-3);
                g2.setColor(Color.ORANGE);
                x1=this.xTransformation(((core.Storey)thePlate).getMassPoint().getX())+2;
                y1=this.yTransformation(((core.Storey)thePlate).getMassPoint().getY())-2;
                x2=this.xTransformation(((core.Storey)thePlate).getMassPoint().getX())-2;
                y2=this.yTransformation(((core.Storey)thePlate).getMassPoint().getY())+2;
                g2.drawLine(x1, y1, x2, y2);
            }
        }
        
        Map<Integer,core.StoreyElement> theElements =thePlate.getStElements();
        int x1,x2,y1,y2;
        g2.setColor(Color.blue);
        g2.setStroke(new BasicStroke(1));
        for(Iterator<core.StoreyElement> it=theElements.values().iterator(); it.hasNext();){
            core.StoreyElement theElement = it.next();
            x1=this.xTransformation(theElement.getEdge1().getX());
            x2=this.xTransformation(theElement.getEdge2().getX());
            y1=this.yTransformation(theElement.getEdge1().getY());
            y2=this.yTransformation(theElement.getEdge2().getY());
            g2.drawLine(x1, y1, x2, y2);
            x1=this.xTransformation(theElement.getEdge2().getX());
            x2=this.xTransformation(theElement.getEdge3().getX());
            y1=this.yTransformation(theElement.getEdge2().getY());
            y2=this.yTransformation(theElement.getEdge3().getY());
            g2.drawLine(x1, y1, x2, y2);
            x1=this.xTransformation(theElement.getEdge3().getX());
            x2=this.xTransformation(theElement.getEdge4().getX());
            y1=this.yTransformation(theElement.getEdge3().getY());
            y2=this.yTransformation(theElement.getEdge4().getY());
            g2.drawLine(x1, y1, x2, y2);
            x1=this.xTransformation(theElement.getEdge4().getX());
            x2=this.xTransformation(theElement.getEdge1().getX());
            y1=this.yTransformation(theElement.getEdge4().getY());
            y2=this.yTransformation(theElement.getEdge1().getY());
            g2.drawLine(x1, y1, x2, y2);
            x1=this.xTransformation(theElement.getEdge1().getX());
            x2=this.xTransformation(theElement.getEdge3().getX());
            y1=this.yTransformation(theElement.getEdge1().getY());
            y2=this.yTransformation(theElement.getEdge3().getY());
            g2.drawLine(x1, y1, x2, y2);
            x1=this.xTransformation(theElement.getEdge2().getX());
            x2=this.xTransformation(theElement.getEdge4().getX());
            y1=this.yTransformation(theElement.getEdge2().getY());
            y2=this.yTransformation(theElement.getEdge4().getY());
            g2.drawLine(x1, y1, x2, y2);
        }
    }
    
    private void drawEigStElements(Graphics2D g2){
        core.Structure thePlate = this.theStructure;
        
        // Get dimensions
	int width  = this.getWidth();
	int height = this.getHeight();
	// Clear window
//	g2.setBackground(Color.BLACK);
	g2.clearRect(0, 0, width, height);
        
        g2.setColor(Color.GRAY);
        
        xs=width/10;
        xe=width-width/10;
        ye=height/10;
        ys=height-height/10;
        
        g2.setStroke(new BasicStroke(1));
        g2.drawLine(xs, (ys+ye)/2, xe, (ys+ye)/2);
        g2.drawLine(xe, (ys+ye)/2, xe-10, (ys+ye)/2-8);
        g2.drawLine(xe, (ys+ye)/2, xe-10, (ys+ye)/2+8);
        g2.drawString("x", xe+10, (ys+ye)/2+10);
        g2.drawLine((xs+xe)/2, ye, (xs+xe)/2, ys);
        g2.drawLine((xs+xe)/2, ye, (xs+xe)/2-8, ye+10);
        g2.drawLine((xs+xe)/2, ye, (xs+xe)/2+8, ye+10);
        g2.drawString("y", (xs+xe)/2-10, ye-10);
        
        if(thePlate!=null){
            int x1,x2,y1,y2;
            g2.setStroke(new BasicStroke(2));
            g2.setColor(Color.blue);
            
            x1=this.xTransformation(-thePlate.getXLength()/2.);
            x2=this.xTransformation(thePlate.getXLength()/2.);
            y1=this.yTransformation(-thePlate.getYLength()/2.);
            y2=this.yTransformation(-thePlate.getYLength()/2.);
            g2.drawLine(x1, y1, x2, y2);
            x1=this.xTransformation(-thePlate.getXLength()/2.);
            x2=this.xTransformation(thePlate.getXLength()/2.);
            y1=this.yTransformation(thePlate.getYLength()/2.);
            y2=this.yTransformation(thePlate.getYLength()/2.);
            g2.drawLine(x1, y1, x2, y2);
            x1=this.xTransformation(thePlate.getXLength()/2.);
            x2=this.xTransformation(thePlate.getXLength()/2.);
            y1=this.yTransformation(-thePlate.getYLength()/2.);
            y2=this.yTransformation(thePlate.getYLength()/2.);
            g2.drawLine(x1, y1, x2, y2);
            x1=this.xTransformation(-thePlate.getXLength()/2.);
            x2=this.xTransformation(-thePlate.getXLength()/2.);
            y1=this.yTransformation(-thePlate.getYLength()/2.);
            y2=this.yTransformation(thePlate.getYLength()/2.);
            g2.drawLine(x1, y1, x2, y2);
            
            if(((core.Storey)thePlate).isMass()&&((core.Storey)thePlate).isElastic()){
                g2.setColor(Color.ORANGE);
                x1=this.xTransformation(((core.Storey)thePlate).getMassPoint().getX());
                y1=this.yTransformation(((core.Storey)thePlate).getMassPoint().getY());
                x2=this.xTransformation(((core.Storey)thePlate).getElastPoint().getX());
                y2=this.yTransformation(((core.Storey)thePlate).getElastPoint().getY());
                g2.drawLine(x1, y1, x2, y2);
            }
            if(((core.Storey)thePlate).isElastic()){
                g2.setColor(Color.ORANGE);
                x1=this.xTransformation(((core.Storey)thePlate).getElastPoint().getX())-2;
                y1=this.yTransformation(((core.Storey)thePlate).getElastPoint().getY())-2;
                x2=this.xTransformation(((core.Storey)thePlate).getElastPoint().getX())+2;
                y2=this.yTransformation(((core.Storey)thePlate).getElastPoint().getY())+2;
                g2.drawLine(x1, y1, x2, y2);
                g2.setColor(Color.BLACK);
                g2.drawString("Κ", x2+3, y2-3);
                g2.setColor(Color.ORANGE);
                x1=this.xTransformation(((core.Storey)thePlate).getElastPoint().getX())+2;
                y1=this.yTransformation(((core.Storey)thePlate).getElastPoint().getY())-2;
                x2=this.xTransformation(((core.Storey)thePlate).getElastPoint().getX())-2;
                y2=this.yTransformation(((core.Storey)thePlate).getElastPoint().getY())+2;
                g2.drawLine(x1, y1, x2, y2);
            }
            if(((core.Storey)thePlate).isMass()){
                g2.setColor(Color.ORANGE);
                x1=this.xTransformation(((core.Storey)thePlate).getMassPoint().getX())-2;
                y1=this.yTransformation(((core.Storey)thePlate).getMassPoint().getY())-2;
                x2=this.xTransformation(((core.Storey)thePlate).getMassPoint().getX())+2;
                y2=this.yTransformation(((core.Storey)thePlate).getMassPoint().getY())+2;
                g2.drawLine(x1, y1, x2, y2);
                g2.setColor(Color.BLACK);
                g2.drawString("Μ", x2+3, y2-3);
                g2.setColor(Color.ORANGE);
                x1=this.xTransformation(((core.Storey)thePlate).getMassPoint().getX())+2;
                y1=this.yTransformation(((core.Storey)thePlate).getMassPoint().getY())-2;
                x2=this.xTransformation(((core.Storey)thePlate).getMassPoint().getX())-2;
                y2=this.yTransformation(((core.Storey)thePlate).getMassPoint().getY())+2;
                g2.drawLine(x1, y1, x2, y2);
            }
        }
        
        int x1,x2,y1,y2;
        Node Point1,Point2;
        g2.setColor(Color.MAGENTA);
        g2.setStroke(new BasicStroke(1));
        
        Point1 = new Node(0,-thePlate.getXLength()/2.,-thePlate.getYLength()/2.);
        Point1 = ((core.Storey)thePlate).getEigDisplacement(Point1, sit);
        Point2 = new Node(0,thePlate.getXLength()/2.,-thePlate.getYLength()/2.);
        Point2 = ((core.Storey)thePlate).getEigDisplacement(Point2, sit);
        x1=this.xTransformation(Point1.getX());
        x2=this.xTransformation(Point2.getX());
        y1=this.yTransformation(Point1.getY());
        y2=this.yTransformation(Point2.getY());
        g2.drawLine(x1, y1, x2, y2);
        
        Point1 = new Node(0,thePlate.getXLength()/2.,-thePlate.getYLength()/2.);
        Point1 = ((core.Storey)thePlate).getEigDisplacement(Point1, sit);
        Point2 = new Node(0,thePlate.getXLength()/2.,thePlate.getYLength()/2.);
        Point2 = ((core.Storey)thePlate).getEigDisplacement(Point2, sit);
        x1=this.xTransformation(Point1.getX());
        x2=this.xTransformation(Point2.getX());
        y1=this.yTransformation(Point1.getY());
        y2=this.yTransformation(Point2.getY());
        g2.drawLine(x1, y1, x2, y2);
        
        Point1 = new Node(0,thePlate.getXLength()/2.,thePlate.getYLength()/2.);
        Point1 = ((core.Storey)thePlate).getEigDisplacement(Point1, sit);
        Point2 = new Node(0,-thePlate.getXLength()/2.,thePlate.getYLength()/2.);
        Point2 = ((core.Storey)thePlate).getEigDisplacement(Point2, sit);
        x1=this.xTransformation(Point1.getX());
        x2=this.xTransformation(Point2.getX());
        y1=this.yTransformation(Point1.getY());
        y2=this.yTransformation(Point2.getY());
        g2.drawLine(x1, y1, x2, y2);
        
        Point1 = new Node(0,-thePlate.getXLength()/2.,thePlate.getYLength()/2.);
        Point1 = ((core.Storey)thePlate).getEigDisplacement(Point1, sit);
        Point2 = new Node(0,-thePlate.getXLength()/2.,-thePlate.getYLength()/2.);
        Point2 = ((core.Storey)thePlate).getEigDisplacement(Point2, sit);
        x1=this.xTransformation(Point1.getX());
        x2=this.xTransformation(Point2.getX());
        y1=this.yTransformation(Point1.getY());
        y2=this.yTransformation(Point2.getY());
        g2.drawLine(x1, y1, x2, y2);
        
        Map<Integer,core.StoreyElement> theElements = thePlate.getStElements();
        g2.setColor(Color.MAGENTA);
        g2.setStroke(new BasicStroke(1));
        for(Iterator<core.StoreyElement> it=theElements.values().iterator(); it.hasNext();){
            core.StoreyElement theElement = it.next();
            Point1 = new Node(0,theElement.getEdge1().getX(),theElement.getEdge1().getY());
            Point1 = ((core.Storey)thePlate).getEigDisplacement(Point1, sit);
            Point2 = new Node(0,theElement.getEdge2().getX(),theElement.getEdge2().getY());
            Point2 = ((core.Storey)thePlate).getEigDisplacement(Point2, sit);
            x1=this.xTransformation(Point1.getX());
            x2=this.xTransformation(Point2.getX());
            y1=this.yTransformation(Point1.getY());
            y2=this.yTransformation(Point2.getY());
            g2.drawLine(x1, y1, x2, y2);
            
            Point1 = new Node(0,theElement.getEdge2().getX(),theElement.getEdge2().getY());
            Point1 = ((core.Storey)thePlate).getEigDisplacement(Point1, sit);
            Point2 = new Node(0,theElement.getEdge3().getX(),theElement.getEdge3().getY());
            Point2 = ((core.Storey)thePlate).getEigDisplacement(Point2, sit);
            x1=this.xTransformation(Point1.getX());
            x2=this.xTransformation(Point2.getX());
            y1=this.yTransformation(Point1.getY());
            y2=this.yTransformation(Point2.getY());
            g2.drawLine(x1, y1, x2, y2);
            
            Point1 = new Node(0,theElement.getEdge3().getX(),theElement.getEdge3().getY());
            Point1 = ((core.Storey)thePlate).getEigDisplacement(Point1, sit);
            Point2 = new Node(0,theElement.getEdge4().getX(),theElement.getEdge4().getY());
            Point2 = ((core.Storey)thePlate).getEigDisplacement(Point2, sit);
            x1=this.xTransformation(Point1.getX());
            x2=this.xTransformation(Point2.getX());
            y1=this.yTransformation(Point1.getY());
            y2=this.yTransformation(Point2.getY());
            g2.drawLine(x1, y1, x2, y2);
            
            Point1 = new Node(0,theElement.getEdge4().getX(),theElement.getEdge4().getY());
            Point1 = ((core.Storey)thePlate).getEigDisplacement(Point1, sit);
            Point2 = new Node(0,theElement.getEdge1().getX(),theElement.getEdge1().getY());
            Point2 = ((core.Storey)thePlate).getEigDisplacement(Point2, sit);
            x1=this.xTransformation(Point1.getX());
            x2=this.xTransformation(Point2.getX());
            y1=this.yTransformation(Point1.getY());
            y2=this.yTransformation(Point2.getY());
            g2.drawLine(x1, y1, x2, y2);
            
            Point1 = new Node(0,theElement.getEdge4().getX(),theElement.getEdge4().getY());
            Point1 = ((core.Storey)thePlate).getEigDisplacement(Point1, sit);
            Point2 = new Node(0,theElement.getEdge2().getX(),theElement.getEdge2().getY());
            Point2 = ((core.Storey)thePlate).getEigDisplacement(Point2, sit);
            x1=this.xTransformation(Point1.getX());
            x2=this.xTransformation(Point2.getX());
            y1=this.yTransformation(Point1.getY());
            y2=this.yTransformation(Point2.getY());
            g2.drawLine(x1, y1, x2, y2);
            
            Point1 = new Node(0,theElement.getEdge3().getX(),theElement.getEdge3().getY());
            Point1 = ((core.Storey)thePlate).getEigDisplacement(Point1, sit);
            Point2 = new Node(0,theElement.getEdge1().getX(),theElement.getEdge1().getY());
            Point2 = ((core.Storey)thePlate).getEigDisplacement(Point2, sit);
            x1=this.xTransformation(Point1.getX());
            x2=this.xTransformation(Point2.getX());
            y1=this.yTransformation(Point1.getY());
            y2=this.yTransformation(Point2.getY());
            g2.drawLine(x1, y1, x2, y2);
        }
        Point1 = new Node(0,((core.Storey)thePlate).getElastPoint().getX(),((core.Storey)thePlate).getElastPoint().getY());
        Point1 = ((core.Storey)thePlate).getEigDisplacement(Point1, sit);
        x1=this.xTransformation(Point1.getX())-2;
        y1=this.yTransformation(Point1.getY())-2;
        x2=this.xTransformation(Point1.getX())+2;
        y2=this.yTransformation(Point1.getY())+2;
        g2.drawLine(x1, y1, x2, y2);
        g2.drawString("Κ", x2+3, y2-3);
        x1=this.xTransformation(Point1.getX())+2;
        y1=this.yTransformation(Point1.getY())-2;
        x2=this.xTransformation(Point1.getX())-2;
        y2=this.yTransformation(Point1.getY())+2;
        g2.drawLine(x1, y1, x2, y2);
        
        Point1 = new Node(0,((core.Storey)thePlate).getMassPoint().getX(),((core.Storey)thePlate).getMassPoint().getY());
        Point1 = ((core.Storey)thePlate).getEigDisplacement(Point1, sit);
        x1=this.xTransformation(Point1.getX())-2;
        y1=this.yTransformation(Point1.getY())-2;
        x2=this.xTransformation(Point1.getX())+2;
        y2=this.yTransformation(Point1.getY())+2;
        g2.drawLine(x1, y1, x2, y2);
        g2.drawString("M", x2+3, y2-3);
        x1=this.xTransformation(Point1.getX())+2;
        y1=this.yTransformation(Point1.getY())-2;
        x2=this.xTransformation(Point1.getX())-2;
        y2=this.yTransformation(Point1.getY())+2;
        g2.drawLine(x1, y1, x2, y2);
        
        Point1 = new Node(0,((core.Storey)thePlate).getMassPoint().getX(),((core.Storey)thePlate).getMassPoint().getY());
        Point1 = ((core.Storey)thePlate).getEigDisplacement(Point1, sit);
        Point2 = new Node(0,((core.Storey)thePlate).getElastPoint().getX(),((core.Storey)thePlate).getElastPoint().getY());
        Point2 = ((core.Storey)thePlate).getEigDisplacement(Point2, sit);
        x1=this.xTransformation(Point1.getX());
        x2=this.xTransformation(Point2.getX());
        y1=this.yTransformation(Point1.getY());
        y2=this.yTransformation(Point2.getY());
        g2.drawLine(x1, y1, x2, y2);
        
        g2.setColor(Color.BLACK);
        DecimalFormatSymbols comma =new DecimalFormatSymbols();
        comma.setDecimalSeparator('.');
        DecimalFormat Places = new DecimalFormat("0.00000",comma);
        String sd1,sd2;
        sd1=Places.format(thePlate.getEigPeriod(sit));
        sd2=Places.format(2.*Math.PI/thePlate.getEigPeriod(sit));
        g2.drawString("Eigenmode "+Integer.toString(sit)+", T="+sd1+", ω="+sd2, 10, 20);
    }   
    
    private void drawDefStElements(Graphics2D g2){
        core.Structure thePlate = this.theStructure;
        
        // Get dimensions
	int width  = this.getWidth();
	int height = this.getHeight();
	// Clear window
//	g2.setBackground(Color.BLACK);
	g2.clearRect(0, 0, width, height);
        
        g2.setColor(Color.GRAY);
        
        xs=width/10;
        xe=width-width/10;
        ye=height/10;
        ys=height-height/10;
        
        g2.setStroke(new BasicStroke(1));
        g2.drawLine(xs, (ys+ye)/2, xe, (ys+ye)/2);
        g2.drawLine(xe, (ys+ye)/2, xe-10, (ys+ye)/2-8);
        g2.drawLine(xe, (ys+ye)/2, xe-10, (ys+ye)/2+8);
        g2.drawString("x", xe+10, (ys+ye)/2+10);
        g2.drawLine((xs+xe)/2, ye, (xs+xe)/2, ys);
        g2.drawLine((xs+xe)/2, ye, (xs+xe)/2-8, ye+10);
        g2.drawLine((xs+xe)/2, ye, (xs+xe)/2+8, ye+10);
        g2.drawString("y", (xs+xe)/2-10, ye-10);
        
        if(thePlate!=null){
            int x1,x2,y1,y2;
            g2.setStroke(new BasicStroke(2));
            g2.setColor(Color.blue);
            
            x1=this.xTransformation(-thePlate.getXLength()/2.);
            x2=this.xTransformation(thePlate.getXLength()/2.);
            y1=this.yTransformation(-thePlate.getYLength()/2.);
            y2=this.yTransformation(-thePlate.getYLength()/2.);
            g2.drawLine(x1, y1, x2, y2);
            x1=this.xTransformation(-thePlate.getXLength()/2.);
            x2=this.xTransformation(thePlate.getXLength()/2.);
            y1=this.yTransformation(thePlate.getYLength()/2.);
            y2=this.yTransformation(thePlate.getYLength()/2.);
            g2.drawLine(x1, y1, x2, y2);
            x1=this.xTransformation(thePlate.getXLength()/2.);
            x2=this.xTransformation(thePlate.getXLength()/2.);
            y1=this.yTransformation(-thePlate.getYLength()/2.);
            y2=this.yTransformation(thePlate.getYLength()/2.);
            g2.drawLine(x1, y1, x2, y2);
            x1=this.xTransformation(-thePlate.getXLength()/2.);
            x2=this.xTransformation(-thePlate.getXLength()/2.);
            y1=this.yTransformation(-thePlate.getYLength()/2.);
            y2=this.yTransformation(thePlate.getYLength()/2.);
            g2.drawLine(x1, y1, x2, y2);
            
            if(((core.Storey)thePlate).isMass()&&((core.Storey)thePlate).isElastic()){
                g2.setColor(Color.ORANGE);
                x1=this.xTransformation(((core.Storey)thePlate).getMassPoint().getX());
                y1=this.yTransformation(((core.Storey)thePlate).getMassPoint().getY());
                x2=this.xTransformation(((core.Storey)thePlate).getElastPoint().getX());
                y2=this.yTransformation(((core.Storey)thePlate).getElastPoint().getY());
                g2.drawLine(x1, y1, x2, y2);
            }
            if(((core.Storey)thePlate).isElastic()){
                g2.setColor(Color.ORANGE);
                x1=this.xTransformation(((core.Storey)thePlate).getElastPoint().getX())-2;
                y1=this.yTransformation(((core.Storey)thePlate).getElastPoint().getY())-2;
                x2=this.xTransformation(((core.Storey)thePlate).getElastPoint().getX())+2;
                y2=this.yTransformation(((core.Storey)thePlate).getElastPoint().getY())+2;
                g2.drawLine(x1, y1, x2, y2);
                g2.setColor(Color.BLACK);
                g2.drawString("Κ", x2+3, y2-3);
                g2.setColor(Color.ORANGE);
                x1=this.xTransformation(((core.Storey)thePlate).getElastPoint().getX())+2;
                y1=this.yTransformation(((core.Storey)thePlate).getElastPoint().getY())-2;
                x2=this.xTransformation(((core.Storey)thePlate).getElastPoint().getX())-2;
                y2=this.yTransformation(((core.Storey)thePlate).getElastPoint().getY())+2;
                g2.drawLine(x1, y1, x2, y2);
            }
            if(((core.Storey)thePlate).isMass()){
                g2.setColor(Color.ORANGE);
                x1=this.xTransformation(((core.Storey)thePlate).getMassPoint().getX())-2;
                y1=this.yTransformation(((core.Storey)thePlate).getMassPoint().getY())-2;
                x2=this.xTransformation(((core.Storey)thePlate).getMassPoint().getX())+2;
                y2=this.yTransformation(((core.Storey)thePlate).getMassPoint().getY())+2;
                g2.drawLine(x1, y1, x2, y2);
                g2.setColor(Color.BLACK);
                g2.drawString("Μ", x2+3, y2-3);
                g2.setColor(Color.ORANGE);
                x1=this.xTransformation(((core.Storey)thePlate).getMassPoint().getX())+2;
                y1=this.yTransformation(((core.Storey)thePlate).getMassPoint().getY())-2;
                x2=this.xTransformation(((core.Storey)thePlate).getMassPoint().getX())-2;
                y2=this.yTransformation(((core.Storey)thePlate).getMassPoint().getY())+2;
                g2.drawLine(x1, y1, x2, y2);
            }
        }
        
        int x1,x2,y1,y2;
        Node Point1,Point2;
        g2.setColor(Color.MAGENTA);
        g2.setStroke(new BasicStroke(1));
        
        Point1 = new Node(0,-thePlate.getXLength()/2.,-thePlate.getYLength()/2.);
        Point1 = ((core.Storey)thePlate).getDefDisplacement(Point1, wstep);
        Point2 = new Node(0,thePlate.getXLength()/2.,-thePlate.getYLength()/2.);
        Point2 = ((core.Storey)thePlate).getDefDisplacement(Point2, wstep);
        x1=this.xTransformation(Point1.getX());
        x2=this.xTransformation(Point2.getX());
        y1=this.yTransformation(Point1.getY());
        y2=this.yTransformation(Point2.getY());
        g2.drawLine(x1, y1, x2, y2);
        
        Point1 = new Node(0,thePlate.getXLength()/2.,-thePlate.getYLength()/2.);
        Point1 = ((core.Storey)thePlate).getDefDisplacement(Point1, wstep);
        Point2 = new Node(0,thePlate.getXLength()/2.,thePlate.getYLength()/2.);
        Point2 = ((core.Storey)thePlate).getDefDisplacement(Point2, wstep);
        x1=this.xTransformation(Point1.getX());
        x2=this.xTransformation(Point2.getX());
        y1=this.yTransformation(Point1.getY());
        y2=this.yTransformation(Point2.getY());
        g2.drawLine(x1, y1, x2, y2);
        
        Point1 = new Node(0,thePlate.getXLength()/2.,thePlate.getYLength()/2.);
        Point1 = ((core.Storey)thePlate).getDefDisplacement(Point1, wstep);
        Point2 = new Node(0,-thePlate.getXLength()/2.,thePlate.getYLength()/2.);
        Point2 = ((core.Storey)thePlate).getDefDisplacement(Point2, wstep);
        x1=this.xTransformation(Point1.getX());
        x2=this.xTransformation(Point2.getX());
        y1=this.yTransformation(Point1.getY());
        y2=this.yTransformation(Point2.getY());
        g2.drawLine(x1, y1, x2, y2);
        
        Point1 = new Node(0,-thePlate.getXLength()/2.,thePlate.getYLength()/2.);
        Point1 = ((core.Storey)thePlate).getDefDisplacement(Point1, wstep);
        Point2 = new Node(0,-thePlate.getXLength()/2.,-thePlate.getYLength()/2.);
        Point2 = ((core.Storey)thePlate).getDefDisplacement(Point2, wstep);
        x1=this.xTransformation(Point1.getX());
        x2=this.xTransformation(Point2.getX());
        y1=this.yTransformation(Point1.getY());
        y2=this.yTransformation(Point2.getY());
        g2.drawLine(x1, y1, x2, y2);
        
        Map<Integer,core.StoreyElement> theElements = thePlate.getStElements();
        g2.setColor(Color.MAGENTA);
        g2.setStroke(new BasicStroke(1));
        for(Iterator<core.StoreyElement> it=theElements.values().iterator(); it.hasNext();){
            core.StoreyElement theElement = it.next();
            Point1 = new Node(0,theElement.getEdge1().getX(),theElement.getEdge1().getY());
            Point1 = ((core.Storey)thePlate).getDefDisplacement(Point1, wstep);
            Point2 = new Node(0,theElement.getEdge2().getX(),theElement.getEdge2().getY());
            Point2 = ((core.Storey)thePlate).getDefDisplacement(Point2, wstep);
            x1=this.xTransformation(Point1.getX());
            x2=this.xTransformation(Point2.getX());
            y1=this.yTransformation(Point1.getY());
            y2=this.yTransformation(Point2.getY());
            g2.drawLine(x1, y1, x2, y2);
            
            Point1 = new Node(0,theElement.getEdge2().getX(),theElement.getEdge2().getY());
            Point1 = ((core.Storey)thePlate).getDefDisplacement(Point1, wstep);
            Point2 = new Node(0,theElement.getEdge3().getX(),theElement.getEdge3().getY());
            Point2 = ((core.Storey)thePlate).getDefDisplacement(Point2, wstep);
            x1=this.xTransformation(Point1.getX());
            x2=this.xTransformation(Point2.getX());
            y1=this.yTransformation(Point1.getY());
            y2=this.yTransformation(Point2.getY());
            g2.drawLine(x1, y1, x2, y2);
            
            Point1 = new Node(0,theElement.getEdge3().getX(),theElement.getEdge3().getY());
            Point1 = ((core.Storey)thePlate).getDefDisplacement(Point1, wstep);
            Point2 = new Node(0,theElement.getEdge4().getX(),theElement.getEdge4().getY());
            Point2 = ((core.Storey)thePlate).getDefDisplacement(Point2, wstep);
            x1=this.xTransformation(Point1.getX());
            x2=this.xTransformation(Point2.getX());
            y1=this.yTransformation(Point1.getY());
            y2=this.yTransformation(Point2.getY());
            g2.drawLine(x1, y1, x2, y2);
            
            Point1 = new Node(0,theElement.getEdge4().getX(),theElement.getEdge4().getY());
            Point1 = ((core.Storey)thePlate).getDefDisplacement(Point1, wstep);
            Point2 = new Node(0,theElement.getEdge1().getX(),theElement.getEdge1().getY());
            Point2 = ((core.Storey)thePlate).getDefDisplacement(Point2, wstep);
            x1=this.xTransformation(Point1.getX());
            x2=this.xTransformation(Point2.getX());
            y1=this.yTransformation(Point1.getY());
            y2=this.yTransformation(Point2.getY());
            g2.drawLine(x1, y1, x2, y2);
            
            Point1 = new Node(0,theElement.getEdge4().getX(),theElement.getEdge4().getY());
            Point1 = ((core.Storey)thePlate).getDefDisplacement(Point1, wstep);
            Point2 = new Node(0,theElement.getEdge2().getX(),theElement.getEdge2().getY());
            Point2 = ((core.Storey)thePlate).getDefDisplacement(Point2, wstep);
            x1=this.xTransformation(Point1.getX());
            x2=this.xTransformation(Point2.getX());
            y1=this.yTransformation(Point1.getY());
            y2=this.yTransformation(Point2.getY());
            g2.drawLine(x1, y1, x2, y2);
            
            Point1 = new Node(0,theElement.getEdge3().getX(),theElement.getEdge3().getY());
            Point1 = ((core.Storey)thePlate).getDefDisplacement(Point1, wstep);
            Point2 = new Node(0,theElement.getEdge1().getX(),theElement.getEdge1().getY());
            Point2 = ((core.Storey)thePlate).getDefDisplacement(Point2, wstep);
            x1=this.xTransformation(Point1.getX());
            x2=this.xTransformation(Point2.getX());
            y1=this.yTransformation(Point1.getY());
            y2=this.yTransformation(Point2.getY());
            g2.drawLine(x1, y1, x2, y2);
        }
        Point1 = new Node(0,((core.Storey)thePlate).getElastPoint().getX(),((core.Storey)thePlate).getElastPoint().getY());
        Point1 = ((core.Storey)thePlate).getDefDisplacement(Point1, wstep);
        x1=this.xTransformation(Point1.getX())-2;
        y1=this.yTransformation(Point1.getY())-2;
        x2=this.xTransformation(Point1.getX())+2;
        y2=this.yTransformation(Point1.getY())+2;
        g2.drawLine(x1, y1, x2, y2);
        g2.drawString("Κ", x2+3, y2-3);
        x1=this.xTransformation(Point1.getX())+2;
        y1=this.yTransformation(Point1.getY())-2;
        x2=this.xTransformation(Point1.getX())-2;
        y2=this.yTransformation(Point1.getY())+2;
        g2.drawLine(x1, y1, x2, y2);
        
        Point1 = new Node(0,((core.Storey)thePlate).getMassPoint().getX(),((core.Storey)thePlate).getMassPoint().getY());
        Point1 = ((core.Storey)thePlate).getDefDisplacement(Point1, wstep);
        x1=this.xTransformation(Point1.getX())-2;
        y1=this.yTransformation(Point1.getY())-2;
        x2=this.xTransformation(Point1.getX())+2;
        y2=this.yTransformation(Point1.getY())+2;
        g2.drawLine(x1, y1, x2, y2);
        g2.drawString("M", x2+3, y2-3);
        x1=this.xTransformation(Point1.getX())+2;
        y1=this.yTransformation(Point1.getY())-2;
        x2=this.xTransformation(Point1.getX())-2;
        y2=this.yTransformation(Point1.getY())+2;
        g2.drawLine(x1, y1, x2, y2);
        
        Point1 = new Node(0,((core.Storey)thePlate).getMassPoint().getX(),((core.Storey)thePlate).getMassPoint().getY());
        Point1 = ((core.Storey)thePlate).getDefDisplacement(Point1, wstep);
        Point2 = new Node(0,((core.Storey)thePlate).getElastPoint().getX(),((core.Storey)thePlate).getElastPoint().getY());
        Point2 = ((core.Storey)thePlate).getDefDisplacement(Point2, wstep);
        x1=this.xTransformation(Point1.getX());
        x2=this.xTransformation(Point2.getX());
        y1=this.yTransformation(Point1.getY());
        y2=this.yTransformation(Point2.getY());
        g2.drawLine(x1, y1, x2, y2);
    }
    
    private void saveImageSelection(){
//        from http://stackoverflow.com/questions/15565328/save-jpanel-into-jpg-png-image
        BufferedImage image = new BufferedImage(this.getWidth(), this.getHeight(), BufferedImage.TYPE_INT_RGB);
        Graphics2D graphics2D = image.createGraphics();
        
        this.paint(graphics2D);
        
//        try{
//            ImageIO.write(image,"png", new File("/home/pchr/Desktop/Example.png"));
//        }
//        catch(Exception ex){
//            
//        }
        
        jFile.showSaveDialog(this);
        Path pth = jFile.getSelectedFile().toPath();
        JOptionPane.showMessageDialog(null, pth.toString());
        try {
            ImageIO.write(image, "png", new File(pth.toString()));
        } catch (IOException ox) {
            // TODO: handle exception
            ox.printStackTrace();
        }
    }
}
