/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package gui;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.text.DecimalFormat;
import java.text.DecimalFormatSymbols;
import javax.swing.JPanel;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;

/**
 *
 * @author pchr
 */
public class SpecPanel extends JPanel{
    //private core.spec theSpec;
    private JTable jTable1;
    private core.Structure theStructure;
    private int xs,ys,xe,ye;
    int yupp;
    int ylow;
    
    public void setFrame(core.Structure frame){
        this.theStructure=frame;
    }
    
    //public void setSpec(core.spec thespec){
    //    this.theSpec=thespec;
    //}
    
    public void setAccelTable(JTable thetable){
        this.jTable1 = thetable;
    }
    
    public void plot(){
        repaint();
    }
    
    protected int xTransformation(double x){
        int xd=0;
        double xmax=6*this.maxPeriod()/5;
        double xmin=0.;
        xd=(int) ((-xmin * xe + x * (xe - xs) + xmax * xs) / (xmax - xmin));
        return xd;
    }
    
    protected int yTransformation(double y){
        int yd=0;
        double ymax=6*this.maxAcc()/5;
        double ymin=0.;
        yd=(int) ((-ymin * ye + y * (ye - ys) + ymax * ys) / (ymax - ymin));
        return yd;
    }
    
    @Override
    public void paintComponent(Graphics g) {
        //System.out.println("paintComponent");
	// Define graphics
        Graphics2D g2 = (Graphics2D) g;
        // Get dimensions
	int width  = this.getWidth();
	int height = this.getHeight();
	// Clear window
	g2.setBackground(Color.LIGHT_GRAY);
	g2.clearRect(0, 0, width, height);
        
        g2.setColor(Color.BLACK);
        
        xs=width/10;
        xe=width-width/10;
        ye=height/10;
        ys=height-height/10;
        
        g2.setStroke(new BasicStroke(1));
        g2.drawLine(xs, ys, xe, ys);
        g2.drawLine(xe, ys, xe-10, ys-8);
        g2.drawLine(xe, ys, xe-10, ys+8);
        g2.drawString("T (sec)", xe+10, ys);
        g2.drawLine(xs, ys, xs, ye);
        g2.drawLine(xs, ye, xs-8, ye+10);
        g2.drawLine(xs, ye, xs+8, ye+10);
        g2.drawString("Sa (m/sec^2)", xs-10, ye-10);
        
        int x1,x2,y1,y2;
        DefaultTableModel tableModel = (DefaultTableModel) jTable1.getModel();
        int nrows = tableModel.getRowCount();
        double[] periods = new double[nrows];
        double[] accel = new double[nrows];
        for(int i=0; i<nrows; i++){
            periods[i]=Double.parseDouble(tableModel.getValueAt(i, 0).toString());
            accel[i]=Double.parseDouble(tableModel.getValueAt(i, 1).toString());
        }
        
        double maxT=periods[periods.length-1]; double maxA=this.maxAcc();
        for(int i=1;i<=10;i++){
            DecimalFormatSymbols comma =new DecimalFormatSymbols();
            comma.setDecimalSeparator('.');
            DecimalFormat Places = new DecimalFormat("0.000",comma);
            String sd;
            
            x1=this.xTransformation(i*maxT/10);
            x2=this.xTransformation(i*maxT/10);
            y1=this.ys-1;
            y2=this.ys+1;
            g2.setColor(Color.BLACK);
            g2.setStroke(new BasicStroke(1));
            g2.drawLine(x1, y1, x2, y2);
            sd=Places.format(i*maxT/10.);
            g2.setColor(Color.BLACK);
            g2.drawString(sd, x2, ys+20);
            
            x1=this.xs-1;
            x2=this.xs+1;
            y1=this.yTransformation(i*maxA/10);
            y2=this.yTransformation(i*maxA/10);
            g2.setColor(Color.BLACK);
            g2.setStroke(new BasicStroke(1));
            g2.drawLine(x1, y1, x2, y2);
            sd=Places.format(i*maxA/10.);
            g2.setColor(Color.BLACK);
            g2.drawString(sd, xs-50, y1);
        }
        
        if(theStructure!=null){
            int stories=theStructure.getNumDOFS();
            for(int i=1; i<=stories; i++){
                core.spec tempSpectrum = new core.spec();
                tempSpectrum.setPeriods(periods);
                tempSpectrum.setAccelerations(accel);
                
                x1=this.xTransformation(theStructure.getEigPeriod(i));
                x2=this.xTransformation(theStructure.getEigPeriod(i));
                y1=this.yTransformation(0.);
                y2=this.yTransformation(tempSpectrum.getAccel(theStructure.getEigPeriod(i)));
                
                g2.setColor(Color.YELLOW);
                g2.setStroke(new BasicStroke(1));
                g2.drawLine(x1, y1, x2, y2);
                DecimalFormatSymbols comma =new DecimalFormatSymbols();
                comma.setDecimalSeparator('.');
                DecimalFormat Places = new DecimalFormat("0.000",comma);
                String sd;
                sd=Places.format(theStructure.getEigPeriod(i));
                g2.setColor(Color.BLACK);
                g2.drawString("T"+i+"="+sd, x2, y2-20);
                
                x1=this.xTransformation(0.0);
                x2=this.xTransformation(theStructure.getEigPeriod(i));
                y1=this.yTransformation(tempSpectrum.getAccel(theStructure.getEigPeriod(i)));
                y2=this.yTransformation(tempSpectrum.getAccel(theStructure.getEigPeriod(i)));
                
                g2.setColor(Color.YELLOW);
                g2.setStroke(new BasicStroke(1));
                g2.drawLine(x1, y1, x2, y2);
                sd=Places.format(tempSpectrum.getAccel(theStructure.getEigPeriod(i)));
                g2.setColor(Color.BLACK);
                g2.drawString("Sa"+i+"="+sd, x2, y2);
            }
        }
        
        for(int i=0; i<nrows-1; i++){
            x1=this.xTransformation(periods[i]);
            x2=this.xTransformation(periods[i+1]);
            y1=this.yTransformation(accel[i]);
            y2=this.yTransformation(accel[i+1]);

            g2.setColor(Color.RED);
            g2.setStroke(new BasicStroke(1));
            g2.drawLine(x1, y1, x2, y2);
        }
    }
    
    private double maxAcc(){
        double max=0.;
        DefaultTableModel tableModel = (DefaultTableModel) jTable1.getModel();
        int nrows = tableModel.getRowCount();
        for(int i=0; i<nrows; i++){
            if(Double.parseDouble(tableModel.getValueAt(i, 1).toString())>max){
                max=Double.parseDouble(tableModel.getValueAt(i, 1).toString());
            }
        }
        return max;
    }
    
    private double maxPeriod(){
        double max=0.;
        DefaultTableModel tableModel = (DefaultTableModel) jTable1.getModel();
        int nrows = tableModel.getRowCount();
        for(int i=0; i<nrows; i++){
            if(Double.parseDouble(tableModel.getValueAt(i, 0).toString())>max){
                max=Double.parseDouble(tableModel.getValueAt(i, 0).toString());
            }
        }
        if(theStructure!=null){
            if(theStructure.getEigPeriod(1)>max){max=theStructure.getEigPeriod(1);}
            if(theStructure.getNumDOFS()>1)if(theStructure.getEigPeriod(2)>max){max=theStructure.getEigPeriod(2);}
            if(theStructure.getNumDOFS()>2)if(theStructure.getEigPeriod(3)>max){max=theStructure.getEigPeriod(3);}
        }
        return max;
    }

}
