/*
 * MainGUI.java
 * a) Oloklirosi tou input force
 * b) xekatharisma tou xronou kinisis Dt
 * Created on 3 Ιούνιος 2008, 8:15 πμ
 */

package gui;

import Jama.Matrix;
import core.FunctionParser;
import core.StoreyElement;
import core.Node;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Image;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.text.DecimalFormat;
import java.text.DecimalFormatSymbols;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import javax.swing.AbstractButton;
import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.ButtonModel;
import javax.swing.DefaultComboBoxModel;
import javax.swing.ImageIcon;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JRadioButtonMenuItem;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.table.DefaultTableModel;
import misc.BareBonesBrowserLaunch;
import java.util.Locale;
import java.util.ResourceBundle;
import javax.swing.JComboBox;

/**
 *
 * @author  pchr
 */
public class MainGUI extends javax.swing.JFrame {
    private core.Structure theStructure=null;
    private core.spec theSpectrum;
    private core.Ground theGround;
    private FunctionParser theFParser;
    private core.SpecCalc theSpecCalc=null;
    private double dt;
    private double TotalT;
    private double[] f0,f1,f2,f3,fb;
    private double[] f0_interp,f1_interp,f2_interp,f3_interp;
    private double[] u0,u1,u2,u3;
    private double[] v0,v1,v2,v3;
    private double[] a0,a1,a2,a3;
    private double u0init,u1init,u2init,u3init;
    private double v0init,v1init,v2init,v3init;
    private File File1,File2,File3,FileBase;
    private double tmp1,tmp2,tmp3,tmp4,tmp5,tmp6;
    DefaultComboBoxModel listModel;
    DefaultComboBoxModel initlistModel;
    
    JRadioButtonMenuItem SpecPlot;
    JRadioButtonMenuItem RespPlot;
    
    JRadioButtonMenuItem EnglishLang;
    JRadioButtonMenuItem GreekLang;
    JRadioButtonMenuItem SpanishLang;
    
    String lang="en";
    Locale local;
    String langb="misc.bundle";
    ResourceBundle resb; 

    /** Creates new form MainGUI */
    public MainGUI() {
        String[] listOfThings = new String[3];
        listOfThings[0]="English";
        listOfThings[1]="Ελληνικά";
        listOfThings[2]="Español";
        JComboBox<String> box = new JComboBox<>(listOfThings);
        box.setEditable(false);
        JOptionPane.showMessageDialog(null, box, "dynasoft: choose language", JOptionPane.QUESTION_MESSAGE); // this method blocks
        switch(box.getSelectedIndex()){
            case 1: lang="gr"; langb="misc.bundle_gr"; break;
            case 2: lang="es"; langb="misc.bundle_es"; break;
            default: lang="en"; langb="misc.bundle_en"; break;
        }
        
//        System.out.println("You chose " + listOfThings[box.getSelectedIndex()]);
        local=new Locale(lang);
        resb = ResourceBundle.getBundle("misc.bundle", local);
        
        
        EnglishLang = new JRadioButtonMenuItem(resb.getString("EnglishLang"));
        GreekLang = new JRadioButtonMenuItem(resb.getString("GreekLang"));
        SpanishLang = new JRadioButtonMenuItem(resb.getString("SpanishLang"));
        
        EnglishLang.setEnabled(false);
        GreekLang.setEnabled(false);
        SpanishLang.setEnabled(false);
        ButtonGroup LangGroup = new ButtonGroup();
        EnglishLang.setToolTipText(resb.getString("msg_077"));
        GreekLang.setToolTipText(resb.getString("msg_077"));
        SpanishLang.setToolTipText(resb.getString("msg_077"));
        LangGroup.add(EnglishLang);
        LangGroup.add(GreekLang);
        LangGroup.add(SpanishLang);
        if(lang.equalsIgnoreCase("en"))EnglishLang.setSelected(true);
        if(lang.equalsIgnoreCase("gr"))GreekLang.setSelected(true);
        if(lang.equalsIgnoreCase("es"))SpanishLang.setSelected(true);
        
        SpecPlot = new JRadioButtonMenuItem(resb.getString("plot_specs"));
        RespPlot = new JRadioButtonMenuItem(resb.getString("plot_response"));
        ButtonGroup ViewGroup = new ButtonGroup();
        ViewGroup.add(SpecPlot);
        ViewGroup.add(RespPlot);
        RespPlot.setSelected(true);
        
        //////////////
        initlistModel = new DefaultComboBoxModel();
        initlistModel.addElement(resb.getString("Time"));
        initlistModel.addElement(resb.getString("External_Force")+" 0");
        initlistModel.addElement(resb.getString("External_Force")+" 1");
        initlistModel.addElement(resb.getString("External_Force")+" 2");
        initlistModel.addElement(resb.getString("External_Force")+" 3");
        initlistModel.addElement(resb.getString("Displacement")+" 0");
        initlistModel.addElement(resb.getString("Displacement")+" 1");
        initlistModel.addElement(resb.getString("Displacement")+" 2");
        initlistModel.addElement(resb.getString("Displacement")+" 3");
        initlistModel.addElement(resb.getString("Velocity")+" 0");
        initlistModel.addElement(resb.getString("Velocity")+" 1");
        initlistModel.addElement(resb.getString("Velocity")+" 2");
        initlistModel.addElement(resb.getString("Velocity")+" 3");
        initlistModel.addElement(resb.getString("Acceleration")+" 0");
        initlistModel.addElement(resb.getString("Acceleration")+" 1");
        initlistModel.addElement(resb.getString("Acceleration")+" 2");
        initlistModel.addElement(resb.getString("Acceleration")+" 3");
        initlistModel.addElement(resb.getString("Elastic_Force")+" 0");
        initlistModel.addElement(resb.getString("Elastic_Force")+" 1");
        initlistModel.addElement(resb.getString("Elastic_Force")+" 2");
        initlistModel.addElement(resb.getString("Elastic_Force")+" 3");
        initlistModel.addElement(resb.getString("Inertial_Force")+" 0");
        initlistModel.addElement(resb.getString("Inertial_Force")+" 1");
        initlistModel.addElement(resb.getString("Inertial_Force")+" 2");
        initlistModel.addElement(resb.getString("Inertial_Force")+" 3");
        initlistModel.addElement(resb.getString("Damping_Force")+" 0");
        initlistModel.addElement(resb.getString("Damping_Force")+" 1");
        initlistModel.addElement(resb.getString("Damping_Force")+" 2");
        initlistModel.addElement(resb.getString("Damping_Force")+" 3");
        
        listModel = new DefaultComboBoxModel();
        listModel.addElement(resb.getString("Time"));
        listModel.addElement(resb.getString("External_Force")+" 0");
        listModel.addElement(resb.getString("External_Force")+" 1");
        listModel.addElement(resb.getString("External_Force")+" 2");
        listModel.addElement(resb.getString("External_Force")+" 3");
        listModel.addElement(resb.getString("Displacement")+" 0");
        listModel.addElement(resb.getString("Displacement")+" 1");
        listModel.addElement(resb.getString("Displacement")+" 2");
        listModel.addElement(resb.getString("Displacement")+" 3");
        listModel.addElement(resb.getString("Velocity")+" 0");
        listModel.addElement(resb.getString("Velocity")+" 1");
        listModel.addElement(resb.getString("Velocity")+" 2");
        listModel.addElement(resb.getString("Velocity")+" 3");
        listModel.addElement(resb.getString("Acceleration")+" 0");
        listModel.addElement(resb.getString("Acceleration")+" 1");
        listModel.addElement(resb.getString("Acceleration")+" 2");
        listModel.addElement(resb.getString("Acceleration")+" 3");
        listModel.addElement(resb.getString("Elastic_Force")+" 0");
        listModel.addElement(resb.getString("Elastic_Force")+" 1");
        listModel.addElement(resb.getString("Elastic_Force")+" 2");
        listModel.addElement(resb.getString("Elastic_Force")+" 3");
        listModel.addElement(resb.getString("Inertial_Force")+" 0");
        listModel.addElement(resb.getString("Inertial_Force")+" 1");
        listModel.addElement(resb.getString("Inertial_Force")+" 2");
        listModel.addElement(resb.getString("Inertial_Force")+" 3");
        listModel.addElement(resb.getString("Damping_Force")+" 0");
        listModel.addElement(resb.getString("Damping_Force")+" 1");
        listModel.addElement(resb.getString("Damping_Force")+" 2");
        listModel.addElement(resb.getString("Damping_Force")+" 3");
        //////////////
        initComponents();
        
        ChangeListener PlotChangeListener = new ChangeListener() {
            @Override
            public void stateChanged(ChangeEvent changEvent) {
                ButtonModel aModel = SpecPlot.getModel();
                if(aModel.isPressed())if(aModel.isSelected()){
                    initlistModel = new DefaultComboBoxModel();
                    initlistModel.addElement(resb.getString("Time"));
                    initlistModel.addElement(resb.getString("eigenperiod"));

                    jComboBox3.setModel(initlistModel);
                    jComboBox3.setSelectedIndex(0);

                    listModel = new DefaultComboBoxModel();
                    listModel.addElement(resb.getString("Acceleration"));
                    listModel.addElement(resb.getString("Spectral")+" "+resb.getString("Displacement"));
                    listModel.addElement(resb.getString("Spectral")+" "+resb.getString("Velocity"));
                    listModel.addElement(resb.getString("Spectral")+" "+resb.getString("Acceleration"));
                    jComboBox4.setModel(listModel);
                    jComboBox4.setSelectedIndex(0);

                    jButton_play.setEnabled(false);
                    jButton_stop.setEnabled(false);
                    jButton_left.setEnabled(false);
                    jButton_right.setEnabled(false);
                    jSlider2.setEnabled(false);
                    
                    if(theSpecCalc!=null){
                        jComboBox3.setEnabled(true);
                        jComboBox4.setEnabled(true);
                        drawPanelGraph1.plot();
                    }else{
                        jComboBox3.setEnabled(false);
                        jComboBox4.setEnabled(false);
                    }
                }
                aModel = RespPlot.getModel();
                if(aModel.isPressed())if(aModel.isSelected()){
                    initlistModel = new DefaultComboBoxModel();
                    initlistModel.addElement(resb.getString("Time"));
                    initlistModel.addElement(resb.getString("External_Force")+" 0");
                    initlistModel.addElement(resb.getString("External_Force")+" 1");
                    initlistModel.addElement(resb.getString("External_Force")+" 2");
                    initlistModel.addElement(resb.getString("External_Force")+" 3");
                    initlistModel.addElement(resb.getString("Displacement")+" 0");
                    initlistModel.addElement(resb.getString("Displacement")+" 1");
                    initlistModel.addElement(resb.getString("Displacement")+" 2");
                    initlistModel.addElement(resb.getString("Displacement")+" 3");
                    initlistModel.addElement(resb.getString("Velocity")+" 0");
                    initlistModel.addElement(resb.getString("Velocity")+" 1");
                    initlistModel.addElement(resb.getString("Velocity")+" 2");
                    initlistModel.addElement(resb.getString("Velocity")+" 3");
                    initlistModel.addElement(resb.getString("Acceleration")+" 0");
                    initlistModel.addElement(resb.getString("Acceleration")+" 1");
                    initlistModel.addElement(resb.getString("Acceleration")+" 2");
                    initlistModel.addElement(resb.getString("Acceleration")+" 3");
                    initlistModel.addElement(resb.getString("Elastic_Force")+" 0");
                    initlistModel.addElement(resb.getString("Elastic_Force")+" 1");
                    initlistModel.addElement(resb.getString("Elastic_Force")+" 2");
                    initlistModel.addElement(resb.getString("Elastic_Force")+" 3");
                    initlistModel.addElement(resb.getString("Inertial_Force")+" 0");
                    initlistModel.addElement(resb.getString("Inertial_Force")+" 1");
                    initlistModel.addElement(resb.getString("Inertial_Force")+" 2");
                    initlistModel.addElement(resb.getString("Inertial_Force")+" 3");
                    initlistModel.addElement(resb.getString("Damping_Force")+" 0");
                    initlistModel.addElement(resb.getString("Damping_Force")+" 1");
                    initlistModel.addElement(resb.getString("Damping_Force")+" 2");
                    initlistModel.addElement(resb.getString("Damping_Force")+" 3");

                    jComboBox3.setModel(initlistModel);
                    jComboBox3.setSelectedIndex(0);

                    listModel = new DefaultComboBoxModel();
                    listModel.addElement(resb.getString("Time"));
                    listModel.addElement(resb.getString("External_Force")+" 0");
                    listModel.addElement(resb.getString("External_Force")+" 1");
                    listModel.addElement(resb.getString("External_Force")+" 2");
                    listModel.addElement(resb.getString("External_Force")+" 3");
                    listModel.addElement(resb.getString("Displacement")+" 0");
                    listModel.addElement(resb.getString("Displacement")+" 1");
                    listModel.addElement(resb.getString("Displacement")+" 2");
                    listModel.addElement(resb.getString("Displacement")+" 3");
                    listModel.addElement(resb.getString("Velocity")+" 0");
                    listModel.addElement(resb.getString("Velocity")+" 1");
                    listModel.addElement(resb.getString("Velocity")+" 2");
                    listModel.addElement(resb.getString("Velocity")+" 3");
                    listModel.addElement(resb.getString("Acceleration")+" 0");
                    listModel.addElement(resb.getString("Acceleration")+" 1");
                    listModel.addElement(resb.getString("Acceleration")+" 2");
                    listModel.addElement(resb.getString("Acceleration")+" 3");
                    listModel.addElement(resb.getString("Elastic_Force")+" 0");
                    listModel.addElement(resb.getString("Elastic_Force")+" 1");
                    listModel.addElement(resb.getString("Elastic_Force")+" 2");
                    listModel.addElement(resb.getString("Elastic_Force")+" 3");
                    listModel.addElement(resb.getString("Inertial_Force")+" 0");
                    listModel.addElement(resb.getString("Inertial_Force")+" 1");
                    listModel.addElement(resb.getString("Inertial_Force")+" 2");
                    listModel.addElement(resb.getString("Inertial_Force")+" 3");
                    listModel.addElement(resb.getString("Damping_Force")+" 0");
                    listModel.addElement(resb.getString("Damping_Force")+" 1");
                    listModel.addElement(resb.getString("Damping_Force")+" 2");
                    listModel.addElement(resb.getString("Damping_Force")+" 3");
                    jComboBox4.setModel(listModel);
                    jComboBox4.setSelectedIndex(6);

                    jButton_play.setEnabled(true);
                    jButton_stop.setEnabled(false);
                    jButton_left.setEnabled(true);
                    jButton_right.setEnabled(true);
                    jSlider2.setEnabled(false);
                    if(theStructure!=null){
                        jComboBox3.setEnabled(true);
                        jComboBox4.setEnabled(true);
                        drawPanelGraph1.plot();
                    }else{
                        jComboBox3.setEnabled(false);
                        jComboBox4.setEnabled(false);
                    }
                }
            }
        };
        
        SpecPlot.addChangeListener(PlotChangeListener);
        RespPlot.addChangeListener(PlotChangeListener);
        
        this.jMenu8.add(SpecPlot);
        this.jMenu8.add(RespPlot);
        
        this.jMenu9.add(EnglishLang);
        this.jMenu9.add(GreekLang);
        this.jMenu9.add(SpanishLang);
    
        drawPanelInput1.setSeeGraph(drawPanelGraph1);
        jSplitPane1.setDividerLocation(1100);
        jSplitPane3.setDividerLocation(500);
        jTextArea1.setBackground(new java.awt.Color(102, 102, 102));
        jTextArea1.setColumns(20);
        jTextArea1.setEditable(false);
        jTextArea1.setFont(new java.awt.Font("Arial", 0, 11));
        jTextArea1.setForeground(new java.awt.Color(102, 255, 0));
        jTextArea1.setRows(5);
        jTextArea1.setBackground(new java.awt.Color(102, 102, 102));
        jTextArea1.setColumns(20);
        jTextArea1.setEditable(false);
        jTextArea1.setFont(new java.awt.Font("Arial", 0, 11));
        jTextArea1.setForeground(new java.awt.Color(102, 255, 0));
        jTextArea1.setRows(5);
        
        theSpectrum = new core.spec();
        //specPanel1.setSpec(theSpectrum);
        specPanel1.setAccelTable(jTable_Spec);
        drawPanelInput1.start();
        
        jSlider2.addChangeListener(new SliderListener(drawPanelInput1));
        jSlider2.setBorder(BorderFactory.createTitledBorder(resb.getString("msg_053")));
        jSlider2.setMajorTickSpacing(20);
        jSlider2.setMinorTickSpacing(5);
        jSlider2.setPaintTicks(true);
        jSlider2.setPaintLabels(true);
        Dimension d =new Dimension(600, 350);
        ForceDialog_1.setSize(d);
        d =new Dimension(600, 500);
        this.StoreyDialog.setSize(d);
        d =new Dimension(500, 300);
        PlotDialog.setSize(d);
        d =new Dimension(250, 250);
        SDOFDialog.setSize(d);
        d =new Dimension(750, 200);
        this.InitialDialog_1.setSize(d);
        d =new Dimension(750, 150);
        this.InitialDialogSDOF.setSize(d);
        d =new Dimension(453, 385);
        this.SpecCalcDialog.setSize(d);
        d =new Dimension(520, 150);
        this.jDialogNewmark.setSize(d);
        d =new Dimension(800, 600);
        this.GroundDialog.setSize(d);
        
        drawPanelGraph1.setFrame(this);
        this.theFParser = new FunctionParser();
        u0init=0.0; u1init=0.0; u2init=0.0; u3init=0.0;
        v0init=0.0; v1init=0.0; v2init=0.0; v3init=0.0;
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        FrameDialog = new javax.swing.JDialog();
        jPanel2 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jTextField1 = new javax.swing.JTextField();
        jLabel11 = new javax.swing.JLabel();
        jTextField9 = new javax.swing.JTextField();
        jPanel4 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        jTextField2 = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        jTextField3 = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        jTextField4 = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        jTextField5 = new javax.swing.JTextField();
        jTextField6 = new javax.swing.JTextField();
        jTextField7 = new javax.swing.JTextField();
        jLabel29 = new javax.swing.JLabel();
        jTextField28 = new javax.swing.JTextField();
        jLabel30 = new javax.swing.JLabel();
        jTextField29 = new javax.swing.JTextField();
        jLabel31 = new javax.swing.JLabel();
        jTextField30 = new javax.swing.JTextField();
        jLabel32 = new javax.swing.JLabel();
        jTextField31 = new javax.swing.JTextField();
        jLabel33 = new javax.swing.JLabel();
        jTextField32 = new javax.swing.JTextField();
        jLabel34 = new javax.swing.JLabel();
        jTextField33 = new javax.swing.JTextField();
        jLabel8 = new javax.swing.JLabel();
        jTextField8 = new javax.swing.JTextField();
        jLabel9 = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        jCheckBox5 = new javax.swing.JCheckBox();
        jCheckBox6 = new javax.swing.JCheckBox();
        jCheckBox7 = new javax.swing.JCheckBox();
        jPanel11 = new javax.swing.JPanel();
        jButton3 = new javax.swing.JButton();
        jButton4 = new javax.swing.JButton();
        jLabel23 = new javax.swing.JLabel();
        jPanel5 = new javax.swing.JPanel();
        StiffRadioButton = new javax.swing.JRadioButton();
        FlexRadioButton = new javax.swing.JRadioButton();
        jPanel7 = new javax.swing.JPanel();
        jCheckBox8 = new javax.swing.JCheckBox();
        jLabel21 = new javax.swing.JLabel();
        jTextField15 = new javax.swing.JTextField();
        jLabel22 = new javax.swing.JLabel();
        jTextField16 = new javax.swing.JTextField();
        jLabel37 = new javax.swing.JLabel();
        jTextField36 = new javax.swing.JTextField();
        SpecDialog = new javax.swing.JDialog();
        jSplitPane2 = new javax.swing.JSplitPane();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTable_Spec = new javax.swing.JTable();
        specPanel1 = new gui.SpecPanel();
        jPanel3 = new javax.swing.JPanel();
        jButton13 = new javax.swing.JButton();
        jButton14 = new javax.swing.JButton();
        jButton15 = new javax.swing.JButton();
        jButton16 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        theFileChooser = new javax.swing.JFileChooser();
        ForceDialog_1 = new javax.swing.JDialog();
        jButton20 = new javax.swing.JButton();
        jButton21 = new javax.swing.JButton();
        jCheckBox1 = new javax.swing.JCheckBox();
        jButton26 = new javax.swing.JButton();
        jLabel18 = new javax.swing.JLabel();
        jPanel6 = new javax.swing.JPanel();
        jLabel12 = new javax.swing.JLabel();
        jLabel13 = new javax.swing.JLabel();
        jLabel14 = new javax.swing.JLabel();
        jTextField12 = new javax.swing.JTextField();
        jTextField11 = new javax.swing.JTextField();
        jTextField10 = new javax.swing.JTextField();
        jButton17 = new javax.swing.JButton();
        jButton18 = new javax.swing.JButton();
        jButton19 = new javax.swing.JButton();
        jLabel17 = new javax.swing.JLabel();
        jLabel16 = new javax.swing.JLabel();
        jLabel15 = new javax.swing.JLabel();
        jCheckBox2 = new javax.swing.JCheckBox();
        jCheckBox3 = new javax.swing.JCheckBox();
        jCheckBox4 = new javax.swing.JCheckBox();
        jLabel45 = new javax.swing.JLabel();
        jTextField25 = new javax.swing.JTextField();
        jLabel46 = new javax.swing.JLabel();
        jTextField26 = new javax.swing.JTextField();
        jLabelAngle = new javax.swing.JLabel();
        jTextFieldAngle = new javax.swing.JTextField();
        PlotDialog = new javax.swing.JDialog();
        jComboBox3 = new javax.swing.JComboBox();
        jComboBox4 = new javax.swing.JComboBox();
        jSlider2 = new javax.swing.JSlider();
        jButton_left = new javax.swing.JButton();
        jButton_right = new javax.swing.JButton();
        jButton_play = new javax.swing.JButton();
        jButton_stop = new javax.swing.JButton();
        SDOFDialog = new javax.swing.JDialog();
        jPanel1 = new javax.swing.JPanel();
        jLabel24 = new javax.swing.JLabel();
        jLabel25 = new javax.swing.JLabel();
        jLabel26 = new javax.swing.JLabel();
        jTextField17 = new javax.swing.JTextField();
        jTextField18 = new javax.swing.JTextField();
        jTextField19 = new javax.swing.JTextField();
        jPanel12 = new javax.swing.JPanel();
        jButton7 = new javax.swing.JButton();
        jButton10 = new javax.swing.JButton();
        StoreyDialog = new javax.swing.JDialog();
        jLabel27 = new javax.swing.JLabel();
        jLabel28 = new javax.swing.JLabel();
        jLabel38 = new javax.swing.JLabel();
        jLabel39 = new javax.swing.JLabel();
        jTextField20 = new javax.swing.JTextField();
        jTextField21 = new javax.swing.JTextField();
        jTextField22 = new javax.swing.JTextField();
        jTextField23 = new javax.swing.JTextField();
        jButton5 = new javax.swing.JButton();
        jButton6 = new javax.swing.JButton();
        jButton11 = new javax.swing.JButton();
        jButton12 = new javax.swing.JButton();
        jScrollPane3 = new javax.swing.JScrollPane();
        jScrollPane4 = new javax.swing.JScrollPane();
        jTable_Columns = new javax.swing.JTable();
        jLabel40 = new javax.swing.JLabel();
        jTextField24 = new javax.swing.JTextField();
        FlexRadioButtonStorey = new javax.swing.JRadioButton();
        StiffRadioButtonStorey = new javax.swing.JRadioButton();
        Symetry = new javax.swing.JCheckBox();
        jButton22 = new javax.swing.JButton();
        jLabel19 = new javax.swing.JLabel();
        jTextField39 = new javax.swing.JTextField();
        newStoreyElemDialog = new javax.swing.JDialog();
        jLabel41 = new javax.swing.JLabel();
        jTextField_newX = new javax.swing.JTextField();
        jLabel42 = new javax.swing.JLabel();
        jTextField_newY = new javax.swing.JTextField();
        jLabel43 = new javax.swing.JLabel();
        jTextField_newbx = new javax.swing.JTextField();
        jLabel44 = new javax.swing.JLabel();
        jTextField_newby = new javax.swing.JTextField();
        jButton23 = new javax.swing.JButton();
        jButton24 = new javax.swing.JButton();
        ForceDialogSDOF = new javax.swing.JDialog();
        jPanel8 = new javax.swing.JPanel();
        jLabelfsodf = new javax.swing.JLabel();
        jTextFieldfsdof = new javax.swing.JTextField();
        jButtonfsdof = new javax.swing.JButton();
        jCheckBoxsdof = new javax.swing.JCheckBox();
        jButtoncnlfsdof = new javax.swing.JButton();
        jButtonupdfsdof = new javax.swing.JButton();
        jLabel49 = new javax.swing.JLabel();
        jTextField27 = new javax.swing.JTextField();
        jLabel50 = new javax.swing.JLabel();
        jTextField37 = new javax.swing.JTextField();
        jLabelsdof = new javax.swing.JLabel();
        jDialogNewmark = new javax.swing.JDialog();
        jButton25 = new javax.swing.JButton();
        jButton27 = new javax.swing.JButton();
        jLabel47 = new javax.swing.JLabel();
        jTextFieldbeta = new javax.swing.JTextField();
        jLabel48 = new javax.swing.JLabel();
        jTextFieldgamma = new javax.swing.JTextField();
        jLabelSC7 = new javax.swing.JLabel();
        jTextFieldNewmark_dt = new javax.swing.JTextField();
        InitialDialog_1 = new javax.swing.JDialog();
        jPanel9 = new javax.swing.JPanel();
        jLabel20 = new javax.swing.JLabel();
        jLabel51 = new javax.swing.JLabel();
        jLabel52 = new javax.swing.JLabel();
        jTextField13 = new javax.swing.JTextField();
        jTextField14 = new javax.swing.JTextField();
        jTextField38 = new javax.swing.JTextField();
        jLabel58 = new javax.swing.JLabel();
        jLabel59 = new javax.swing.JLabel();
        jLabel60 = new javax.swing.JLabel();
        jTextField41 = new javax.swing.JTextField();
        jTextField42 = new javax.swing.JTextField();
        jTextField43 = new javax.swing.JTextField();
        jButton29 = new javax.swing.JButton();
        jButton28 = new javax.swing.JButton();
        InitialDialogSDOF = new javax.swing.JDialog();
        jPanel10 = new javax.swing.JPanel();
        jLabel53 = new javax.swing.JLabel();
        jTextField44 = new javax.swing.JTextField();
        jLabel61 = new javax.swing.JLabel();
        jTextField47 = new javax.swing.JTextField();
        jButton30 = new javax.swing.JButton();
        jButton31 = new javax.swing.JButton();
        SpecCalcDialog = new javax.swing.JDialog();
        jPanelSC1 = new javax.swing.JPanel();
        jLabelSC1 = new javax.swing.JLabel();
        jLabelSC2 = new javax.swing.JLabel();
        jTextFieldSC1 = new javax.swing.JTextField();
        jTextFieldSC2 = new javax.swing.JTextField();
        jLabelSC3 = new javax.swing.JLabel();
        jTextFieldSC3 = new javax.swing.JTextField();
        jLabelSC4 = new javax.swing.JLabel();
        jTextFieldSC4 = new javax.swing.JTextField();
        jButton1 = new javax.swing.JButton();
        jButton32 = new javax.swing.JButton();
        jPanel13 = new javax.swing.JPanel();
        FindFileButtonSC = new javax.swing.JButton();
        jLabelSC11 = new javax.swing.JLabel();
        jLabelSC5 = new javax.swing.JLabel();
        jTextFieldSC5 = new javax.swing.JTextField();
        jCheckBox12 = new javax.swing.JCheckBox();
        GroundDialog = new javax.swing.JDialog();
        jPanel14 = new javax.swing.JPanel();
        jButton8 = new javax.swing.JButton();
        jButton9 = new javax.swing.JButton();
        jPanel15 = new javax.swing.JPanel();
        jPanel19 = new javax.swing.JPanel();
        jLabel35 = new javax.swing.JLabel();
        jTextField34 = new javax.swing.JTextField();
        jLabel66 = new javax.swing.JLabel();
        jTextField53 = new javax.swing.JTextField();
        jLabel67 = new javax.swing.JLabel();
        jTextField54 = new javax.swing.JTextField();
        jPanel20 = new javax.swing.JPanel();
        jLabel63 = new javax.swing.JLabel();
        jTextField50 = new javax.swing.JTextField();
        jLabel64 = new javax.swing.JLabel();
        jTextField51 = new javax.swing.JTextField();
        jLabel65 = new javax.swing.JLabel();
        jTextField52 = new javax.swing.JTextField();
        jLabel68 = new javax.swing.JLabel();
        jTextField55 = new javax.swing.JTextField();
        jLabel69 = new javax.swing.JLabel();
        jTextField56 = new javax.swing.JTextField();
        jPanel16 = new javax.swing.JPanel();
        jCheckBox9 = new javax.swing.JCheckBox();
        jLabel36 = new javax.swing.JLabel();
        jTextField35 = new javax.swing.JTextField();
        jLabel54 = new javax.swing.JLabel();
        jTextField40 = new javax.swing.JTextField();
        jPanel17 = new javax.swing.JPanel();
        jTextField45 = new javax.swing.JTextField();
        jLabel55 = new javax.swing.JLabel();
        jTextField46 = new javax.swing.JTextField();
        jLabel56 = new javax.swing.JLabel();
        jCheckBox10 = new javax.swing.JCheckBox();
        jPanel18 = new javax.swing.JPanel();
        jTextField48 = new javax.swing.JTextField();
        jLabel57 = new javax.swing.JLabel();
        jTextField49 = new javax.swing.JTextField();
        jLabel62 = new javax.swing.JLabel();
        jCheckBox11 = new javax.swing.JCheckBox();
        jSplitPane1 = new javax.swing.JSplitPane();
        drawPanelInput1 = new gui.DrawPanelInput();
        jSplitPane3 = new javax.swing.JSplitPane();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextArea1 = new gui.myTextArea();
        drawPanelGraph1 = new gui.DrawPanelGraph();
        jMenuBar1 = new javax.swing.JMenuBar();
        jMenu1 = new javax.swing.JMenu();
        jMenu6 = new javax.swing.JMenu();
        jMenuItem2 = new javax.swing.JMenuItem();
        jMenuItem3 = new javax.swing.JMenuItem();
        jMenuItem4 = new javax.swing.JMenuItem();
        jMenuItem1 = new javax.swing.JMenuItem();
        jMenuItem14 = new javax.swing.JMenuItem();
        jMenu7 = new javax.swing.JMenu();
        jMenuItem7 = new javax.swing.JMenuItem();
        jMenuItem10 = new javax.swing.JMenuItem();
        jMenuItem8 = new javax.swing.JMenuItem();
        jMenu2 = new javax.swing.JMenu();
        jMenuItem11 = new javax.swing.JMenuItem();
        jMenuItem12 = new javax.swing.JMenuItem();
        jMenu3 = new javax.swing.JMenu();
        jMenu8 = new javax.swing.JMenu();
        jMenu9 = new javax.swing.JMenu();
        jMenu4 = new javax.swing.JMenu();
        jMenuItem9 = new javax.swing.JMenuItem();
        jMenu5 = new javax.swing.JMenu();
        jMenuItem5 = new javax.swing.JMenuItem();
        jMenuItem6 = new javax.swing.JMenuItem();
        jMenuItem13 = new javax.swing.JMenuItem();

        FrameDialog.setTitle(resb.getString("msg_034"));
        FrameDialog.setLocationByPlatform(true);
        FrameDialog.setMinimumSize(new java.awt.Dimension(1220, 650));

        jLabel1.setText(resb.getString("msg_035"));

        jTextField1.setText("2.9e7");

        jLabel11.setText(resb.getString("Damping_ratio_z"));

        jTextField9.setText("0");

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel1)
                    .addComponent(jLabel11, javax.swing.GroupLayout.PREFERRED_SIZE, 121, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jTextField9, javax.swing.GroupLayout.PREFERRED_SIZE, 48, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jTextField1, javax.swing.GroupLayout.PREFERRED_SIZE, 100, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel2Layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {jTextField1, jTextField9});

        jPanel2Layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {jLabel1, jLabel11});

        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jTextField1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel11)
                    .addComponent(jTextField9, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jLabel2.setText("m1");

        jTextField2.setText("20.0");

        jLabel3.setText("m2");

        jTextField3.setText("20.0");

        jLabel4.setText("m3");

        jTextField4.setText("20.0");

        jLabel5.setText("b1");

        jLabel6.setText("b2");

        jLabel7.setText("b3");

        jTextField5.setText("0.35");

        jTextField6.setText("0.35");

        jTextField7.setText("0.35");

        jLabel29.setText("d1");

        jTextField28.setText("0.35");

        jLabel30.setText("d2");

        jTextField29.setText("0.35");

        jLabel31.setText("d3");

        jTextField30.setText("0.35");

        jLabel32.setText("h1");

        jTextField31.setText("3.0");

        jLabel33.setText("h2");

        jTextField32.setText("3.0");

        jLabel34.setText("h3");

        jTextField33.setText("3.0");

        jLabel8.setText("L");

        jTextField8.setText("5.0");

        jLabel9.setText(resb.getString("msg_036"));

        jLabel10.setText("!  I=b*d^3/12");

        jCheckBox5.setSelected(true);
        jCheckBox5.setEnabled(false);

        jCheckBox6.setSelected(true);
        jCheckBox6.setEnabled(false);
        jCheckBox6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox6ActionPerformed(evt);
            }
        });

        jCheckBox7.setSelected(true);
        jCheckBox7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox7ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jCheckBox5)
                    .addComponent(jCheckBox6)
                    .addComponent(jCheckBox7))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addComponent(jLabel2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jTextField2, javax.swing.GroupLayout.PREFERRED_SIZE, 64, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jLabel5)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jTextField7, javax.swing.GroupLayout.PREFERRED_SIZE, 64, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jLabel29)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jTextField28, javax.swing.GroupLayout.PREFERRED_SIZE, 64, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel32)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jTextField31, javax.swing.GroupLayout.PREFERRED_SIZE, 64, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap())
                    .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(jPanel4Layout.createSequentialGroup()
                            .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                .addGroup(jPanel4Layout.createSequentialGroup()
                                    .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                        .addGroup(jPanel4Layout.createSequentialGroup()
                                            .addComponent(jLabel3)
                                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                            .addComponent(jTextField3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                        .addGroup(jPanel4Layout.createSequentialGroup()
                                            .addComponent(jLabel4)
                                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                            .addComponent(jTextField4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                    .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                        .addGroup(jPanel4Layout.createSequentialGroup()
                                            .addComponent(jLabel6)
                                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                            .addComponent(jTextField6, javax.swing.GroupLayout.PREFERRED_SIZE, 64, javax.swing.GroupLayout.PREFERRED_SIZE))
                                        .addGroup(jPanel4Layout.createSequentialGroup()
                                            .addComponent(jLabel7)
                                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                            .addComponent(jTextField5, javax.swing.GroupLayout.PREFERRED_SIZE, 64, javax.swing.GroupLayout.PREFERRED_SIZE)))
                                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                    .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                        .addGroup(jPanel4Layout.createSequentialGroup()
                                            .addComponent(jLabel30)
                                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                            .addComponent(jTextField29, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                        .addGroup(jPanel4Layout.createSequentialGroup()
                                            .addComponent(jLabel31)
                                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                            .addComponent(jTextField30, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                    .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                        .addGroup(jPanel4Layout.createSequentialGroup()
                                            .addComponent(jLabel33)
                                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                            .addComponent(jTextField32, javax.swing.GroupLayout.PREFERRED_SIZE, 64, javax.swing.GroupLayout.PREFERRED_SIZE))
                                        .addGroup(jPanel4Layout.createSequentialGroup()
                                            .addComponent(jLabel34)
                                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                            .addComponent(jTextField33, javax.swing.GroupLayout.PREFERRED_SIZE, 64, javax.swing.GroupLayout.PREFERRED_SIZE))))
                                .addGroup(jPanel4Layout.createSequentialGroup()
                                    .addComponent(jLabel8)
                                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                    .addComponent(jTextField8, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                    .addComponent(jLabel9, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                            .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addGroup(jPanel4Layout.createSequentialGroup()
                            .addComponent(jLabel10, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addGap(116, 116, 116)))))
        );

        jPanel4Layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {jTextField2, jTextField3, jTextField4, jTextField5, jTextField6, jTextField7, jTextField8});

        jPanel4Layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {jTextField28, jTextField29, jTextField30, jTextField31, jTextField32, jTextField33});

        jPanel4Layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {jLabel4, jLabel8});

        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jCheckBox5)
                    .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(jLabel2)
                        .addComponent(jTextField2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(jLabel5)
                        .addComponent(jTextField7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(jLabel29)
                        .addComponent(jTextField28, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(jLabel32)
                        .addComponent(jTextField31, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGap(5, 5, 5)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel4Layout.createSequentialGroup()
                                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                    .addComponent(jLabel3)
                                    .addComponent(jTextField3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                    .addComponent(jLabel4)
                                    .addComponent(jTextField4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                            .addGroup(jPanel4Layout.createSequentialGroup()
                                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                    .addComponent(jLabel6)
                                    .addComponent(jTextField6, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                    .addComponent(jLabel7)
                                    .addComponent(jTextField5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                            .addGroup(jPanel4Layout.createSequentialGroup()
                                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                    .addComponent(jLabel30)
                                    .addComponent(jTextField29, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                    .addComponent(jLabel31)
                                    .addComponent(jTextField30, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                            .addGroup(jPanel4Layout.createSequentialGroup()
                                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                    .addComponent(jLabel33)
                                    .addComponent(jTextField32, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                    .addComponent(jLabel34)
                                    .addComponent(jTextField33, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel8)
                            .addComponent(jTextField8, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel9, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jLabel10, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addComponent(jCheckBox6)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jCheckBox7)))
                .addContainerGap(24, Short.MAX_VALUE))
        );

        jPanel4Layout.linkSize(javax.swing.SwingConstants.VERTICAL, new java.awt.Component[] {jTextField2, jTextField3, jTextField4, jTextField5, jTextField6, jTextField7});

        jPanel11.setBorder(javax.swing.BorderFactory.createEmptyBorder(1, 1, 1, 1));

        jButton3.setText(resb.getString("cancel"));
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });

        jButton4.setText(resb.getString("update"));
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel11Layout = new javax.swing.GroupLayout(jPanel11);
        jPanel11.setLayout(jPanel11Layout);
        jPanel11Layout.setHorizontalGroup(
            jPanel11Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel11Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jButton3)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton4)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel11Layout.setVerticalGroup(
            jPanel11Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel11Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                .addComponent(jButton3)
                .addComponent(jButton4))
        );

        jPanel11Layout.linkSize(javax.swing.SwingConstants.VERTICAL, new java.awt.Component[] {jButton3, jButton4});

        jLabel23.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel23.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/D2.png"))); // NOI18N

        StiffRadioButton.setSelected(true);
        StiffRadioButton.setText(resb.getString("msg_038"));
        StiffRadioButton.setToolTipText("πλήρως δύσκαμπτες δοκοί");
        StiffRadioButton.setFocusPainted(false);
        StiffRadioButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                StiffRadioButtonActionPerformed(evt);
            }
        });

        FlexRadioButton.setText(resb.getString("msg_039"));
        FlexRadioButton.setToolTipText("πλήρως εύκαμπτες δοκοί");
        FlexRadioButton.setFocusPainted(false);
        FlexRadioButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                FlexRadioButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel5Layout = new javax.swing.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addGap(16, 16, 16)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(StiffRadioButton)
                    .addComponent(FlexRadioButton))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(StiffRadioButton)
                .addGap(3, 3, 3)
                .addComponent(FlexRadioButton)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jCheckBox8.setText(resb.getString("msg_037"));
        jCheckBox8.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox8ActionPerformed(evt);
            }
        });

        jLabel21.setText("Kb");
        jLabel21.setEnabled(false);

        jTextField15.setText("1000.0");
        jTextField15.setEnabled(false);

        jLabel22.setText("ζb(%)");
        jLabel22.setEnabled(false);

        jTextField16.setText("0");
        jTextField16.setEnabled(false);

        jLabel37.setText("Mb");
        jLabel37.setEnabled(false);

        jTextField36.setText("0.0");
        jTextField36.setEnabled(false);

        javax.swing.GroupLayout jPanel7Layout = new javax.swing.GroupLayout(jPanel7);
        jPanel7.setLayout(jPanel7Layout);
        jPanel7Layout.setHorizontalGroup(
            jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel7Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jCheckBox8)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jLabel21)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jTextField15, javax.swing.GroupLayout.PREFERRED_SIZE, 64, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel22)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jTextField16, javax.swing.GroupLayout.PREFERRED_SIZE, 64, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel37)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jTextField36, javax.swing.GroupLayout.PREFERRED_SIZE, 64, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(142, Short.MAX_VALUE))
        );
        jPanel7Layout.setVerticalGroup(
            jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel7Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(jLabel21)
                        .addComponent(jTextField15, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(jLabel22)
                        .addComponent(jTextField16, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(jLabel37)
                        .addComponent(jTextField36, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jCheckBox8))
                .addContainerGap(13, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout FrameDialogLayout = new javax.swing.GroupLayout(FrameDialog.getContentPane());
        FrameDialog.getContentPane().setLayout(FrameDialogLayout);
        FrameDialogLayout.setHorizontalGroup(
            FrameDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(FrameDialogLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(FrameDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(jPanel7, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel5, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel4, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel2, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel11, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED, 207, Short.MAX_VALUE)
                .addComponent(jLabel23, javax.swing.GroupLayout.PREFERRED_SIZE, 596, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(151, Short.MAX_VALUE))
        );
        FrameDialogLayout.setVerticalGroup(
            FrameDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(FrameDialogLayout.createSequentialGroup()
                .addGap(8, 8, 8)
                .addGroup(FrameDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel23, javax.swing.GroupLayout.PREFERRED_SIZE, 493, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(FrameDialogLayout.createSequentialGroup()
                        .addComponent(jPanel4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(jPanel5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jPanel7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jPanel11, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(46, Short.MAX_VALUE))
        );

        SpecDialog.setTitle(ResourceBundle.getBundle("misc.bundle", local).getString("msg_106"));
        SpecDialog.setMinimumSize(new java.awt.Dimension(1220, 650));
        SpecDialog.setModal(true);

        jTable_Spec.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jScrollPane2.setViewportView(jTable_Spec);

        jSplitPane2.setRightComponent(jScrollPane2);

        javax.swing.GroupLayout specPanel1Layout = new javax.swing.GroupLayout(specPanel1);
        specPanel1.setLayout(specPanel1Layout);
        specPanel1Layout.setHorizontalGroup(
            specPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );
        specPanel1Layout.setVerticalGroup(
            specPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 425, Short.MAX_VALUE)
        );

        jSplitPane2.setLeftComponent(specPanel1);

        SpecDialog.getContentPane().add(jSplitPane2, java.awt.BorderLayout.CENTER);

        jButton13.setText(ResourceBundle.getBundle("misc.bundle", local).getString("File"));
        jButton13.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton13ActionPerformed(evt);
            }
        });

        jButton14.setText(ResourceBundle.getBundle("misc.bundle", local).getString("msg_105"));
        jButton14.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton14ActionPerformed(evt);
            }
        });

        jButton15.setText(ResourceBundle.getBundle("misc.bundle", local).getString("update"));
        jButton15.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton15ActionPerformed(evt);
            }
        });

        jButton16.setText(ResourceBundle.getBundle("misc.bundle", local).getString("cancel"));
        jButton16.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton16ActionPerformed(evt);
            }
        });

        jButton2.setText(ResourceBundle.getBundle("misc.bundle", local).getString("msg_104"));
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addGap(18, 18, 18)
                .addComponent(jButton13)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jButton2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton14)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton15)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton16)
                .addContainerGap(175, Short.MAX_VALUE))
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addGap(36, 36, 36)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton13)
                    .addComponent(jButton2)
                    .addComponent(jButton14)
                    .addComponent(jButton15)
                    .addComponent(jButton16))
                .addContainerGap(41, Short.MAX_VALUE))
        );

        SpecDialog.getContentPane().add(jPanel3, java.awt.BorderLayout.SOUTH);

        ForceDialog_1.setTitle(ResourceBundle.getBundle("misc.bundle", local).getString("msg_091"));
        ForceDialog_1.setAlwaysOnTop(true);
        ForceDialog_1.setLocationByPlatform(true);

        jButton20.setText(ResourceBundle.getBundle("misc.bundle", local).getString("update"));
        jButton20.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton20ActionPerformed(evt);
            }
        });

        jButton21.setText(ResourceBundle.getBundle("misc.bundle", local).getString("cancel"));
        jButton21.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton21ActionPerformed(evt);
            }
        });

        jCheckBox1.setText(ResourceBundle.getBundle("misc.bundle", local).getString("msg_092"));
        jCheckBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox1ActionPerformed(evt);
            }
        });

        jButton26.setText(ResourceBundle.getBundle("misc.bundle", local).getString("File"));
        jButton26.setEnabled(false);
        jButton26.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton26ActionPerformed(evt);
            }
        });

        jLabel18.setText(".......");

        jLabel12.setText(ResourceBundle.getBundle("misc.bundle", local).getString("msg_094"));

        jLabel13.setText(ResourceBundle.getBundle("misc.bundle", local).getString("msg_095"));

        jLabel14.setText(ResourceBundle.getBundle("misc.bundle", local).getString("msg_096"));

        jTextField12.setText("0.0");

        jTextField11.setText("cos(10*t)");

        jTextField10.setText("sin(t)");

        jButton17.setText(ResourceBundle.getBundle("misc.bundle", local).getString("File")+" (1)");
        jButton17.setEnabled(false);
        jButton17.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton17ActionPerformed(evt);
            }
        });

        jButton18.setText(ResourceBundle.getBundle("misc.bundle", local).getString("File")+" (2)");
        jButton18.setEnabled(false);
        jButton18.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton18ActionPerformed(evt);
            }
        });

        jButton19.setText(ResourceBundle.getBundle("misc.bundle", local).getString("File")+" (3)");
        jButton19.setEnabled(false);
        jButton19.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton19ActionPerformed(evt);
            }
        });

        jLabel17.setText(".......");

        jLabel16.setText(".......");

        jLabel15.setText(".......");

        jCheckBox2.setSelected(true);
        jCheckBox2.setText(ResourceBundle.getBundle("misc.bundle", local).getString("analytical")+" (1)");
        jCheckBox2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox2ActionPerformed(evt);
            }
        });

        jCheckBox3.setSelected(true);
        jCheckBox3.setText(ResourceBundle.getBundle("misc.bundle", local).getString("analytical")+" (2)");
        jCheckBox3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox3ActionPerformed(evt);
            }
        });

        jCheckBox4.setSelected(true);
        jCheckBox4.setText(ResourceBundle.getBundle("misc.bundle", local).getString("analytical")+" (3)");
        jCheckBox4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox4ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel6Layout = new javax.swing.GroupLayout(jPanel6);
        jPanel6.setLayout(jPanel6Layout);
        jPanel6Layout.setHorizontalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel6Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel14)
                    .addComponent(jLabel13)
                    .addComponent(jLabel12))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jCheckBox2)
                    .addComponent(jCheckBox3)
                    .addComponent(jCheckBox4))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jTextField10, javax.swing.GroupLayout.PREFERRED_SIZE, 94, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jTextField11, javax.swing.GroupLayout.PREFERRED_SIZE, 102, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jTextField12, javax.swing.GroupLayout.PREFERRED_SIZE, 102, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel6Layout.createSequentialGroup()
                        .addComponent(jButton17)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel15, javax.swing.GroupLayout.PREFERRED_SIZE, 286, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel6Layout.createSequentialGroup()
                        .addComponent(jButton18)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel16, javax.swing.GroupLayout.PREFERRED_SIZE, 286, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel6Layout.createSequentialGroup()
                        .addComponent(jButton19)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel17, javax.swing.GroupLayout.PREFERRED_SIZE, 286, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );

        jPanel6Layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {jTextField10, jTextField11, jTextField12});

        jPanel6Layout.setVerticalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel6Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel6Layout.createSequentialGroup()
                        .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jTextField10, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jButton17)
                            .addComponent(jLabel15))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jButton18)
                            .addComponent(jLabel16)
                            .addComponent(jTextField11, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jCheckBox3)
                            .addComponent(jLabel13))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jTextField12, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jButton19)
                            .addComponent(jLabel17)
                            .addComponent(jCheckBox4)
                            .addComponent(jLabel14)))
                    .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(jCheckBox2)
                        .addComponent(jLabel12)))
                .addContainerGap(13, Short.MAX_VALUE))
        );

        jLabel45.setText(ResourceBundle.getBundle("misc.bundle", local).getString("discrTimeStep"));

        jTextField25.setText("0.01");

        jLabel46.setText(ResourceBundle.getBundle("misc.bundle", local).getString("total_time"));

        jTextField26.setText("10.5");

        jLabelAngle.setText(ResourceBundle.getBundle("misc.bundle", local).getString("msg_093"));
        jLabelAngle.setEnabled(false);

        jTextFieldAngle.setText("0.0");
        jTextFieldAngle.setEnabled(false);

        javax.swing.GroupLayout ForceDialog_1Layout = new javax.swing.GroupLayout(ForceDialog_1.getContentPane());
        ForceDialog_1.getContentPane().setLayout(ForceDialog_1Layout);
        ForceDialog_1Layout.setHorizontalGroup(
            ForceDialog_1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(ForceDialog_1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(ForceDialog_1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel6, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(ForceDialog_1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                        .addGroup(ForceDialog_1Layout.createSequentialGroup()
                            .addComponent(jButton21)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                            .addComponent(jButton20))
                        .addGroup(ForceDialog_1Layout.createSequentialGroup()
                            .addComponent(jCheckBox1)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                            .addComponent(jButton26)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                            .addComponent(jLabel18, javax.swing.GroupLayout.PREFERRED_SIZE, 286, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(ForceDialog_1Layout.createSequentialGroup()
                        .addGroup(ForceDialog_1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, ForceDialog_1Layout.createSequentialGroup()
                                .addComponent(jLabelAngle)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jTextFieldAngle, javax.swing.GroupLayout.PREFERRED_SIZE, 79, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, ForceDialog_1Layout.createSequentialGroup()
                                .addComponent(jLabel45)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(jTextField25, javax.swing.GroupLayout.PREFERRED_SIZE, 79, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addGap(18, 18, 18)
                        .addComponent(jLabel46)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jTextField26, javax.swing.GroupLayout.PREFERRED_SIZE, 79, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(455, Short.MAX_VALUE))
        );
        ForceDialog_1Layout.setVerticalGroup(
            ForceDialog_1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(ForceDialog_1Layout.createSequentialGroup()
                .addComponent(jPanel6, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(ForceDialog_1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jCheckBox1)
                    .addComponent(jButton26)
                    .addComponent(jLabel18))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(ForceDialog_1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabelAngle)
                    .addComponent(jTextFieldAngle, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(ForceDialog_1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel45)
                    .addComponent(jTextField25, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel46)
                    .addComponent(jTextField26, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(ForceDialog_1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton21)
                    .addComponent(jButton20))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        PlotDialog.setTitle("plot parameters");
        PlotDialog.setAlwaysOnTop(true);

        jComboBox3.setModel(initlistModel);
        jComboBox3.setToolTipText(resb.getString("Y_Param"));
        jComboBox3.setEnabled(false);
        jComboBox3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox3ActionPerformed(evt);
            }
        });

        jComboBox4.setModel(listModel);
        jComboBox4.setToolTipText(resb.getString("X_Param"));
        jComboBox4.setEnabled(false);
        jComboBox4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox4ActionPerformed(evt);
            }
        });

        jSlider2.setEnabled(false);
        jSlider2.setPreferredSize(new java.awt.Dimension(400, 80));

        jButton_left.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/06.png"))); // NOI18N
        jButton_left.setToolTipText("σχεδίαση προηγούμενης ιδιομορφής");
        jButton_left.setEnabled(false);
        jButton_left.setMaximumSize(new java.awt.Dimension(28, 28));
        jButton_left.setMinimumSize(new java.awt.Dimension(28, 28));
        jButton_left.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton_leftActionPerformed(evt);
            }
        });

        jButton_right.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/05.png"))); // NOI18N
        jButton_right.setToolTipText("σχεδίαση επόμενης ιδιομορφής");
        jButton_right.setEnabled(false);
        jButton_right.setMaximumSize(new java.awt.Dimension(28, 28));
        jButton_right.setMinimumSize(new java.awt.Dimension(28, 28));
        jButton_right.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton_rightActionPerformed(evt);
            }
        });

        jButton_play.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/play_1.png"))); // NOI18N
        jButton_play.setToolTipText("εκκίνηση κινούμενου σχεδίου ");
        jButton_play.setEnabled(false);
        jButton_play.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton_playActionPerformed(evt);
            }
        });

        jButton_stop.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/stop.png"))); // NOI18N
        jButton_stop.setToolTipText("παύση κινούμενου σχεδίου ");
        jButton_stop.setEnabled(false);
        jButton_stop.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton_stopActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout PlotDialogLayout = new javax.swing.GroupLayout(PlotDialog.getContentPane());
        PlotDialog.getContentPane().setLayout(PlotDialogLayout);
        PlotDialogLayout.setHorizontalGroup(
            PlotDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(PlotDialogLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(PlotDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jSlider2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(PlotDialogLayout.createSequentialGroup()
                        .addComponent(jComboBox3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jComboBox4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(PlotDialogLayout.createSequentialGroup()
                        .addComponent(jButton_left, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jButton_right, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton_play)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton_stop)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        PlotDialogLayout.setVerticalGroup(
            PlotDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(PlotDialogLayout.createSequentialGroup()
                .addGroup(PlotDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jComboBox3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jComboBox4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(PlotDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jButton_stop)
                    .addComponent(jButton_play)
                    .addGroup(PlotDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                        .addComponent(jButton_right, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(jButton_left, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGap(7, 7, 7)
                .addComponent(jSlider2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );

        jButton_play.getAccessibleContext().setAccessibleDescription("");
        jButton_stop.getAccessibleContext().setAccessibleDescription("");

        SDOFDialog.setAlwaysOnTop(true);

        jLabel24.setText("Stiffness k");
        jLabel24.setMaximumSize(new java.awt.Dimension(94, 17));
        jLabel24.setMinimumSize(new java.awt.Dimension(94, 17));

        jLabel25.setText("mass m");
        jLabel25.setMaximumSize(new java.awt.Dimension(94, 17));
        jLabel25.setMinimumSize(new java.awt.Dimension(94, 17));

        jLabel26.setText("damping ζ(%)");

        jTextField17.setText("100.0");
        jTextField17.setMaximumSize(new java.awt.Dimension(94, 27));
        jTextField17.setMinimumSize(new java.awt.Dimension(94, 27));

        jTextField18.setText("10.0");
        jTextField18.setMaximumSize(new java.awt.Dimension(94, 27));
        jTextField18.setMinimumSize(new java.awt.Dimension(94, 27));

        jTextField19.setText("0.0");
        jTextField19.setMaximumSize(new java.awt.Dimension(94, 27));
        jTextField19.setMinimumSize(new java.awt.Dimension(94, 27));

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel24, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel25, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel26))
                .addGap(18, 18, 18)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jTextField18, javax.swing.GroupLayout.PREFERRED_SIZE, 94, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jTextField19, javax.swing.GroupLayout.PREFERRED_SIZE, 94, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jTextField17, javax.swing.GroupLayout.PREFERRED_SIZE, 94, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(370, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel24, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jTextField17, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel25, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jTextField18, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel26)
                    .addComponent(jTextField19, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(93, 93, 93))
        );

        jPanel12.setBorder(javax.swing.BorderFactory.createEmptyBorder(1, 1, 1, 1));

        jButton7.setText(ResourceBundle.getBundle("misc.bundle", local).getString("cancel"));
        jButton7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton7ActionPerformed(evt);
            }
        });

        jButton10.setText(ResourceBundle.getBundle("misc.bundle", local).getString("update"));
        jButton10.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton10ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel12Layout = new javax.swing.GroupLayout(jPanel12);
        jPanel12.setLayout(jPanel12Layout);
        jPanel12Layout.setHorizontalGroup(
            jPanel12Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel12Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jButton7)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton10)
                .addContainerGap(362, Short.MAX_VALUE))
        );
        jPanel12Layout.setVerticalGroup(
            jPanel12Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel12Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                .addComponent(jButton7)
                .addComponent(jButton10))
        );

        javax.swing.GroupLayout SDOFDialogLayout = new javax.swing.GroupLayout(SDOFDialog.getContentPane());
        SDOFDialog.getContentPane().setLayout(SDOFDialogLayout);
        SDOFDialogLayout.setHorizontalGroup(
            SDOFDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jPanel12, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        SDOFDialogLayout.setVerticalGroup(
            SDOFDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, SDOFDialogLayout.createSequentialGroup()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, 146, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel12, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(66, Short.MAX_VALUE))
        );

        StoreyDialog.setTitle("καθορισμός κτιρίου");
        StoreyDialog.setLocationByPlatform(true);
        StoreyDialog.setMinimumSize(new java.awt.Dimension(800, 400));
        StoreyDialog.setResizable(false);

        jLabel27.setText("Lx (m)");
        jLabel27.setToolTipText("τα Lx, Ly χρησιμοποιούνται για τον υπολογισμό της μάζας του κτιρίου και για γραφικούς λόγους");

        jLabel28.setText("Ly (m)");
        jLabel28.setToolTipText("τα Lx, Ly χρησιμοποιούνται για τον υπολογισμό της μάζας του κτιρίου και για γραφικούς λόγους");

        jLabel38.setText("μ (tn/m^2)");

        jLabel39.setText("E (kN/m^2)");

        jTextField20.setText("35.0");
        jTextField20.setToolTipText("τα Lx, Ly χρησιμοποιούνται για τον υπολογισμό της μάζας του κτιρίου και για γραφικούς λόγους");
        jTextField20.setPreferredSize(new java.awt.Dimension(50, 27));

        jTextField21.setText("20.0");
        jTextField21.setToolTipText("τα Lx, Ly χρησιμοποιούνται για τον υπολογισμό της μάζας του κτιρίου και για γραφικούς λόγους");
        jTextField21.setPreferredSize(new java.awt.Dimension(50, 27));

        jTextField22.setText("1.0");
        jTextField22.setPreferredSize(new java.awt.Dimension(50, 27));

        jTextField23.setText("2.9E7");

        jButton5.setText(resb.getString("msg_019"));
        jButton5.setToolTipText("τα κατακόρυφα στοιχεία συνεισφέρουν στη δυσκαμψία ακόμα και αν βρίσκονται εκτός της επιφάνειας της πλάκας");
        jButton5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton5ActionPerformed(evt);
            }
        });

        jButton6.setText(resb.getString("msg_020"));
        jButton6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton6ActionPerformed(evt);
            }
        });

        jButton11.setText(resb.getString("cancel"));
        jButton11.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton11ActionPerformed(evt);
            }
        });

        jButton12.setText(resb.getString("update"));
        jButton12.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton12ActionPerformed(evt);
            }
        });

        jTable_Columns.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jScrollPane4.setViewportView(jTable_Columns);

        jScrollPane3.setViewportView(jScrollPane4);

        jLabel40.setText("h (m)");

        jTextField24.setText("3.5");
        jTextField24.setPreferredSize(new java.awt.Dimension(50, 27));

        FlexRadioButtonStorey.setSelected(true);
        FlexRadioButtonStorey.setText(resb.getString("msg_015"));
        FlexRadioButtonStorey.setToolTipText("πλήρως εύκαμπτη πλάκα");
        FlexRadioButtonStorey.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                FlexRadioButtonStoreyActionPerformed(evt);
            }
        });

        StiffRadioButtonStorey.setText(resb.getString("msg_016"));
        StiffRadioButtonStorey.setToolTipText("πλήρως δύσκαμπτη πλάκα");
        StiffRadioButtonStorey.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                StiffRadioButtonStoreyActionPerformed(evt);
            }
        });

        Symetry.setText(resb.getString("msg_017"));

        jButton22.setText(resb.getString("msg_018"));
        jButton22.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton22ActionPerformed(evt);
            }
        });

        jLabel19.setText(resb.getString("Damping_ratio_z"));

        jTextField39.setText("0");
        jTextField39.setPreferredSize(new java.awt.Dimension(50, 27));

        javax.swing.GroupLayout StoreyDialogLayout = new javax.swing.GroupLayout(StoreyDialog.getContentPane());
        StoreyDialog.getContentPane().setLayout(StoreyDialogLayout);
        StoreyDialogLayout.setHorizontalGroup(
            StoreyDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(StoreyDialogLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(StoreyDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(StoreyDialogLayout.createSequentialGroup()
                        .addGroup(StoreyDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(StoreyDialogLayout.createSequentialGroup()
                                .addComponent(FlexRadioButtonStorey)
                                .addGap(18, 18, Short.MAX_VALUE))
                            .addGroup(StoreyDialogLayout.createSequentialGroup()
                                .addComponent(jLabel27)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(jTextField20, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(10, 10, 10))
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, StoreyDialogLayout.createSequentialGroup()
                                .addGroup(StoreyDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                    .addGroup(StoreyDialogLayout.createSequentialGroup()
                                        .addComponent(jLabel19, javax.swing.GroupLayout.PREFERRED_SIZE, 194, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 18, Short.MAX_VALUE)
                                        .addComponent(jTextField39, javax.swing.GroupLayout.PREFERRED_SIZE, 48, javax.swing.GroupLayout.PREFERRED_SIZE))
                                    .addGroup(StoreyDialogLayout.createSequentialGroup()
                                        .addComponent(jLabel40)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .addComponent(jTextField24, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE))
                                    .addGroup(StoreyDialogLayout.createSequentialGroup()
                                        .addGroup(StoreyDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addComponent(jLabel39)
                                            .addComponent(jLabel38))
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .addGroup(StoreyDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addComponent(jTextField23, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE)
                                            .addComponent(jTextField22, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                                    .addGroup(StoreyDialogLayout.createSequentialGroup()
                                        .addComponent(jLabel28)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .addComponent(jTextField21, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)))
                        .addComponent(jScrollPane3, javax.swing.GroupLayout.PREFERRED_SIZE, 479, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(StiffRadioButtonStorey)
                    .addComponent(Symetry)
                    .addComponent(jButton22)
                    .addGroup(StoreyDialogLayout.createSequentialGroup()
                        .addComponent(jButton5)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jButton6)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jButton11)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jButton12)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        StoreyDialogLayout.setVerticalGroup(
            StoreyDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(StoreyDialogLayout.createSequentialGroup()
                .addGroup(StoreyDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(StoreyDialogLayout.createSequentialGroup()
                        .addGroup(StoreyDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, StoreyDialogLayout.createSequentialGroup()
                                .addContainerGap()
                                .addComponent(jScrollPane3, 0, 0, Short.MAX_VALUE))
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, StoreyDialogLayout.createSequentialGroup()
                                .addGap(17, 17, 17)
                                .addGroup(StoreyDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                    .addComponent(jLabel40)
                                    .addGroup(StoreyDialogLayout.createSequentialGroup()
                                        .addGroup(StoreyDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                            .addComponent(jTextField20, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                            .addComponent(jLabel27))
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addGroup(StoreyDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                            .addComponent(jLabel28)
                                            .addComponent(jTextField21, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addGroup(StoreyDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                            .addComponent(jTextField22, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                            .addComponent(jLabel38))
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addGroup(StoreyDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addComponent(jTextField23, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                            .addComponent(jLabel39))
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(jTextField24, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addGroup(StoreyDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                    .addComponent(jLabel19)
                                    .addComponent(jTextField39, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addGap(38, 38, 38)))
                        .addGap(70, 70, 70))
                    .addGroup(StoreyDialogLayout.createSequentialGroup()
                        .addGap(0, 0, Short.MAX_VALUE)
                        .addComponent(FlexRadioButtonStorey)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(StiffRadioButtonStorey)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(Symetry)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton22)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(StoreyDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton5)
                    .addComponent(jButton6)
                    .addComponent(jButton11)
                    .addComponent(jButton12))
                .addGap(144, 144, 144))
        );

        newStoreyElemDialog.setTitle("εισαγωγή κτακόρυφου στοιχείου");
        newStoreyElemDialog.setAlwaysOnTop(true);
        newStoreyElemDialog.setLocationByPlatform(true);
        newStoreyElemDialog.setMinimumSize(new java.awt.Dimension(350, 200));
        newStoreyElemDialog.setModal(true);
        newStoreyElemDialog.setResizable(false);

        jLabel41.setText("x (m)");

        jTextField_newX.setText("0.0");
        jTextField_newX.setMinimumSize(new java.awt.Dimension(32, 27));

        jLabel42.setText("y (m)");

        jTextField_newY.setText("0.0");
        jTextField_newY.setMinimumSize(new java.awt.Dimension(32, 27));

        jLabel43.setText("bx (m)");

        jTextField_newbx.setText("0.45");
        jTextField_newbx.setMinimumSize(new java.awt.Dimension(32, 27));
        jTextField_newbx.setPreferredSize(new java.awt.Dimension(32, 27));

        jLabel44.setText("by (m)");

        jTextField_newby.setText("1.5");
        jTextField_newby.setMinimumSize(new java.awt.Dimension(32, 27));

        jButton23.setText("ακύρωση");
        jButton23.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton23ActionPerformed(evt);
            }
        });

        jButton24.setText("ενημέρωση");
        jButton24.setToolTipText("τα κατακόρυφα στοιχεία συνεισφέρουν στη δυσκαμψία ακόμα και αν βρίσκονται εκτός της επιφανειας της πλακας");
        jButton24.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton24ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout newStoreyElemDialogLayout = new javax.swing.GroupLayout(newStoreyElemDialog.getContentPane());
        newStoreyElemDialog.getContentPane().setLayout(newStoreyElemDialogLayout);
        newStoreyElemDialogLayout.setHorizontalGroup(
            newStoreyElemDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(newStoreyElemDialogLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(newStoreyElemDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(newStoreyElemDialogLayout.createSequentialGroup()
                        .addComponent(jLabel44)
                        .addGap(18, 18, 18)
                        .addComponent(jTextField_newby, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addGroup(newStoreyElemDialogLayout.createSequentialGroup()
                        .addComponent(jLabel43)
                        .addGap(18, 18, 18)
                        .addComponent(jTextField_newbx, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addGroup(newStoreyElemDialogLayout.createSequentialGroup()
                        .addGroup(newStoreyElemDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel42)
                            .addComponent(jLabel41))
                        .addGap(27, 27, 27)
                        .addGroup(newStoreyElemDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jTextField_newX, javax.swing.GroupLayout.PREFERRED_SIZE, 65, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jTextField_newY, javax.swing.GroupLayout.PREFERRED_SIZE, 65, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addGap(30, 30, 30)
                .addGroup(newStoreyElemDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jButton24, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jButton23, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addGap(170, 170, 170))
        );
        newStoreyElemDialogLayout.setVerticalGroup(
            newStoreyElemDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(newStoreyElemDialogLayout.createSequentialGroup()
                .addGap(20, 20, 20)
                .addGroup(newStoreyElemDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel41)
                    .addComponent(jTextField_newX, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton23))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(newStoreyElemDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel42)
                    .addComponent(jTextField_newY, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton24))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(newStoreyElemDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel43)
                    .addComponent(jTextField_newbx, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(newStoreyElemDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel44)
                    .addComponent(jTextField_newby, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(171, Short.MAX_VALUE))
        );

        newStoreyElemDialog.getAccessibleContext().setAccessibleName("εισαγωγή κατακόρυφου στοιχείου");

        ForceDialogSDOF.setTitle(ResourceBundle.getBundle("misc.bundle", local).getString("msg_091"));
        ForceDialogSDOF.setMinimumSize(new java.awt.Dimension(650, 200));

        jLabelfsodf.setText(ResourceBundle.getBundle("misc.bundle", local).getString("ext_load_function"));

        jTextFieldfsdof.setText("sin(t)");

        jButtonfsdof.setText(ResourceBundle.getBundle("misc.bundle", local).getString("File"));
        jButtonfsdof.setEnabled(false);
        jButtonfsdof.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonfsdofActionPerformed(evt);
            }
        });

        jCheckBoxsdof.setSelected(true);
        jCheckBoxsdof.setText(ResourceBundle.getBundle("misc.bundle", local).getString("analytical"));
        jCheckBoxsdof.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxsdofActionPerformed(evt);
            }
        });

        jButtoncnlfsdof.setText(ResourceBundle.getBundle("misc.bundle", local).getString("cancel"));
        jButtoncnlfsdof.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtoncnlfsdofActionPerformed(evt);
            }
        });

        jButtonupdfsdof.setText(ResourceBundle.getBundle("misc.bundle", local).getString("update"));
        jButtonupdfsdof.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonupdfsdofActionPerformed(evt);
            }
        });

        jLabel49.setText(ResourceBundle.getBundle("misc.bundle", local).getString("discrTimeStep"));

        jTextField27.setText("0.01");

        jLabel50.setText(ResourceBundle.getBundle("misc.bundle", local).getString("total_time"));

        jTextField37.setText("10.5");

        jLabelsdof.setText(".......");

        javax.swing.GroupLayout jPanel8Layout = new javax.swing.GroupLayout(jPanel8);
        jPanel8.setLayout(jPanel8Layout);
        jPanel8Layout.setHorizontalGroup(
            jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel8Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                        .addGroup(jPanel8Layout.createSequentialGroup()
                            .addComponent(jButtoncnlfsdof)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                            .addComponent(jButtonupdfsdof))
                        .addGroup(jPanel8Layout.createSequentialGroup()
                            .addComponent(jLabelfsodf)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                            .addComponent(jCheckBoxsdof)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                            .addComponent(jTextFieldfsdof, javax.swing.GroupLayout.PREFERRED_SIZE, 94, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGap(14, 14, 14)
                            .addComponent(jButtonfsdof)))
                    .addGroup(jPanel8Layout.createSequentialGroup()
                        .addComponent(jLabel49)
                        .addGap(18, 18, 18)
                        .addComponent(jTextField27, javax.swing.GroupLayout.PREFERRED_SIZE, 79, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jLabel50)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jTextField37, javax.swing.GroupLayout.PREFERRED_SIZE, 79, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabelsdof, javax.swing.GroupLayout.PREFERRED_SIZE, 64, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(113, Short.MAX_VALUE))
        );
        jPanel8Layout.setVerticalGroup(
            jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel8Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(jTextFieldfsdof, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(jButtonfsdof)
                        .addComponent(jLabelsdof))
                    .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(jCheckBoxsdof)
                        .addComponent(jLabelfsodf)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel49)
                    .addComponent(jTextField27, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel50)
                    .addComponent(jTextField37, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 14, Short.MAX_VALUE)
                .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButtoncnlfsdof)
                    .addComponent(jButtonupdfsdof)))
        );

        javax.swing.GroupLayout ForceDialogSDOFLayout = new javax.swing.GroupLayout(ForceDialogSDOF.getContentPane());
        ForceDialogSDOF.getContentPane().setLayout(ForceDialogSDOFLayout);
        ForceDialogSDOFLayout.setHorizontalGroup(
            ForceDialogSDOFLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(ForceDialogSDOFLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel8, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        ForceDialogSDOFLayout.setVerticalGroup(
            ForceDialogSDOFLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(ForceDialogSDOFLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel8, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jDialogNewmark.setMinimumSize(new java.awt.Dimension(500, 150));

        jButton25.setText(ResourceBundle.getBundle("misc.bundle", local).getString("cancel"));
        jButton25.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton25ActionPerformed(evt);
            }
        });

        jButton27.setText(ResourceBundle.getBundle("misc.bundle", local).getString("update"));
        jButton27.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton27ActionPerformed(evt);
            }
        });

        jLabel47.setText(ResourceBundle.getBundle("misc.bundle", local).getString("msg_103")+" β");

        jTextFieldbeta.setText("0.25");

        jLabel48.setText(ResourceBundle.getBundle("misc.bundle", local).getString("msg_103")+" γ");

        jTextFieldgamma.setText("0.5");

        jLabelSC7.setText(ResourceBundle.getBundle("misc.bundle", local).getString("discrTimeStep")+" δt");
        jLabelSC7.setToolTipText("<=Δt");

        jTextFieldNewmark_dt.setText("0.01");
        jTextFieldNewmark_dt.setToolTipText("<=Δt");
        jTextFieldNewmark_dt.setMinimumSize(new java.awt.Dimension(32, 27));
        jTextFieldNewmark_dt.setPreferredSize(new java.awt.Dimension(32, 27));

        javax.swing.GroupLayout jDialogNewmarkLayout = new javax.swing.GroupLayout(jDialogNewmark.getContentPane());
        jDialogNewmark.getContentPane().setLayout(jDialogNewmarkLayout);
        jDialogNewmarkLayout.setHorizontalGroup(
            jDialogNewmarkLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jDialogNewmarkLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jDialogNewmarkLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jDialogNewmarkLayout.createSequentialGroup()
                        .addComponent(jLabelSC7)
                        .addGap(18, 18, 18)
                        .addComponent(jTextFieldNewmark_dt, javax.swing.GroupLayout.PREFERRED_SIZE, 49, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(26, 26, 26)
                        .addComponent(jButton25)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton27))
                    .addGroup(jDialogNewmarkLayout.createSequentialGroup()
                        .addComponent(jLabel47)
                        .addGap(18, 18, 18)
                        .addComponent(jTextFieldbeta, javax.swing.GroupLayout.PREFERRED_SIZE, 79, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(jLabel48)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jTextFieldgamma, javax.swing.GroupLayout.PREFERRED_SIZE, 79, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jDialogNewmarkLayout.setVerticalGroup(
            jDialogNewmarkLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jDialogNewmarkLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jDialogNewmarkLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel47)
                    .addComponent(jTextFieldbeta, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel48)
                    .addComponent(jTextFieldgamma, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jDialogNewmarkLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jDialogNewmarkLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(jLabelSC7)
                        .addComponent(jTextFieldNewmark_dt, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jDialogNewmarkLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(jButton25)
                        .addComponent(jButton27)))
                .addContainerGap(76, Short.MAX_VALUE))
        );

        InitialDialog_1.setTitle(ResourceBundle.getBundle("misc.bundle", local).getString("msg_082"));
        InitialDialog_1.setAlwaysOnTop(true);
        InitialDialog_1.setLocationByPlatform(true);

        jLabel20.setText(ResourceBundle.getBundle("misc.bundle", local).getString("msg_085"));

        jLabel51.setText(ResourceBundle.getBundle("misc.bundle", local).getString("msg_086"));

        jLabel52.setText(ResourceBundle.getBundle("misc.bundle", local).getString("msg_087"));

        jTextField13.setText("0.0");

        jTextField14.setText("0.0");

        jTextField38.setText("0.0");

        jLabel58.setText(ResourceBundle.getBundle("misc.bundle", local).getString("msg_084")+ResourceBundle.getBundle("misc.bundle", local).getString("msg_085")+" 1");

        jLabel59.setText(ResourceBundle.getBundle("misc.bundle", local).getString("msg_084")+ResourceBundle.getBundle("misc.bundle", local).getString("msg_085")+" 2");

        jLabel60.setText(ResourceBundle.getBundle("misc.bundle", local).getString("msg_084")+ResourceBundle.getBundle("misc.bundle", local).getString("msg_085")+" 3");

        jTextField41.setText("0.0");

        jTextField42.setText("0.0");

        jTextField43.setText("0.0");

        jButton29.setText(ResourceBundle.getBundle("misc.bundle", local).getString("cancel"));
        jButton29.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton29ActionPerformed(evt);
            }
        });

        jButton28.setText(ResourceBundle.getBundle("misc.bundle", local).getString("update"));
        jButton28.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton28ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel9Layout = new javax.swing.GroupLayout(jPanel9);
        jPanel9.setLayout(jPanel9Layout);
        jPanel9Layout.setHorizontalGroup(
            jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel9Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(jPanel9Layout.createSequentialGroup()
                        .addComponent(jButton29)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton28))
                    .addGroup(jPanel9Layout.createSequentialGroup()
                        .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel52)
                            .addComponent(jLabel51)
                            .addComponent(jLabel20))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jTextField14)
                            .addComponent(jTextField13)
                            .addComponent(jTextField38, javax.swing.GroupLayout.PREFERRED_SIZE, 102, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(18, 18, 18)
                        .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel60)
                            .addComponent(jLabel59)
                            .addComponent(jLabel58))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jTextField42)
                            .addComponent(jTextField41)
                            .addComponent(jTextField43, javax.swing.GroupLayout.PREFERRED_SIZE, 102, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap(198, Short.MAX_VALUE))
        );
        jPanel9Layout.setVerticalGroup(
            jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel9Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel9Layout.createSequentialGroup()
                        .addComponent(jTextField43, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jTextField42, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel59))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jTextField41, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel60)))
                    .addComponent(jLabel58)
                    .addGroup(jPanel9Layout.createSequentialGroup()
                        .addComponent(jTextField38, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jTextField14, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel51))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jTextField13, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel52)))
                    .addComponent(jLabel20))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton29)
                    .addComponent(jButton28))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout InitialDialog_1Layout = new javax.swing.GroupLayout(InitialDialog_1.getContentPane());
        InitialDialog_1.getContentPane().setLayout(InitialDialog_1Layout);
        InitialDialog_1Layout.setHorizontalGroup(
            InitialDialog_1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(InitialDialog_1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel9, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(597, Short.MAX_VALUE))
        );
        InitialDialog_1Layout.setVerticalGroup(
            InitialDialog_1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(InitialDialog_1Layout.createSequentialGroup()
                .addComponent(jPanel9, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(107, Short.MAX_VALUE))
        );

        InitialDialogSDOF.setTitle(ResourceBundle.getBundle("misc.bundle", local).getString("msg_082"));
        InitialDialogSDOF.setLocationByPlatform(true);

        jLabel53.setText(ResourceBundle.getBundle("misc.bundle", local).getString("msg_083"));

        jTextField44.setText("0.0");

        jLabel61.setText(ResourceBundle.getBundle("misc.bundle", local).getString("msg_084"));

        jTextField47.setText("0.0");

        jButton30.setText(ResourceBundle.getBundle("misc.bundle", local).getString("cancel"));
        jButton30.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton30ActionPerformed(evt);
            }
        });

        jButton31.setText(ResourceBundle.getBundle("misc.bundle", local).getString("update"));
        jButton31.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton31ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel10Layout = new javax.swing.GroupLayout(jPanel10);
        jPanel10.setLayout(jPanel10Layout);
        jPanel10Layout.setHorizontalGroup(
            jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel10Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(jPanel10Layout.createSequentialGroup()
                        .addComponent(jButton30)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton31))
                    .addGroup(jPanel10Layout.createSequentialGroup()
                        .addComponent(jLabel53)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jTextField44, javax.swing.GroupLayout.PREFERRED_SIZE, 102, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(jLabel61)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jTextField47, javax.swing.GroupLayout.PREFERRED_SIZE, 102, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(198, Short.MAX_VALUE))
        );
        jPanel10Layout.setVerticalGroup(
            jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel10Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jTextField47, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel61)
                    .addComponent(jTextField44, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel53))
                .addGap(18, 18, 18)
                .addGroup(jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton30)
                    .addComponent(jButton31))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout InitialDialogSDOFLayout = new javax.swing.GroupLayout(InitialDialogSDOF.getContentPane());
        InitialDialogSDOF.getContentPane().setLayout(InitialDialogSDOFLayout);
        InitialDialogSDOFLayout.setHorizontalGroup(
            InitialDialogSDOFLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(InitialDialogSDOFLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel10, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(597, Short.MAX_VALUE))
        );
        InitialDialogSDOFLayout.setVerticalGroup(
            InitialDialogSDOFLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(InitialDialogSDOFLayout.createSequentialGroup()
                .addComponent(jPanel10, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(107, Short.MAX_VALUE))
        );

        SpecCalcDialog.setAlwaysOnTop(true);

        jPanelSC1.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        jLabelSC1.setText(resb.getString("msg_066"));

        jLabelSC2.setText(resb.getString("msg_067"));

        jTextFieldSC1.setText("0.0");
        jTextFieldSC1.setMinimumSize(new java.awt.Dimension(32, 27));

        jTextFieldSC2.setText("4.5");
        jTextFieldSC2.setMinimumSize(new java.awt.Dimension(32, 27));

        jLabelSC3.setText(resb.getString("msg_068"));

        jTextFieldSC3.setText("400");
        jTextFieldSC3.setMinimumSize(new java.awt.Dimension(32, 27));
        jTextFieldSC3.setPreferredSize(new java.awt.Dimension(32, 27));

        jLabelSC4.setText(resb.getString("msg_069"));

        jTextFieldSC4.setText("2.0");
        jTextFieldSC4.setMinimumSize(new java.awt.Dimension(37, 27));

        javax.swing.GroupLayout jPanelSC1Layout = new javax.swing.GroupLayout(jPanelSC1);
        jPanelSC1.setLayout(jPanelSC1Layout);
        jPanelSC1Layout.setHorizontalGroup(
            jPanelSC1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanelSC1Layout.createSequentialGroup()
                .addGroup(jPanelSC1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanelSC1Layout.createSequentialGroup()
                        .addGroup(jPanelSC1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabelSC2)
                            .addComponent(jLabelSC3))
                        .addGap(81, 81, 81)
                        .addGroup(jPanelSC1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jTextFieldSC2, javax.swing.GroupLayout.DEFAULT_SIZE, 43, Short.MAX_VALUE)
                            .addComponent(jTextFieldSC3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                    .addGroup(jPanelSC1Layout.createSequentialGroup()
                        .addGroup(jPanelSC1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabelSC1)
                            .addComponent(jLabelSC4))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGroup(jPanelSC1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jTextFieldSC4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jTextFieldSC1, javax.swing.GroupLayout.DEFAULT_SIZE, 43, Short.MAX_VALUE))))
                .addGap(42, 42, 42))
        );
        jPanelSC1Layout.setVerticalGroup(
            jPanelSC1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelSC1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanelSC1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabelSC1)
                    .addComponent(jTextFieldSC1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanelSC1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabelSC2)
                    .addComponent(jTextFieldSC2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanelSC1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabelSC3)
                    .addComponent(jTextFieldSC3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanelSC1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabelSC4)
                    .addComponent(jTextFieldSC4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jButton1.setText(resb.getString("update"));
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jButton32.setText(resb.getString("cancel"));
        jButton32.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton32ActionPerformed(evt);
            }
        });

        jPanel13.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        FindFileButtonSC.setText(resb.getString("File"));
        FindFileButtonSC.setToolTipText("Αρχείο ιστορίας επιτάχυνσης βάσης:");
        FindFileButtonSC.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                FindFileButtonSCActionPerformed(evt);
            }
        });

        jLabelSC11.setText(resb.getString("msg_070"));

        jLabelSC5.setText(resb.getString("msg_071"));
        jLabelSC5.setToolTipText(">=δt");

        jTextFieldSC5.setText("0.01");
        jTextFieldSC5.setToolTipText(">=δt");
        jTextFieldSC5.setMinimumSize(new java.awt.Dimension(32, 27));
        jTextFieldSC5.setPreferredSize(new java.awt.Dimension(32, 27));

        jCheckBox12.setSelected(true);
        jCheckBox12.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox12ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel13Layout = new javax.swing.GroupLayout(jPanel13);
        jPanel13.setLayout(jPanel13Layout);
        jPanel13Layout.setHorizontalGroup(
            jPanel13Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel13Layout.createSequentialGroup()
                .addGroup(jPanel13Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel13Layout.createSequentialGroup()
                        .addComponent(FindFileButtonSC)
                        .addGap(18, 18, 18)
                        .addComponent(jLabelSC11, javax.swing.GroupLayout.DEFAULT_SIZE, 124, Short.MAX_VALUE))
                    .addGroup(jPanel13Layout.createSequentialGroup()
                        .addComponent(jCheckBox12)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabelSC5)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jTextFieldSC5, javax.swing.GroupLayout.PREFERRED_SIZE, 79, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        jPanel13Layout.setVerticalGroup(
            jPanel13Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel13Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel13Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(FindFileButtonSC)
                    .addComponent(jLabelSC11))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel13Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabelSC5)
                    .addComponent(jTextFieldSC5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jCheckBox12))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout SpecCalcDialogLayout = new javax.swing.GroupLayout(SpecCalcDialog.getContentPane());
        SpecCalcDialog.getContentPane().setLayout(SpecCalcDialogLayout);
        SpecCalcDialogLayout.setHorizontalGroup(
            SpecCalcDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(SpecCalcDialogLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(SpecCalcDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jPanelSC1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel13, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, SpecCalcDialogLayout.createSequentialGroup()
                        .addComponent(jButton32)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jButton1)))
                .addContainerGap(390, Short.MAX_VALUE))
        );
        SpecCalcDialogLayout.setVerticalGroup(
            SpecCalcDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(SpecCalcDialogLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanelSC1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jPanel13, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(45, 45, 45)
                .addGroup(SpecCalcDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton32)
                    .addComponent(jButton1))
                .addContainerGap(42, Short.MAX_VALUE))
        );

        GroundDialog.setAlwaysOnTop(true);

        jPanel14.setBorder(javax.swing.BorderFactory.createEmptyBorder(1, 1, 1, 1));

        jButton8.setText(resb.getString("cancel"));
        jButton8.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton8ActionPerformed(evt);
            }
        });

        jButton9.setText(resb.getString("update"));
        jButton9.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton9ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel14Layout = new javax.swing.GroupLayout(jPanel14);
        jPanel14.setLayout(jPanel14Layout);
        jPanel14Layout.setHorizontalGroup(
            jPanel14Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel14Layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jButton8)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton9)
                .addContainerGap())
        );
        jPanel14Layout.setVerticalGroup(
            jPanel14Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel14Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                .addComponent(jButton8)
                .addComponent(jButton9))
        );

        jLabel35.setText(resb.getString("msg_054"));

        jTextField34.setText("0.135");

        jLabel66.setText(resb.getString("msg_063"));

        jTextField53.setText("0.01");
        jTextField53.setPreferredSize(new java.awt.Dimension(50, 27));

        jLabel67.setText(resb.getString("msg_062"));

        jTextField54.setText("500");
        jTextField54.setPreferredSize(new java.awt.Dimension(50, 27));

        javax.swing.GroupLayout jPanel19Layout = new javax.swing.GroupLayout(jPanel19);
        jPanel19.setLayout(jPanel19Layout);
        jPanel19Layout.setHorizontalGroup(
            jPanel19Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel19Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel19Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel19Layout.createSequentialGroup()
                        .addComponent(jLabel35)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 31, Short.MAX_VALUE)
                        .addComponent(jTextField34, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel19Layout.createSequentialGroup()
                        .addComponent(jLabel66)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jTextField53, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel19Layout.createSequentialGroup()
                        .addComponent(jLabel67)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jTextField54, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        jPanel19Layout.setVerticalGroup(
            jPanel19Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel19Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel19Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTextField34, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel35))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel19Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTextField54, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel67))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel19Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTextField53, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel66))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jLabel63.setText(resb.getString("msg_058"));

        jTextField50.setText("20.00");

        jLabel64.setText(resb.getString("msg_059"));

        jTextField51.setText("10.00");

        jLabel65.setText(resb.getString("msg_060"));

        jTextField52.setText("50.00");

        jLabel68.setText("Ωα=");

        jTextField55.setText("1.200");
        jTextField55.setMinimumSize(new java.awt.Dimension(50, 27));

        jLabel69.setText("Ωβ=");

        jTextField56.setText("150.0");
        jTextField56.setMinimumSize(new java.awt.Dimension(50, 27));

        javax.swing.GroupLayout jPanel20Layout = new javax.swing.GroupLayout(jPanel20);
        jPanel20.setLayout(jPanel20Layout);
        jPanel20Layout.setHorizontalGroup(
            jPanel20Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel20Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel20Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel20Layout.createSequentialGroup()
                        .addComponent(jLabel68)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jTextField55, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel20Layout.createSequentialGroup()
                        .addComponent(jLabel63)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jTextField50, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel20Layout.createSequentialGroup()
                        .addComponent(jLabel64)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jTextField51, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel20Layout.createSequentialGroup()
                        .addComponent(jLabel69)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jTextField56, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel20Layout.createSequentialGroup()
                        .addComponent(jLabel65)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jTextField52, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel20Layout.setVerticalGroup(
            jPanel20Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel20Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel20Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel63)
                    .addComponent(jTextField50, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel20Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTextField51, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel64))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel20Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel65)
                    .addComponent(jTextField52, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel20Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel68)
                    .addComponent(jTextField55, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel20Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel69)
                    .addComponent(jTextField56, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout jPanel15Layout = new javax.swing.GroupLayout(jPanel15);
        jPanel15.setLayout(jPanel15Layout);
        jPanel15Layout.setHorizontalGroup(
            jPanel15Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel15Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel20, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(jPanel19, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel15Layout.setVerticalGroup(
            jPanel15Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel15Layout.createSequentialGroup()
                .addGroup(jPanel15Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jPanel19, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel20, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );

        jCheckBox9.setSelected(true);
        jCheckBox9.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox9ActionPerformed(evt);
            }
        });

        jLabel36.setText("ω1(Hz)=");

        jTextField35.setText("0.80");
        jTextField35.setPreferredSize(new java.awt.Dimension(50, 27));

        jLabel54.setText("ζ1(%)=");

        jTextField40.setText("100");

        javax.swing.GroupLayout jPanel16Layout = new javax.swing.GroupLayout(jPanel16);
        jPanel16.setLayout(jPanel16Layout);
        jPanel16Layout.setHorizontalGroup(
            jPanel16Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel16Layout.createSequentialGroup()
                .addComponent(jCheckBox9)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel36)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jTextField35, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jLabel54)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jTextField40, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, Short.MAX_VALUE))
        );
        jPanel16Layout.setVerticalGroup(
            jPanel16Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel16Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel16Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(jPanel16Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(jPanel16Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel54)
                            .addComponent(jTextField40, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGroup(jPanel16Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel36)
                            .addComponent(jTextField35, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addComponent(jCheckBox9))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jTextField45.setText("75");
        jTextField45.setPreferredSize(new java.awt.Dimension(37, 27));

        jLabel55.setText("ζ2(%)=");

        jTextField46.setText("4.80");
        jTextField46.setPreferredSize(new java.awt.Dimension(50, 27));

        jLabel56.setText("ω2(Hz)=");

        jCheckBox10.setSelected(true);
        jCheckBox10.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox10ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel17Layout = new javax.swing.GroupLayout(jPanel17);
        jPanel17.setLayout(jPanel17Layout);
        jPanel17Layout.setHorizontalGroup(
            jPanel17Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel17Layout.createSequentialGroup()
                .addComponent(jCheckBox10)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel56)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jTextField46, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jLabel55)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jTextField45, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, Short.MAX_VALUE))
        );
        jPanel17Layout.setVerticalGroup(
            jPanel17Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel17Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel17Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(jPanel17Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(jPanel17Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel55)
                            .addComponent(jTextField45, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGroup(jPanel17Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel56)
                            .addComponent(jTextField46, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addComponent(jCheckBox10))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jTextField48.setText("140");

        jLabel57.setText("ζ3(%)=");

        jTextField49.setText("10.20");

        jLabel62.setText("ω3(Hz)=");

        jCheckBox11.setSelected(true);
        jCheckBox11.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox11ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel18Layout = new javax.swing.GroupLayout(jPanel18);
        jPanel18.setLayout(jPanel18Layout);
        jPanel18Layout.setHorizontalGroup(
            jPanel18Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel18Layout.createSequentialGroup()
                .addComponent(jCheckBox11)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel62)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jTextField49, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jLabel57)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jTextField48, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, Short.MAX_VALUE))
        );
        jPanel18Layout.setVerticalGroup(
            jPanel18Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel18Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel18Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(jPanel18Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(jPanel18Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel57)
                            .addComponent(jTextField48, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGroup(jPanel18Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel62)
                            .addComponent(jTextField49, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addComponent(jCheckBox11))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout GroundDialogLayout = new javax.swing.GroupLayout(GroundDialog.getContentPane());
        GroundDialog.getContentPane().setLayout(GroundDialogLayout);
        GroundDialogLayout.setHorizontalGroup(
            GroundDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(GroundDialogLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(GroundDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel14, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel15, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel16, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel17, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel18, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        GroundDialogLayout.setVerticalGroup(
            GroundDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, GroundDialogLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel15, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGap(18, 18, 18)
                .addComponent(jPanel16, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jPanel17, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jPanel18, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(jPanel14, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle(ResourceBundle.getBundle("misc.bundle", local).getString("dynasoft-title"));

        javax.swing.GroupLayout drawPanelInput1Layout = new javax.swing.GroupLayout(drawPanelInput1);
        drawPanelInput1.setLayout(drawPanelInput1Layout);
        drawPanelInput1Layout.setHorizontalGroup(
            drawPanelInput1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );
        drawPanelInput1Layout.setVerticalGroup(
            drawPanelInput1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 331, Short.MAX_VALUE)
        );

        jSplitPane1.setLeftComponent(drawPanelInput1);

        jSplitPane3.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);

        jTextArea1.setColumns(20);
        jTextArea1.setRows(5);
        jScrollPane1.setViewportView(jTextArea1);

        jSplitPane3.setTopComponent(jScrollPane1);

        javax.swing.GroupLayout drawPanelGraph1Layout = new javax.swing.GroupLayout(drawPanelGraph1);
        drawPanelGraph1.setLayout(drawPanelGraph1Layout);
        drawPanelGraph1Layout.setHorizontalGroup(
            drawPanelGraph1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 933, Short.MAX_VALUE)
        );
        drawPanelGraph1Layout.setVerticalGroup(
            drawPanelGraph1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 303, Short.MAX_VALUE)
        );

        jSplitPane3.setBottomComponent(drawPanelGraph1);

        jSplitPane1.setRightComponent(jSplitPane3);

        getContentPane().add(jSplitPane1, java.awt.BorderLayout.CENTER);

        jMenu1.setText(ResourceBundle.getBundle("misc.bundle", local).getString("File"));
        jMenu1.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                jMenu1KeyPressed(evt);
            }
        });

        jMenu6.setText(ResourceBundle.getBundle("misc.bundle", local).getString("New"));

        jMenuItem2.setText(ResourceBundle.getBundle("misc.bundle", local).getString("msg_072"));
        jMenuItem2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem2ActionPerformed(evt);
            }
        });
        jMenu6.add(jMenuItem2);

        jMenuItem3.setText(ResourceBundle.getBundle("misc.bundle", local).getString("msg_073"));
        jMenuItem3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem3ActionPerformed(evt);
            }
        });
        jMenu6.add(jMenuItem3);

        jMenuItem4.setText(ResourceBundle.getBundle("misc.bundle", local).getString("msg_074"));
        jMenuItem4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem4ActionPerformed(evt);
            }
        });
        jMenu6.add(jMenuItem4);

        jMenuItem1.setText(ResourceBundle.getBundle("misc.bundle", local).getString("msg_075"));
        jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem1ActionPerformed(evt);
            }
        });
        jMenu6.add(jMenuItem1);

        jMenuItem14.setText(ResourceBundle.getBundle("misc.bundle", local).getString("msg_076"));
        jMenuItem14.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem14ActionPerformed(evt);
            }
        });
        jMenu6.add(jMenuItem14);

        jMenu1.add(jMenu6);

        jMenu7.setText(ResourceBundle.getBundle("misc.bundle", local).getString("Define"));

        jMenuItem7.setText(ResourceBundle.getBundle("misc.bundle", local).getString("msg_097"));
        jMenuItem7.setEnabled(false);
        jMenuItem7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem7ActionPerformed(evt);
            }
        });
        jMenu7.add(jMenuItem7);

        jMenuItem10.setText(ResourceBundle.getBundle("misc.bundle", local).getString("msg_098"));
        jMenuItem10.setEnabled(false);
        jMenuItem10.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem10ActionPerformed(evt);
            }
        });
        jMenu7.add(jMenuItem10);

        jMenuItem8.setText(ResourceBundle.getBundle("misc.bundle", local).getString("msg_099"));
        jMenuItem8.setEnabled(false);
        jMenuItem8.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem8ActionPerformed(evt);
            }
        });
        jMenu7.add(jMenuItem8);

        jMenu1.add(jMenu7);

        jMenuBar1.add(jMenu1);

        jMenu2.setText(ResourceBundle.getBundle("misc.bundle", local).getString("Edit"));

        jMenuItem11.setText(ResourceBundle.getBundle("misc.bundle", local).getString("b-Newmark_parameters"));
        jMenuItem11.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem11ActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItem11);

        jMenuItem12.setText(ResourceBundle.getBundle("misc.bundle", local).getString("Transient_analysis"));
        jMenuItem12.setEnabled(false);
        jMenuItem12.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem12ActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItem12);

        jMenuBar1.add(jMenu2);

        jMenu3.setText(ResourceBundle.getBundle("misc.bundle", local).getString("View"));

        jMenu8.setText(ResourceBundle.getBundle("misc.bundle", local).getString("Plots"));
        jMenu3.add(jMenu8);

        jMenu9.setText(ResourceBundle.getBundle("misc.bundle", local).getString("Language"));
        jMenu9.setToolTipText(ResourceBundle.getBundle("misc.bundle", local).getString("msg_077"));
        jMenu3.add(jMenu9);

        jMenuBar1.add(jMenu3);

        jMenu4.setText(ResourceBundle.getBundle("misc.bundle", local).getString("Tools"));

        jMenuItem9.setText(ResourceBundle.getBundle("misc.bundle", local).getString("msg_078"));
        jMenuItem9.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem9ActionPerformed(evt);
            }
        });
        jMenu4.add(jMenuItem9);

        jMenuBar1.add(jMenu4);

        jMenu5.setText(ResourceBundle.getBundle("misc.bundle", local).getString("Help"));

        jMenuItem5.setText(ResourceBundle.getBundle("misc.bundle", local).getString("About"));
        jMenuItem5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem5ActionPerformed(evt);
            }
        });
        jMenu5.add(jMenuItem5);

        jMenuItem6.setText(ResourceBundle.getBundle("misc.bundle", local).getString("msg_080"));
        jMenuItem6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem6ActionPerformed(evt);
            }
        });
        jMenu5.add(jMenuItem6);

        jMenuItem13.setText(ResourceBundle.getBundle("misc.bundle", local).getString("msg_081"));
        jMenuItem13.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem13ActionPerformed(evt);
            }
        });
        jMenu5.add(jMenuItem13);

        jMenuBar1.add(jMenu5);

        setJMenuBar(jMenuBar1);

        pack();
    }// </editor-fold>//GEN-END:initComponents

private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
// TODO add your handling code here:
    FrameDialog.setVisible(false);
}//GEN-LAST:event_jButton3ActionPerformed

private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
// TODO add your handling code here:
    jMenuItem12.setEnabled(false);
    drawPanelInput1.setForIsolataion(false);
    double h1,h2,h3;
    double L; double Elast;
    double b1,d1,b2,d2,b3,d3;
    double m1,m2,m3;
    
    h1=Double.parseDouble(jTextField31.getText()); 
    h2=Double.parseDouble(jTextField32.getText()); 
    h3=Double.parseDouble(jTextField33.getText());
    L=Double.parseDouble(jTextField8.getText());
    Elast=Double.parseDouble(jTextField1.getText());

    
    m1=Double.parseDouble(jTextField2.getText()); 
    m2=Double.parseDouble(jTextField3.getText()); 
    m3=Double.parseDouble(jTextField4.getText());
    
    b1=Double.parseDouble(jTextField7.getText()); 
    b2=Double.parseDouble(jTextField6.getText()); 
    b3=Double.parseDouble(jTextField5.getText());
    
    d1=Double.parseDouble(jTextField28.getText()); 
    d2=Double.parseDouble(jTextField29.getText()); 
    d3=Double.parseDouble(jTextField30.getText());
    
    //theFrame = new core.Frame();
    if(jCheckBox7.isSelected()){
        theStructure = new core.Frame();
    }else if(jCheckBox6.isSelected()){
        theStructure = new core.Frame(2);
    }else{
        theStructure = new core.Frame(1);
    }
    core.Node aNode;
    core.Element anElement;
    
    if(StiffRadioButton.isSelected()){((core.Frame) theStructure).setStiff(true);}
    if(FlexRadioButton.isSelected()){((core.Frame) theStructure).setStiff(false);}

    
    
    aNode = new core.Node(1,-L/2.,0.0);
    theStructure.addNode(aNode.getId(), aNode);
    aNode = new core.Node(2,L/2.,0.0);
    theStructure.addNode(aNode.getId(), aNode);
    aNode = new core.Node(3,-L/2.,h1);
    theStructure.addNode(aNode.getId(), aNode);
    aNode = new core.Node(4,L/2.,h1);
    theStructure.addNode(aNode.getId(), aNode);
    if(jCheckBox6.isSelected()){
        aNode = new core.Node(5,-L/2.,h1+h2);
        theStructure.addNode(aNode.getId(), aNode);
        aNode = new core.Node(6,L/2.,h1+h2);
        theStructure.addNode(aNode.getId(), aNode);
    }
    if(jCheckBox7.isSelected()){
        aNode = new core.Node(7,-L/2.,h1+h2+h3);
        theStructure.addNode(aNode.getId(), aNode);
        aNode = new core.Node(8,L/2.,h1+h2+h3);
        theStructure.addNode(aNode.getId(), aNode);
    }

    anElement = new core.Element(1, theStructure.getNode(1), theStructure.getNode(3));
    theStructure.addElement(anElement.getId(), anElement);
    anElement = new core.Element(2, theStructure.getNode(2), theStructure.getNode(4));
    theStructure.addElement(anElement.getId(), anElement);
    anElement = new core.Element(3, theStructure.getNode(3), theStructure.getNode(4));
    theStructure.addElement(anElement.getId(), anElement);
    if(jCheckBox6.isSelected()){
        anElement = new core.Element(4, theStructure.getNode(3), theStructure.getNode(5));
        theStructure.addElement(anElement.getId(), anElement);
        anElement = new core.Element(5, theStructure.getNode(4), theStructure.getNode(6));
        theStructure.addElement(anElement.getId(), anElement);
        anElement = new core.Element(6, theStructure.getNode(5), theStructure.getNode(6));
        theStructure.addElement(anElement.getId(), anElement);
    }
    if(jCheckBox7.isSelected()){
        anElement = new core.Element(7, theStructure.getNode(5), theStructure.getNode(7));
        theStructure.addElement(anElement.getId(), anElement);
        anElement = new core.Element(8, theStructure.getNode(6), theStructure.getNode(8));
        theStructure.addElement(anElement.getId(), anElement);
        anElement = new core.Element(9, theStructure.getNode(7), theStructure.getNode(8));
        theStructure.addElement(anElement.getId(), anElement);
    }
    double[] data = new double[14];
    data[0]=h1; data[1]=h2; data[2]=h3;
    data[3]=m1; data[4]=m2; data[5]=m3;
    data[6]=b1; data[7]=b2; data[8]=b3;
    data[9]=d1; data[10]=d2; data[11]=d3;
    data[12]=L; data[13]=Elast;
    theStructure.setGeometry(data);
    if(jCheckBox8.isSelected()){
        ((core.Frame) theStructure).setBaseIsolated(true);
        ((core.Frame) theStructure).setIsolation(Double.parseDouble(jTextField15.getText()),
                Double.parseDouble(jTextField16.getText())/100., 
                Double.parseDouble(jTextField36.getText()));
    }
    double totalMass=0.;
    if(jCheckBox5.isSelected()) totalMass+=m1;
    if(jCheckBox6.isSelected()) totalMass+=m2;
    if(jCheckBox7.isSelected()) totalMass+=m3;
    
    theStructure.setK();
    theStructure.setM();
    theStructure.EigenRun();
    double[] eigs = theStructure.getEigenValues();
    DecimalFormatSymbols comma =new DecimalFormatSymbols();
    comma.setDecimalSeparator('.');
    DecimalFormat Places = new DecimalFormat("0.000",comma);
    String sd1,sd2 = null,sd3 = null;
    Matrix mat;
    int sit;
    theStructure.setC(Double.parseDouble(jTextField9.getText())/100.);
    if(((core.Frame)theStructure).isIsolated()==false){
        jTextArea1.append("====================================================="+'\n');
        jTextArea1.append(""+'\n');
        jTextArea1.append("<"+resb.getString("msg_022")+">"+'\n');
        jTextArea1.append(""+'\n');
        mat = theStructure.getK();
        Places = new DecimalFormat("0.000",comma);
        switch(this.theStructure.getNumDOFS()){
            case 1:
                sd1=Places.format(mat.get(0, 0));
                jTextArea1.append(sd1+'\n');
                break;
            case 2:
                sd1=Places.format(mat.get(0, 0));
                sd2=Places.format(mat.get(0, 1));
                jTextArea1.append(sd1+" "+sd2+'\n');
                sd1=Places.format(mat.get(1, 0));
                sd2=Places.format(mat.get(1, 1));
                jTextArea1.append(sd1+" "+sd2+'\n');
                break;
            case 3:
                sd1=Places.format(mat.get(0, 0));
                sd2=Places.format(mat.get(0, 1));
                sd3=Places.format(mat.get(0, 2));
                jTextArea1.append(sd1+" "+sd2+" "+sd3+'\n');
                sd1=Places.format(mat.get(1, 0));
                sd2=Places.format(mat.get(1, 1));
                sd3=Places.format(mat.get(1, 2));
                jTextArea1.append(sd1+" "+sd2+" "+sd3+'\n');
                sd1=Places.format(mat.get(2, 0));
                sd2=Places.format(mat.get(2, 1));
                sd3=Places.format(mat.get(2, 2));
                jTextArea1.append(sd1+" "+sd2+" "+sd3+'\n');
                break;
        }

        jTextArea1.append(""+'\n');
        jTextArea1.append("<"+resb.getString("msg_023")+">"+'\n');
        jTextArea1.append(""+'\n');
        mat = theStructure.getM();
        Places = new DecimalFormat("0.000",comma);
        switch(this.theStructure.getNumDOFS()){
            case 1:
                sd1=Places.format(mat.get(0, 0));
                jTextArea1.append(sd1+'\n');
                break;
            case 2:
                sd1=Places.format(mat.get(0, 0));
                sd2=Places.format(mat.get(0, 1));
                jTextArea1.append(sd1+" "+sd2+'\n');
                sd1=Places.format(mat.get(1, 0));
                sd2=Places.format(mat.get(1, 1));
                jTextArea1.append(sd1+" "+sd2+'\n');
                break;
            case 3:
                sd1=Places.format(mat.get(0, 0));
                sd2=Places.format(mat.get(0, 1));
                sd3=Places.format(mat.get(0, 2));
                jTextArea1.append(sd1+" "+sd2+" "+sd3+'\n');
                sd1=Places.format(mat.get(1, 0));
                sd2=Places.format(mat.get(1, 1));
                sd3=Places.format(mat.get(1, 2));
                jTextArea1.append(sd1+" "+sd2+" "+sd3+'\n');
                sd1=Places.format(mat.get(2, 0));
                sd2=Places.format(mat.get(2, 1));
                sd3=Places.format(mat.get(2, 2));
                jTextArea1.append(sd1+" "+sd2+" "+sd3+'\n');
                break;
        }

        jTextArea1.append(""+'\n');
        jTextArea1.append("<"+resb.getString("msg_024")+">"+'\n');
        jTextArea1.append(""+'\n');
        mat = theStructure.getC();
        Places = new DecimalFormat("0.000",comma);
        switch(this.theStructure.getNumDOFS()){
            case 1:
                sd1=Places.format(mat.get(0, 0));
                jTextArea1.append(sd1+'\n');
                break;
            case 2:
                sd1=Places.format(mat.get(0, 0));
                sd2=Places.format(mat.get(0, 1));
                jTextArea1.append(sd1+" "+sd2+'\n');
                sd1=Places.format(mat.get(1, 0));
                sd2=Places.format(mat.get(1, 1));
                jTextArea1.append(sd1+" "+sd2+'\n');
                break;
            case 3:
                sd1=Places.format(mat.get(0, 0));
                sd2=Places.format(mat.get(0, 1));
                sd3=Places.format(mat.get(0, 2));
                jTextArea1.append(sd1+" "+sd2+" "+sd3+'\n');
                sd1=Places.format(mat.get(1, 0));
                sd2=Places.format(mat.get(1, 1));
                sd3=Places.format(mat.get(1, 2));
                jTextArea1.append(sd1+" "+sd2+" "+sd3+'\n');
                sd1=Places.format(mat.get(2, 0));
                sd2=Places.format(mat.get(2, 1));
                sd3=Places.format(mat.get(2, 2));
                jTextArea1.append(sd1+" "+sd2+" "+sd3+'\n');
                break;
        }

        jTextArea1.append(""+'\n');
        jTextArea1.append("<"+resb.getString("msg_027")+">"+'\n');
        sit=1;
        jTextArea1.append(""+'\n');
        jTextArea1.append(resb.getString("msg_044")+" "+Integer.toString(sit)+'\n');
        jTextArea1.append("----------"+'\n');
        sd1=Places.format(theStructure.getEigPeriod(sit));
        jTextArea1.append(resb.getString("eigenperiod")+"  T="+sd1+'\n');
        sd1=Places.format(2.*Math.PI/theStructure.getEigPeriod(sit));
        jTextArea1.append(resb.getString("msg_028")+"  ω="+sd1+'\n');
        switch(this.theStructure.getNumDOFS()){
            case 1:
                sd1=Places.format(theStructure.getEigenVector(sit)[0]);
                jTextArea1.append(resb.getString("msg_032")+":  φ11="+sd1+'\n');
                break;
            case 2:
                sd1=Places.format(theStructure.getEigenVector(sit)[0]);
                jTextArea1.append(resb.getString("msg_032")+":  φ11="+sd1);
                sd1=Places.format(theStructure.getEigenVector(sit)[1]);
                jTextArea1.append(" φ21="+sd1+'\n');
                break;
            case 3:
                sd1=Places.format(theStructure.getEigenVector(sit)[0]);
                jTextArea1.append(resb.getString("msg_032")+":  φ11="+sd1);
                sd1=Places.format(theStructure.getEigenVector(sit)[1]);
                jTextArea1.append(" φ21="+sd1);
                sd1=Places.format(theStructure.getEigenVector(sit)[2]);
                jTextArea1.append(" φ31="+sd1+'\n');
                break;
        }
        sd1=Places.format(theStructure.getEigMass(sit));
        jTextArea1.append(resb.getString("msg_045")+"="+sd1+'\n');
        sd1=Places.format(theStructure.getEigContribution(sit));
        jTextArea1.append(resb.getString("msg_046")+"="+sd1+'\n');
        sd1=Places.format(theStructure.getEigMass(sit)*theStructure.getEigContribution(sit)*theStructure.getEigContribution(sit));
        jTextArea1.append(resb.getString("msg_047")+"="+sd1+'\n');
        sd1=Places.format(100.*theStructure.getEigMass(sit)*theStructure.getEigContribution(sit)*theStructure.getEigContribution(sit)/totalMass);
        jTextArea1.append(resb.getString("msg_048")+"="+sd1+"%"+'\n');
        if(this.theStructure.getNumDOFS()>1){
            sit=2;
            jTextArea1.append(""+'\n');
            jTextArea1.append(resb.getString("msg_044")+" "+Integer.toString(sit)+'\n');
            jTextArea1.append("----------"+'\n');
            sd1=Places.format(theStructure.getEigPeriod(sit));
            jTextArea1.append(resb.getString("eigenperiod")+"  T="+sd1+'\n');
            sd1=Places.format(2.*Math.PI/theStructure.getEigPeriod(sit));
            jTextArea1.append(resb.getString("msg_028")+"  ω="+sd1+'\n');
            switch(this.theStructure.getNumDOFS()){
                case 2:
                    sd1=Places.format(theStructure.getEigenVector(sit)[0]);
                    jTextArea1.append(resb.getString("msg_032")+":  φ12="+sd1);
                    sd1=Places.format(theStructure.getEigenVector(sit)[1]);
                    jTextArea1.append(" φ22="+sd1+'\n');
                    break;
                case 3:
                    sd1=Places.format(theStructure.getEigenVector(sit)[0]);
                    jTextArea1.append(resb.getString("msg_032")+":  φ12="+sd1);
                    sd1=Places.format(theStructure.getEigenVector(sit)[1]);
                    jTextArea1.append(" φ22="+sd1);
                    sd1=Places.format(theStructure.getEigenVector(sit)[2]);
                    jTextArea1.append(" φ32="+sd1+'\n');
                    break;
        }
            sd1=Places.format(theStructure.getEigMass(sit));
            jTextArea1.append(resb.getString("msg_045")+"="+sd1+'\n');
            sd1=Places.format(theStructure.getEigContribution(sit));
            jTextArea1.append(resb.getString("msg_046")+"="+sd1+'\n');
            sd1=Places.format(theStructure.getEigMass(sit)*theStructure.getEigContribution(sit)*theStructure.getEigContribution(sit));
            jTextArea1.append(resb.getString("msg_047")+"="+sd1+'\n');
            sd1=Places.format(100.*theStructure.getEigMass(sit)*theStructure.getEigContribution(sit)*theStructure.getEigContribution(sit)/totalMass);
            jTextArea1.append(resb.getString("msg_048")+"="+sd1+"%"+'\n');
        }
        if(this.theStructure.getNumDOFS()>2){
            sit=3;
            jTextArea1.append(""+'\n');
            jTextArea1.append(resb.getString("msg_044")+" "+Integer.toString(sit)+'\n');
            jTextArea1.append("----------"+'\n');
            sd1=Places.format(theStructure.getEigPeriod(sit));
            jTextArea1.append(resb.getString("eigenperiod")+"  T="+sd1+'\n');
            sd1=Places.format(2.*Math.PI/theStructure.getEigPeriod(sit));
            jTextArea1.append(resb.getString("msg_028")+"  ω="+sd1+'\n');
            sd1=Places.format(theStructure.getEigenVector(sit)[0]);
            jTextArea1.append(resb.getString("msg_032")+":  φ13="+sd1);
            sd1=Places.format(theStructure.getEigenVector(sit)[1]);
            jTextArea1.append(" φ23="+sd1);
            sd1=Places.format(theStructure.getEigenVector(sit)[2]);
            jTextArea1.append(" φ33="+sd1+'\n');
            sd1=Places.format(theStructure.getEigMass(sit));
            jTextArea1.append(resb.getString("msg_045")+"="+sd1+'\n');
            sd1=Places.format(theStructure.getEigContribution(sit));
            jTextArea1.append(resb.getString("msg_046")+"="+sd1+'\n');
            sd1=Places.format(theStructure.getEigMass(sit)*theStructure.getEigContribution(sit)*theStructure.getEigContribution(sit));
            jTextArea1.append(resb.getString("msg_047")+"="+sd1+'\n');
            sd1=Places.format(100.*theStructure.getEigMass(sit)*theStructure.getEigContribution(sit)*theStructure.getEigContribution(sit)/totalMass);
            jTextArea1.append(resb.getString("msg_048")+"="+sd1+"%"+'\n');
        }
    }
    
    //////////////////////
    // ISOLATED
    //////////////////////
    if(jCheckBox8.isSelected()){
        drawPanelInput1.setForIsolataion(true);
        ((core.Frame)theStructure).setKiso();
        ((core.Frame)theStructure).setMiso();
        ((core.Frame)theStructure).setCiso();
        ((core.Frame)theStructure).EigenRuniso();
        eigs = theStructure.getEigenValues();
        jTextArea1.append("====================================================="+'\n');
        jTextArea1.append(""+'\n');
        jTextArea1.append("<"+resb.getString("msg_022")+">"+'\n');
        jTextArea1.append(""+'\n');
        mat = theStructure.getK();
        Places = new DecimalFormat("0.000",comma);
        String sd4;
        switch(this.theStructure.getNumDOFS()){
            case 1:
                sd1=Places.format(mat.get(0, 0));
                sd2=Places.format(mat.get(0, 1));
                jTextArea1.append(sd1+" "+sd2+'\n');
                sd1=Places.format(mat.get(1, 0));
                sd2=Places.format(mat.get(1, 1));
                jTextArea1.append(sd1+" "+sd2+'\n');
                break;
            case 2:
                sd1=Places.format(mat.get(0, 0));
                sd2=Places.format(mat.get(0, 1));
                sd3=Places.format(mat.get(0, 2));
                jTextArea1.append(sd1+" "+sd2+" "+sd3+'\n');
                sd1=Places.format(mat.get(1, 0));
                sd2=Places.format(mat.get(1, 1));
                sd3=Places.format(mat.get(1, 2));
                jTextArea1.append(sd1+" "+sd2+" "+sd3+'\n');
                sd1=Places.format(mat.get(2, 0));
                sd2=Places.format(mat.get(2, 1));
                sd3=Places.format(mat.get(2, 2));
                jTextArea1.append(sd1+" "+sd2+" "+sd3+'\n');
                break;
            case 3:
                sd1=Places.format(mat.get(0, 0));
                sd2=Places.format(mat.get(0, 1));
                sd3=Places.format(mat.get(0, 2));
                sd4=Places.format(mat.get(0, 3));
                jTextArea1.append(sd1+" "+sd2+" "+sd3+" "+sd4+'\n');
                sd1=Places.format(mat.get(1, 0));
                sd2=Places.format(mat.get(1, 1));
                sd3=Places.format(mat.get(1, 2));
                sd4=Places.format(mat.get(1, 3));
                jTextArea1.append(sd1+" "+sd2+" "+sd3+" "+sd4+'\n');
                sd1=Places.format(mat.get(2, 0));
                sd2=Places.format(mat.get(2, 1));
                sd3=Places.format(mat.get(2, 2));
                sd4=Places.format(mat.get(2, 3));
                jTextArea1.append(sd1+" "+sd2+" "+sd3+" "+sd4+'\n');
                sd1=Places.format(mat.get(3, 0));
                sd2=Places.format(mat.get(3, 1));
                sd3=Places.format(mat.get(3, 2));
                sd4=Places.format(mat.get(3, 3));
                jTextArea1.append(sd1+" "+sd2+" "+sd3+" "+sd4+'\n');
                break;
        }
        
        jTextArea1.append("====================================================="+'\n');
        jTextArea1.append(""+'\n');
        jTextArea1.append("<"+resb.getString("msg_023")+">"+'\n');
        jTextArea1.append(""+'\n');
        mat = theStructure.getM();
        Places = new DecimalFormat("0.000",comma);
        switch(this.theStructure.getNumDOFS()){
            case 1:
                sd1=Places.format(mat.get(0, 0));
                sd2=Places.format(mat.get(0, 1));
                jTextArea1.append(sd1+" "+sd2+'\n');
                sd1=Places.format(mat.get(1, 0));
                sd2=Places.format(mat.get(1, 1));
                jTextArea1.append(sd1+" "+sd2+'\n');
                break;
            case 2:
                sd1=Places.format(mat.get(0, 0));
                sd2=Places.format(mat.get(0, 1));
                sd3=Places.format(mat.get(0, 2));
                jTextArea1.append(sd1+" "+sd2+" "+sd3+'\n');
                sd1=Places.format(mat.get(1, 0));
                sd2=Places.format(mat.get(1, 1));
                sd3=Places.format(mat.get(1, 2));
                jTextArea1.append(sd1+" "+sd2+" "+sd3+'\n');
                sd1=Places.format(mat.get(2, 0));
                sd2=Places.format(mat.get(2, 1));
                sd3=Places.format(mat.get(2, 2));
                jTextArea1.append(sd1+" "+sd2+" "+sd3+'\n');
                break;
            case 3:
                sd1=Places.format(mat.get(0, 0));
                sd2=Places.format(mat.get(0, 1));
                sd3=Places.format(mat.get(0, 2));
                sd4=Places.format(mat.get(0, 3));
                jTextArea1.append(sd1+" "+sd2+" "+sd3+" "+sd4+'\n');
                sd1=Places.format(mat.get(1, 0));
                sd2=Places.format(mat.get(1, 1));
                sd3=Places.format(mat.get(1, 2));
                sd3=Places.format(mat.get(1, 3));
                jTextArea1.append(sd1+" "+sd2+" "+sd3+" "+sd4+'\n');
                sd1=Places.format(mat.get(2, 0));
                sd2=Places.format(mat.get(2, 1));
                sd3=Places.format(mat.get(2, 2));
                sd4=Places.format(mat.get(2, 3));
                jTextArea1.append(sd1+" "+sd2+" "+sd3+" "+sd4+'\n');
                sd1=Places.format(mat.get(3, 0));
                sd2=Places.format(mat.get(3, 1));
                sd3=Places.format(mat.get(3, 2));
                sd4=Places.format(mat.get(3, 3));
                jTextArea1.append(sd1+" "+sd2+" "+sd3+" "+sd4+'\n');
                break;
        }
        
        jTextArea1.append("====================================================="+'\n');
        jTextArea1.append(""+'\n');
        jTextArea1.append("<"+resb.getString("msg_024")+">"+'\n');
        jTextArea1.append(""+'\n');
        mat = theStructure.getC();
        Places = new DecimalFormat("0.000",comma);
        switch(this.theStructure.getNumDOFS()){
            case 1:
                sd1=Places.format(mat.get(0, 0));
                sd2=Places.format(mat.get(0, 1));
                jTextArea1.append(sd1+" "+sd2+'\n');
                sd1=Places.format(mat.get(1, 0));
                sd2=Places.format(mat.get(1, 1));
                jTextArea1.append(sd1+" "+sd2+'\n');
                break;
            case 2:
                sd1=Places.format(mat.get(0, 0));
                sd2=Places.format(mat.get(0, 1));
                sd3=Places.format(mat.get(0, 2));
                jTextArea1.append(sd1+" "+sd2+" "+sd3+'\n');
                sd1=Places.format(mat.get(1, 0));
                sd2=Places.format(mat.get(1, 1));
                sd3=Places.format(mat.get(1, 2));
                jTextArea1.append(sd1+" "+sd2+" "+sd3+'\n');
                sd1=Places.format(mat.get(2, 0));
                sd2=Places.format(mat.get(2, 1));
                sd3=Places.format(mat.get(2, 2));
                jTextArea1.append(sd1+" "+sd2+" "+sd3+'\n');
                break;
            case 3:
                sd1=Places.format(mat.get(0, 0));
                sd2=Places.format(mat.get(0, 1));
                sd3=Places.format(mat.get(0, 2));
                sd4=Places.format(mat.get(0, 3));
                jTextArea1.append(sd1+" "+sd2+" "+sd3+" "+sd4+'\n');
                sd1=Places.format(mat.get(1, 0));
                sd2=Places.format(mat.get(1, 1));
                sd3=Places.format(mat.get(1, 2));
                sd3=Places.format(mat.get(1, 3));
                jTextArea1.append(sd1+" "+sd2+" "+sd3+" "+sd4+'\n');
                sd1=Places.format(mat.get(2, 0));
                sd2=Places.format(mat.get(2, 1));
                sd3=Places.format(mat.get(2, 2));
                sd4=Places.format(mat.get(2, 3));
                jTextArea1.append(sd1+" "+sd2+" "+sd3+" "+sd4+'\n');
                sd1=Places.format(mat.get(3, 0));
                sd2=Places.format(mat.get(3, 1));
                sd3=Places.format(mat.get(3, 2));
                sd4=Places.format(mat.get(3, 3));
                jTextArea1.append(sd1+" "+sd2+" "+sd3+" "+sd4+'\n');
                break;
        }
        
        jTextArea1.append(""+'\n');
        jTextArea1.append("<"+resb.getString("msg_027")+">"+'\n');
        sd1=Places.format(2.*Math.PI/((core.Frame)theStructure).getOmegaB());
        jTextArea1.append(resb.getString("msg_049")+"  T="+sd1+'\n');
        sd1=Places.format(((core.Frame)theStructure).getOmegaB());
        jTextArea1.append(resb.getString("msg_050")+"  ω="+sd1+'\n');
        sit=1;
        jTextArea1.append(""+'\n');
        jTextArea1.append(resb.getString("msg_044")+" "+Integer.toString(sit)+'\n');
        jTextArea1.append("----------"+'\n');
        sd1=Places.format(theStructure.getEigPeriod(sit));
        jTextArea1.append(resb.getString("eigenperiod")+"  T="+sd1+'\n');
        sd1=Places.format(2.*Math.PI/theStructure.getEigPeriod(sit));
        jTextArea1.append(resb.getString("msg_028")+"  ω="+sd1+'\n');
        switch(this.theStructure.getNumDOFS()){
            case 1:
                sd1=Places.format(((core.Frame)theStructure).getEigenVectoriso(sit)[0]);
                jTextArea1.append(resb.getString("msg_032")+":  φ11="+sd1);
                sd1=Places.format(((core.Frame)theStructure).getEigenVectoriso(sit)[1]);
                jTextArea1.append(" φ21="+sd1+'\n');
                break;
            case 2:
                sd1=Places.format(((core.Frame)theStructure).getEigenVectoriso(sit)[0]);
                jTextArea1.append(resb.getString("msg_032")+":  φ11="+sd1);
                sd1=Places.format(((core.Frame)theStructure).getEigenVectoriso(sit)[1]);
                jTextArea1.append(" φ21="+sd1);
                sd1=Places.format(((core.Frame)theStructure).getEigenVectoriso(sit)[2]);
                jTextArea1.append(" φ31="+sd1+'\n');
                break;
            case 3:
                sd1=Places.format(((core.Frame)theStructure).getEigenVectoriso(sit)[0]);
                jTextArea1.append(resb.getString("msg_032")+":  φ11="+sd1);
                sd1=Places.format(((core.Frame)theStructure).getEigenVectoriso(sit)[1]);
                jTextArea1.append(" φ21="+sd1);
                sd1=Places.format(((core.Frame)theStructure).getEigenVectoriso(sit)[2]);
                jTextArea1.append(" φ31="+sd1);
                sd1=Places.format(((core.Frame)theStructure).getEigenVectoriso(sit)[3]);
                jTextArea1.append(" φ41="+sd1+'\n');
                break;
        }
        sd1=Places.format(theStructure.getEigMass(sit));
        jTextArea1.append(resb.getString("msg_045")+"="+sd1+'\n');
        sd1=Places.format(theStructure.getEigContribution(sit));
        jTextArea1.append(resb.getString("msg_046")+"="+sd1+'\n');
        sd1=Places.format(theStructure.getEigMass(sit)*theStructure.getEigContribution(sit)*theStructure.getEigContribution(sit));
        jTextArea1.append(resb.getString("msg_047")+"="+sd1+'\n');
        sd1=Places.format(100.*theStructure.getEigMass(sit)*theStructure.getEigContribution(sit)*theStructure.getEigContribution(sit)/totalMass);
        jTextArea1.append(resb.getString("msg_048")+"="+sd1+"%"+'\n');
        
        sit=2;
        jTextArea1.append(""+'\n');
        jTextArea1.append(resb.getString("msg_044")+" "+Integer.toString(sit)+'\n');
        jTextArea1.append("----------"+'\n');
        sd1=Places.format(theStructure.getEigPeriod(sit));
        jTextArea1.append(resb.getString("eigenperiod")+"  T="+sd1+'\n');
        sd1=Places.format(2.*Math.PI/theStructure.getEigPeriod(sit));
        jTextArea1.append(resb.getString("msg_028")+"  ω="+sd1+'\n');
        switch(this.theStructure.getNumDOFS()){
            case 1:
                sd1=Places.format(((core.Frame)theStructure).getEigenVectoriso(sit)[0]);
                jTextArea1.append(resb.getString("msg_032")+":  φ12="+sd1);
                sd1=Places.format(((core.Frame)theStructure).getEigenVectoriso(sit)[1]);
                jTextArea1.append(" φ22="+sd1+'\n');
                break;
            case 2:
                sd1=Places.format(((core.Frame)theStructure).getEigenVectoriso(sit)[0]);
                jTextArea1.append(resb.getString("msg_032")+":  φ12="+sd1);
                sd1=Places.format(((core.Frame)theStructure).getEigenVectoriso(sit)[1]);
                jTextArea1.append(" φ22="+sd1);
                sd1=Places.format(((core.Frame)theStructure).getEigenVectoriso(sit)[2]);
                jTextArea1.append(" φ32="+sd1+'\n');
                break;
            case 3:
                sd1=Places.format(((core.Frame)theStructure).getEigenVectoriso(sit)[0]);
                jTextArea1.append(resb.getString("msg_032")+":  φ12="+sd1);
                sd1=Places.format(((core.Frame)theStructure).getEigenVectoriso(sit)[1]);
                jTextArea1.append(" φ22="+sd1);
                sd1=Places.format(((core.Frame)theStructure).getEigenVectoriso(sit)[2]);
                jTextArea1.append(" φ32="+sd1);
                sd1=Places.format(((core.Frame)theStructure).getEigenVectoriso(sit)[3]);
                jTextArea1.append(" φ42="+sd1+'\n');
                break;
        }
        sd1=Places.format(theStructure.getEigMass(sit));
        jTextArea1.append(resb.getString("msg_045")+"="+sd1+'\n');
        sd1=Places.format(theStructure.getEigContribution(sit));
        jTextArea1.append(resb.getString("msg_046")+"="+sd1+'\n');
        sd1=Places.format(theStructure.getEigMass(sit)*theStructure.getEigContribution(sit)*theStructure.getEigContribution(sit));
        jTextArea1.append(resb.getString("msg_047")+"="+sd1+'\n');
        sd1=Places.format(100.*theStructure.getEigMass(sit)*theStructure.getEigContribution(sit)*theStructure.getEigContribution(sit)/totalMass);
        jTextArea1.append(resb.getString("msg_048")+"="+sd1+"%"+'\n');
        
        if(this.getNumStories()>1){
            sit=3;
            jTextArea1.append(""+'\n');
            jTextArea1.append(resb.getString("msg_044")+" "+Integer.toString(sit)+'\n');
            jTextArea1.append("----------"+'\n');
            sd1=Places.format(theStructure.getEigPeriod(sit));
            jTextArea1.append(resb.getString("eigenperiod")+"  T="+sd1+'\n');
            sd1=Places.format(2.*Math.PI/theStructure.getEigPeriod(sit));
            jTextArea1.append(resb.getString("msg_028")+"  ω="+sd1+'\n');
            switch(this.theStructure.getNumDOFS()){
                case 1:
                    sd1=Places.format(((core.Frame)theStructure).getEigenVectoriso(sit)[0]);
                    jTextArea1.append(resb.getString("msg_032")+":  φ13="+sd1);
                    sd1=Places.format(((core.Frame)theStructure).getEigenVectoriso(sit)[1]);
                    jTextArea1.append(" φ23="+sd1+'\n');
                    break;
                case 2:
                    sd1=Places.format(((core.Frame)theStructure).getEigenVectoriso(sit)[0]);
                    jTextArea1.append("ιδιοδιάνυσμα: φ13="+sd1);
                    sd1=Places.format(((core.Frame)theStructure).getEigenVectoriso(sit)[1]);
                    jTextArea1.append(" φ23="+sd1);
                    sd1=Places.format(((core.Frame)theStructure).getEigenVectoriso(sit)[2]);
                    jTextArea1.append(" φ33="+sd1+'\n');
                    break;
                case 3:
                    sd1=Places.format(((core.Frame)theStructure).getEigenVectoriso(sit)[0]);
                    jTextArea1.append(resb.getString("msg_032")+":  φ13="+sd1);
                    sd1=Places.format(((core.Frame)theStructure).getEigenVectoriso(sit)[1]);
                    jTextArea1.append(" φ23="+sd1);
                    sd1=Places.format(((core.Frame)theStructure).getEigenVectoriso(sit)[2]);
                    jTextArea1.append(" φ33="+sd1);
                    sd1=Places.format(((core.Frame)theStructure).getEigenVectoriso(sit)[3]);
                    jTextArea1.append(" φ43="+sd1+'\n');
                    break;
            }
            sd1=Places.format(theStructure.getEigMass(sit));
            jTextArea1.append(resb.getString("msg_045")+"="+sd1+'\n');
            sd1=Places.format(theStructure.getEigContribution(sit));
            jTextArea1.append(resb.getString("msg_046")+"="+sd1+'\n');
            sd1=Places.format(theStructure.getEigMass(sit)*theStructure.getEigContribution(sit)*theStructure.getEigContribution(sit));
            jTextArea1.append(resb.getString("msg_047")+"="+sd1+'\n');
            sd1=Places.format(100.*theStructure.getEigMass(sit)*theStructure.getEigContribution(sit)*theStructure.getEigContribution(sit)/totalMass);
            jTextArea1.append(resb.getString("msg_048")+"="+sd1+"%"+'\n');
        }
        
        if(this.getNumStories()>2){
            sit=4;
            jTextArea1.append(""+'\n');
            jTextArea1.append(resb.getString("msg_044")+" "+Integer.toString(sit)+'\n');
            jTextArea1.append("----------"+'\n');
            sd1=Places.format(theStructure.getEigPeriod(sit));
            jTextArea1.append(resb.getString("eigenperiod")+"  T="+sd1+'\n');
            sd1=Places.format(2.*Math.PI/theStructure.getEigPeriod(sit));
            jTextArea1.append(resb.getString("msg_028")+"  ω="+sd1+'\n');
            switch(this.theStructure.getNumDOFS()){
                case 1:
                    sd1=Places.format(((core.Frame)theStructure).getEigenVectoriso(sit)[0]);
                    jTextArea1.append(resb.getString("msg_032")+":  φ14="+sd1);
                    sd1=Places.format(((core.Frame)theStructure).getEigenVectoriso(sit)[1]);
                    jTextArea1.append(" φ24="+sd1+'\n');
                    break;
                case 2:
                    sd1=Places.format(((core.Frame)theStructure).getEigenVectoriso(sit)[0]);
                    jTextArea1.append(resb.getString("msg_032")+":  φ14="+sd1);
                    sd1=Places.format(((core.Frame)theStructure).getEigenVectoriso(sit)[1]);
                    jTextArea1.append(" φ24="+sd1);
                    sd1=Places.format(((core.Frame)theStructure).getEigenVectoriso(sit)[2]);
                    jTextArea1.append(" φ34="+sd1+'\n');
                    break;
                case 3:
                    sd1=Places.format(((core.Frame)theStructure).getEigenVectoriso(sit)[0]);
                    jTextArea1.append(resb.getString("msg_032")+":  φ14="+sd1);
                    sd1=Places.format(((core.Frame)theStructure).getEigenVectoriso(sit)[1]);
                    jTextArea1.append(" φ24="+sd1);
                    sd1=Places.format(((core.Frame)theStructure).getEigenVectoriso(sit)[2]);
                    jTextArea1.append(" φ34="+sd1);
                    sd1=Places.format(((core.Frame)theStructure).getEigenVectoriso(sit)[3]);
                    jTextArea1.append(" φ44="+sd1+'\n');
                    break;
            }
            sd1=Places.format(theStructure.getEigMass(sit));
            jTextArea1.append(resb.getString("msg_045")+"="+sd1+'\n');
            sd1=Places.format(theStructure.getEigContribution(sit));
            jTextArea1.append(resb.getString("msg_046")+"="+sd1+'\n');
            sd1=Places.format(theStructure.getEigMass(sit)*theStructure.getEigContribution(sit)*theStructure.getEigContribution(sit));
            jTextArea1.append(resb.getString("msg_047")+"="+sd1+'\n');
            sd1=Places.format(100.*theStructure.getEigMass(sit)*theStructure.getEigContribution(sit)*theStructure.getEigContribution(sit)/totalMass);
            jTextArea1.append(resb.getString("msg_048")+"="+sd1+"%"+'\n');
        }
    }
    
    
    drawPanelInput1.setFrame(theStructure);
    specPanel1.setFrame(theStructure);
    drawPanelInput1.setSit(1);
    drawPanelInput1.setDef(true);
    drawPanelInput1.setInit(false);
    drawPanelInput1.setWhichStep(0);
    drawPanelInput1.stop();
    drawPanelInput1.plot();
    jButton_left.setEnabled(true);
    jButton_right.setEnabled(true);
    jMenuItem8.setEnabled(true);
    jMenuItem7.setEnabled(true);
    jMenuItem10.setEnabled(true);
    drawPanelGraph1.setRespAnalysed(false);
    drawPanelGraph1.setWhichStep(0);
    jButton_play.setEnabled(false);
    jButton_stop.setEnabled(false);
//    jComboBox4.setSelectedIndex(6);
    jComboBox4.setEnabled(false);
//    jComboBox3.setSelectedIndex(0);
    jComboBox3.setEnabled(false);
    jSlider2.setEnabled(false);
    jSlider2.setValue(50);
    drawPanelGraph1.plot();
    FrameDialog.setVisible(false);
}//GEN-LAST:event_jButton4ActionPerformed

private void jButton_rightActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton_rightActionPerformed
// TODO add your handling code here:
    int curSit=drawPanelInput1.getSit();
    int nextSit=1;
    int neig=this.theStructure.getNumDOFS();
    if(theStructure.getType()==1)if(((core.Frame)theStructure).isIsolated())neig+=1;
    if(curSit==neig){nextSit=1;}else{nextSit=curSit+1;}
    drawPanelInput1.setSit(nextSit);
    drawPanelInput1.setDef(true);
    drawPanelInput1.plot();
}//GEN-LAST:event_jButton_rightActionPerformed

private void jButton_leftActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton_leftActionPerformed
// TODO add your handling code here:
    int curSit=drawPanelInput1.getSit();
    int nextSit=1;
    int neig=this.theStructure.getNumDOFS();
    if(theStructure.getType()==1)if(((core.Frame)theStructure).isIsolated())neig+=1;
    if(curSit==1 || curSit==0){nextSit=neig;}else{nextSit=curSit-1;}
    drawPanelInput1.setSit(nextSit);
    drawPanelInput1.setDef(true);
    drawPanelInput1.plot();
}//GEN-LAST:event_jButton_leftActionPerformed

private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
// TODO add your handling code here:
    String strDT;  // A local variable to hold the name.
    strDT = JOptionPane.showInputDialog(SpecDialog, resb.getString("msg_051"));
    int dT = Integer.parseInt(strDT);
    DefaultTableModel tableModel = (DefaultTableModel) jTable_Spec.getModel();
    while (tableModel.getRowCount() != 0) {
        tableModel.removeRow(tableModel.getRowCount() - 1);
    }
    tableModel.setColumnCount(0);
    String name= resb.getString("Period")+" (sec)";
    tableModel.addColumn(name);
    name= resb.getString("msg_052")+" (m/sec^2)";
    tableModel.addColumn(name);
    for(int i=1;i<=dT;i++){
        tableModel.addRow(new Object[]{"",""});
    }
    
}//GEN-LAST:event_jButton2ActionPerformed

private void jButton16ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton16ActionPerformed
// TODO add your handling code here:
    SpecDialog.setVisible(false);
}//GEN-LAST:event_jButton16ActionPerformed

private void jButton15ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton15ActionPerformed
// TODO add your handling code here:
    DefaultTableModel tableModel = (DefaultTableModel) jTable_Spec.getModel();
    int nrows = tableModel.getRowCount();
    double[] periods = new double[nrows];
    double[] accel = new double[nrows];
    for(int i=0; i<nrows; i++){
        periods[i]=Double.parseDouble(tableModel.getValueAt(i, 0).toString());
        accel[i]=Double.parseDouble(tableModel.getValueAt(i, 1).toString());
    }
    this.theSpectrum.setPeriods(periods);
    this.theSpectrum.setAccelerations(accel);
    if(theStructure!=null){
        int stories = theStructure.getNumDOFS();
        double[] vals = new double[stories];
        vals[0]=theSpectrum.getAccel(theStructure.getEigPeriod(1));
        if(stories>1)vals[1]=theSpectrum.getAccel(theStructure.getEigPeriod(2));
        if(stories>2)vals[2]=theSpectrum.getAccel(theStructure.getEigPeriod(3));
        
        theStructure.setSa(vals);
        
        DecimalFormatSymbols comma =new DecimalFormatSymbols();
        comma.setDecimalSeparator('.');
        DecimalFormat Places = new DecimalFormat("0.000",comma);
        String sd1;
        
        jTextArea1.append(""+'\n');
        jTextArea1.append("<Φασματικά χαρακτηριστικά>"+'\n');
        
        jTextArea1.append(""+'\n');
        sd1=Places.format(theStructure.getSa(1));
        jTextArea1.append("Sa1="+sd1+" m/sec^2"+'\n');
        if(stories>1)sd1=Places.format(theStructure.getSa(2));
        if(stories>1)jTextArea1.append("Sa2="+sd1+" m/sec^2"+'\n');
        if(stories>2)sd1=Places.format(theStructure.getSa(3));
        if(stories>2)jTextArea1.append("Sa3="+sd1+" m/sec^2"+'\n');
        
        Places = new DecimalFormat("0.00E0",comma);
        
        jTextArea1.append(""+'\n');
        sd1=Places.format(theStructure.getSd(1));
        jTextArea1.append("Sd1="+sd1+" m"+'\n');
        if(stories>1)sd1=Places.format(theStructure.getSd(2));
        if(stories>1)jTextArea1.append("Sd2="+sd1+" m"+'\n');
        if(stories>2)sd1=Places.format(theStructure.getSd(3));
        if(stories>2)jTextArea1.append("Sd3="+sd1+" m"+'\n');
        
        jTextArea1.append(""+'\n');
        sd1=Places.format(theStructure.getSv(1));
        jTextArea1.append("Sv1="+sd1+" m/sec"+'\n');
        if(stories>1)sd1=Places.format(theStructure.getSv(2));
        if(stories>1)jTextArea1.append("Sv2="+sd1+" m/sec"+'\n');
        if(stories>2)sd1=Places.format(theStructure.getSv(3));
        if(stories>2)jTextArea1.append("Sv3="+sd1+" m/sec"+'\n');
    }
    SpecDialog.setVisible(false);
}//GEN-LAST:event_jButton15ActionPerformed

private void jButton14ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton14ActionPerformed
// TODO add your handling code here:
    specPanel1.plot();
}//GEN-LAST:event_jButton14ActionPerformed

private void FlexRadioButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_FlexRadioButtonActionPerformed
// TODO add your handling code here:
    if(FlexRadioButton.isSelected()){StiffRadioButton.setSelected(false);}
    if(!FlexRadioButton.isSelected()){StiffRadioButton.setSelected(true);}
}//GEN-LAST:event_FlexRadioButtonActionPerformed

private void StiffRadioButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_StiffRadioButtonActionPerformed
// TODO add your handling code here:
    if(StiffRadioButton.isSelected()){FlexRadioButton.setSelected(false);}
    if(!StiffRadioButton.isSelected()){FlexRadioButton.setSelected(true);}
}//GEN-LAST:event_StiffRadioButtonActionPerformed

private void jButton13ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton13ActionPerformed
// TODO add your handling code here:
    int option = theFileChooser.showOpenDialog(this);
    File outFile;
    if (option == JFileChooser.APPROVE_OPTION) {
        outFile = theFileChooser.getSelectedFile();
        parse(outFile);
    }
    specPanel1.plot();
    SpecDialog.setVisible(true);
}//GEN-LAST:event_jButton13ActionPerformed

private void jButton21ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton21ActionPerformed
// TODO add your handling code here:
    ForceDialog_1.setVisible(false);
}//GEN-LAST:event_jButton21ActionPerformed

private void jCheckBox1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox1ActionPerformed
// TODO add your handling code here:
    if(jCheckBox1.isSelected()){
        jTextField10.setEnabled(false);
        if(this.theStructure.getNumDOFS()>1)jTextField11.setEnabled(false);
        if(this.theStructure.getNumDOFS()>2)jTextField12.setEnabled(false);
        jButton17.setEnabled(false);
        if(this.theStructure.getNumDOFS()>1)jButton18.setEnabled(false);
        if(this.theStructure.getNumDOFS()>2)jButton19.setEnabled(false);
        jCheckBox2.setEnabled(false);
        if(this.theStructure.getNumDOFS()>1)jCheckBox3.setEnabled(false);
        if(this.theStructure.getNumDOFS()>2)jCheckBox4.setEnabled(false);
        jButton26.setEnabled(true);
        jLabel18.setEnabled(true);
        
        if(theStructure.getType()==2){
            jLabelAngle.setEnabled(true);
            jTextFieldAngle.setEnabled(true);
        }
        
        jLabel15.setEnabled(false);
        if(this.theStructure.getNumDOFS()>1)jLabel16.setEnabled(false);
        if(this.theStructure.getNumDOFS()>2)jLabel17.setEnabled(false);
    }else{
        
        jLabelAngle.setEnabled(false);
        jTextFieldAngle.setEnabled(false);
        
        if(jCheckBox2.isSelected()){
            jTextField10.setEnabled(true);
            jButton17.setEnabled(false);
            jLabel15.setEnabled(false);
        }else{
            jTextField10.setEnabled(false);
            jButton17.setEnabled(true);
            jLabel15.setEnabled(true);
        }
        if(this.theStructure.getNumDOFS()>1){
            if(jCheckBox3.isSelected()){
                jTextField11.setEnabled(true);
                jButton18.setEnabled(false);
                jLabel16.setEnabled(false);
            }else{
                jTextField11.setEnabled(false);
                jButton18.setEnabled(true);
                jLabel16.setEnabled(true);
            }
        }
        if(this.theStructure.getNumDOFS()>2){
            if(jCheckBox4.isSelected()){
                jTextField12.setEnabled(true);
                jButton19.setEnabled(false);
                jLabel17.setEnabled(false);
            }else{
                jTextField12.setEnabled(false);
                jButton19.setEnabled(true);
                jLabel17.setEnabled(true);
            }
        }
        jCheckBox2.setEnabled(true);
        if(this.theStructure.getNumDOFS()>1) jCheckBox3.setEnabled(true);
        if(this.theStructure.getNumDOFS()>2)jCheckBox4.setEnabled(true);
        jButton26.setEnabled(false);
        jLabel18.setEnabled(false);
    }
    //System.out.println("some action performed");
    /*if(jTextField10.isEnabled()){jTextField10.setEnabled(false);}else{jTextField10.setEnabled(true);}
    if(jTextField11.isEnabled()){jTextField11.setEnabled(false);}else{jTextField11.setEnabled(true);}
    if(jTextField12.isEnabled()){jTextField12.setEnabled(false);}else{jTextField12.setEnabled(true);}
    if(jButton17.isEnabled()){jButton17.setEnabled(false);}else{jButton17.setEnabled(true);}
    if(jButton18.isEnabled()){jButton18.setEnabled(false);}else{jButton18.setEnabled(true);}
    if(jButton19.isEnabled()){jButton19.setEnabled(false);}else{jButton19.setEnabled(true);}
    if(jButton26.isEnabled()){jButton26.setEnabled(false);}else{jButton26.setEnabled(true);}*/
}//GEN-LAST:event_jCheckBox1ActionPerformed

private void jButton17ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton17ActionPerformed
// TODO add your handling code here:
    int option = theFileChooser.showOpenDialog(this);
    if (option == JFileChooser.APPROVE_OPTION) {
        this.File1 = theFileChooser.getSelectedFile();
        jLabel15.setText(File1.getName());
    }
}//GEN-LAST:event_jButton17ActionPerformed

private void jButton_playActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton_playActionPerformed
// TODO add your handling code here:
    drawPanelInput1.stop();
    drawPanelInput1.start();
    drawPanelInput1.setInit(true);
    jButton_right.setEnabled(false);
    jButton_left.setEnabled(false);
    jButton_play.setEnabled(false);
    jButton_stop.setEnabled(true);
    jSlider2.setEnabled(true);
}//GEN-LAST:event_jButton_playActionPerformed

private void jButton_stopActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton_stopActionPerformed
// TODO add your handling code here:
    drawPanelInput1.setInit(false);
    jButton_right.setEnabled(true);
    jButton_left.setEnabled(true);
    jButton_play.setEnabled(true);
    jButton_stop.setEnabled(false);
    jSlider2.setEnabled(false);
    drawPanelInput1.stop();
    drawPanelInput1.setWhichStep(0);
    drawPanelGraph1.setWhichStep(0);
    drawPanelInput1.repaint();
    drawPanelGraph1.repaint();
}//GEN-LAST:event_jButton_stopActionPerformed

private void jCheckBox2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox2ActionPerformed
// TODO add your handling code here:
    if(jCheckBox2.isSelected()){
        jTextField10.setEnabled(true);
        jButton17.setEnabled(false);
        jLabel15.setEnabled(false);
    }else{
        jTextField10.setEnabled(false);
        jButton17.setEnabled(true);
        jLabel15.setEnabled(true);
    }
}//GEN-LAST:event_jCheckBox2ActionPerformed

private void jCheckBox3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox3ActionPerformed
// TODO add your handling code here:
    if(jCheckBox3.isSelected()){
        jTextField11.setEnabled(true);
        jButton18.setEnabled(false);
        jLabel16.setEnabled(false);
    }else{
        jTextField11.setEnabled(false);
        jButton18.setEnabled(true);
        jLabel16.setEnabled(true);
    }
}//GEN-LAST:event_jCheckBox3ActionPerformed

private void jCheckBox4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox4ActionPerformed
// TODO add your handling code here:
    if(jCheckBox4.isSelected()){
        jTextField12.setEnabled(true);
        jButton19.setEnabled(false);
        jLabel17.setEnabled(false);
    }else{
        jTextField12.setEnabled(false);
        jButton19.setEnabled(true);
        jLabel17.setEnabled(true);
    }
}//GEN-LAST:event_jCheckBox4ActionPerformed

private void jButton20ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton20ActionPerformed
// TODO add your handling code here:
    boolean check =true;
    if(jCheckBox1.isSelected()&&this.FileBase==null){
        JOptionPane.showMessageDialog(this.ForceDialog_1, "Πρέπει να οριστεί αρχείο τιμών επιτάχυνσης.");
        check=false;
    }
    if(check){
        double fdt=Double.parseDouble(jTextField25.getText());
        this.TotalT=Double.parseDouble(jTextField26.getText());
        this.theFParser.setTime(TotalT);
        this.theFParser.setTimeStep(fdt);
        if(jCheckBox1.isSelected()==false){
            if(jCheckBox2.isSelected()){
                this.theFParser.setFunction(jTextField10.getText());
                this.f1=this.theFParser.getFunctionAnalytic();
                //System.out.println("f1");
                //for(int i=0;i<f1.length;i++){System.out.println(i*dt+" "+f1[i]);}
            }else{
                this.f1=this.theFParser.getFunctionFromFile(File1);
            }
            if(jCheckBox3.isSelected()){
                this.theFParser.setFunction(jTextField11.getText());
                this.f2=this.theFParser.getFunctionAnalytic();
                //System.out.println("f2");
                //for(int i=0;i<f2.length;i++){System.out.println(i*dt+" "+f2[i]);}
            }else{
                this.f2=this.theFParser.getFunctionFromFile(File2);
            }
            if(jCheckBox4.isSelected()){
                this.theFParser.setFunction(jTextField12.getText());
                this.f3=this.theFParser.getFunctionAnalytic();
                //System.out.println("f3");
                //for(int i=0;i<f3.length;i++){System.out.println(i*dt+" "+f3[i]);}
            }else{
                this.f3=this.theFParser.getFunctionFromFile(File3);
            }
        }else{
            double[] fb=this.theFParser.getFunctionFromFile(this.FileBase);
            f1= new double[fb.length]; f2= new double[fb.length]; f3= new double[fb.length];

            if(this.theStructure.getType()==1){
                if(theStructure.isIsolated()==false){
                    for(int i=0; i<fb.length; i++){
                        f1[i]=-theStructure.getM().get(0, 0)*fb[i];
                        if(this.getNumStories()>1)f2[i]=-theStructure.getM().get(1, 1)*fb[i];
                        if(this.getNumStories()>2)f3[i]=-theStructure.getM().get(2, 2)*fb[i];
                    }
                }else{
                    f0= new double[fb.length];
                    for(int i=0; i<fb.length; i++){
                        f0[i]=-theStructure.getM().get(0, 0)*fb[i];
                        f1[i]=-theStructure.getM().get(1, 1)*fb[i];
                        if(this.getNumStories()>1)f2[i]=-theStructure.getM().get(2, 2)*fb[i];
                        if(this.getNumStories()>2)f3[i]=-theStructure.getM().get(3, 3)*fb[i];
                    }
                }
            }else{
                double angle = Double.parseDouble(this.jTextFieldAngle.getText());
                for(int i=0; i<fb.length; i++){
                    f1[i]=-theStructure.getM().get(0, 0)*fb[i]*Math.cos(Math.toRadians(angle));
                    f2[i]=-theStructure.getM().get(1, 1)*fb[i]*Math.sin(Math.toRadians(angle));
                    f3[i]=0.0;
                }
            }

        }
        jTextArea1.append('\n'+"-------------------------------------------------------"+'\n');
        jTextArea1.append(resb.getString("msg_000")+'\n');
        jTextArea1.append("-------------------------------------------------------"+'\n');
        jMenuItem12.setEnabled(true);
        ForceDialog_1.setVisible(false);
    }
}//GEN-LAST:event_jButton20ActionPerformed

private void jButton18ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton18ActionPerformed
// TODO add your handling code here:
    int option = theFileChooser.showOpenDialog(this);
    if (option == JFileChooser.APPROVE_OPTION) {
        this.File2 = theFileChooser.getSelectedFile();
        jLabel16.setText(File2.getName());
    }
}//GEN-LAST:event_jButton18ActionPerformed

private void jButton19ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton19ActionPerformed
// TODO add your handling code here:
    int option = theFileChooser.showOpenDialog(this);
    if (option == JFileChooser.APPROVE_OPTION) {
        this.File3 = theFileChooser.getSelectedFile();
        jLabel17.setText(File3.getName());
    }
}//GEN-LAST:event_jButton19ActionPerformed

private void jButton26ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton26ActionPerformed
// TODO add your handling code here:
    int option = theFileChooser.showOpenDialog(this);
    if (option == JFileChooser.APPROVE_OPTION) {
        this.FileBase = theFileChooser.getSelectedFile();
        jLabel18.setText(FileBase.getName());
    }
}//GEN-LAST:event_jButton26ActionPerformed

private void jCheckBox7ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox7ActionPerformed
// TODO add your handling code here:
    if(jCheckBox7.isSelected()){
        jLabel4.setEnabled(true);
        jTextField4.setEnabled(true);
        jLabel7.setEnabled(true);
        jTextField5.setEnabled(true);
        jLabel31.setEnabled(true);
        jTextField30.setEnabled(true);
        jLabel34.setEnabled(true);
        jTextField33.setEnabled(true);
        
        jCheckBox6.setEnabled(false);
        jCheckBox6.setSelected(true);
        
        jLabel3.setEnabled(true);
        jTextField3.setEnabled(true);
        jLabel6.setEnabled(true);
        jTextField6.setEnabled(true);
        jLabel30.setEnabled(true);
        jTextField29.setEnabled(true);
        jLabel33.setEnabled(true);
        jTextField32.setEnabled(true);
    }else{
        jLabel4.setEnabled(false);
        jTextField4.setEnabled(false);
        jLabel7.setEnabled(false);
        jTextField5.setEnabled(false);
        jLabel31.setEnabled(false);
        jTextField30.setEnabled(false);
        jLabel34.setEnabled(false);
        jTextField33.setEnabled(false);
        
        jCheckBox6.setEnabled(true);
    }
}//GEN-LAST:event_jCheckBox7ActionPerformed

private void jCheckBox6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox6ActionPerformed
// TODO add your handling code here:
    if(jCheckBox6.isSelected()){
        jLabel3.setEnabled(true);
        jTextField3.setEnabled(true);
        jLabel6.setEnabled(true);
        jTextField6.setEnabled(true);
        jLabel30.setEnabled(true);
        jTextField29.setEnabled(true);
        jLabel33.setEnabled(true);
        jTextField32.setEnabled(true);
        
    }else{
        jLabel3.setEnabled(false);
        jTextField3.setEnabled(false);
        jLabel6.setEnabled(false);
        jTextField6.setEnabled(false);
        jLabel30.setEnabled(false);
        jTextField29.setEnabled(false);
        jLabel33.setEnabled(false);
        jTextField32.setEnabled(false);
    }
}//GEN-LAST:event_jCheckBox6ActionPerformed

private void jCheckBox8ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox8ActionPerformed
// TODO add your handling code here:
    if(jCheckBox8.isSelected()){
        jLabel21.setEnabled(true);
        jTextField15.setEnabled(true);
        jLabel22.setEnabled(true);
        jTextField16.setEnabled(true);
        jLabel37.setEnabled(true);
        jTextField36.setEnabled(true);
    }else{
        jLabel21.setEnabled(false);
        jTextField15.setEnabled(false);
        jLabel22.setEnabled(false);
        jTextField16.setEnabled(false);
        jLabel37.setEnabled(false);
        jTextField36.setEnabled(false);
    }
}//GEN-LAST:event_jCheckBox8ActionPerformed

    private void jMenuItem5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem5ActionPerformed
        // TODO add your handling code here:
        JOptionPane.showMessageDialog(this, 
                      resb.getString("msg_079"),"About jframe",JOptionPane.INFORMATION_MESSAGE);
        
    }//GEN-LAST:event_jMenuItem5ActionPerformed

    private void jMenuItem6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem6ActionPerformed
        // TODO add your handling code here:
        BareBonesBrowserLaunch.openURL("http://dynasoft.civil.auth.gr/sources/PM_CAEE_preprint.pdf");
    }//GEN-LAST:event_jMenuItem6ActionPerformed

    private void jMenu1KeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jMenu1KeyPressed
        // TODO add your handling code here:
    }//GEN-LAST:event_jMenu1KeyPressed

    private void jMenuItem4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem4ActionPerformed
        // TODO add your handling code here:
        jLabel23.setBorder(BorderFactory.createTitledBorder(
            BorderFactory.createEtchedBorder(), resb.getString("msg_043")));
        ImageIcon icon=new javax.swing.ImageIcon(getClass().getResource("/images/st3.png"));
        Image image = icon.getImage().getScaledInstance(400, 493, Image.SCALE_SMOOTH);
        icon.setImage(image);
        jLabel23.setIcon(icon);

        jPanel2.setBorder(BorderFactory.createTitledBorder(
            BorderFactory.createEtchedBorder(), resb.getString("msg_040")));

            jPanel4.setBorder(BorderFactory.createTitledBorder(
                BorderFactory.createEtchedBorder(), resb.getString("msg_041")));

        jPanel5.setBorder(BorderFactory.createTitledBorder(
            BorderFactory.createEtchedBorder(), resb.getString("msg_042")));
            jTextField8.setBackground(Color.LIGHT_GRAY);
            FrameDialog.setLocationRelativeTo(this);
            FrameDialog.setVisible(true);
    }//GEN-LAST:event_jMenuItem4ActionPerformed

    private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem1ActionPerformed
        // TODO add your handling code here:
        tmp1=Double.parseDouble(jTextFieldSC1.getText());
        tmp2=Double.parseDouble(jTextFieldSC2.getText());
        tmp3=Double.parseDouble(jTextFieldSC3.getText());
        tmp4=Double.parseDouble(jTextFieldSC4.getText());
        tmp5=Double.parseDouble(jTextFieldSC5.getText());
        SpecCalcDialog.setVisible(true);
    }//GEN-LAST:event_jMenuItem1ActionPerformed

    private void jMenuItem8ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem8ActionPerformed
        // TODO add your handling code here:
        jSplitPane2.setDividerLocation(1100);
        DefaultTableModel tableModel = (DefaultTableModel) jTable_Spec.getModel();
        while (tableModel.getRowCount() != 0) {
            tableModel.removeRow(tableModel.getRowCount() - 1);
        }

        tableModel.setColumnCount(0);
        String name= ResourceBundle.getBundle("misc.bundle", local).getString("Period")+" (sec)";
        tableModel.addColumn(name);
        name= ResourceBundle.getBundle("misc.bundle", local).getString("msg_052")+" (m/sec^2)";
        tableModel.addColumn(name);

        double[] periods = this.theSpectrum.getPeriods();
        double[] acceler = this.theSpectrum.getAccelerations();
        int num = Math.max(periods.length, acceler.length);

        for(int i=0; i<num; i++){
            tableModel.addRow(new Object[]{periods[i],acceler[i]});
        }

        SpecDialog.setVisible(true);
    }//GEN-LAST:event_jMenuItem8ActionPerformed

    private void jMenuItem7ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem7ActionPerformed
        // TODO add your handling code here:
        switch(this.theStructure.getType()){
            case 0: this.inputloadsdof(); break;
            case 1: this.inputloadframe(); break;
            case 2: this.inputloadstorey();break;
        }
    }//GEN-LAST:event_jMenuItem7ActionPerformed

    private void jComboBox3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox3ActionPerformed
        // TODO add your handling code here:
        drawPanelGraph1.plot();
    }//GEN-LAST:event_jComboBox3ActionPerformed

    private void jComboBox4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox4ActionPerformed
        // TODO add your handling code here:
        drawPanelGraph1.plot();
    }//GEN-LAST:event_jComboBox4ActionPerformed

    private void jMenuItem9ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem9ActionPerformed
        // TODO add your handling code here:
        PlotDialog.setVisible(true);
    }//GEN-LAST:event_jMenuItem9ActionPerformed

    private void jMenuItem13ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem13ActionPerformed
        // TODO add your handling code here:
//        BareBonesBrowserLaunch.openURL("http://www.kallipos.gr/");
        if(lang.equalsIgnoreCase("gr")){
            BareBonesBrowserLaunch.openURL("http://repository.kallipos.gr/handle/11419/2465");
        }else{
            BareBonesBrowserLaunch.openURL("http://repository.kallipos.gr/handle/11419/2465?locale=en");
        }
    }//GEN-LAST:event_jMenuItem13ActionPerformed

    private void jMenuItem2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem2ActionPerformed
        // TODO add your handling code here:
            SDOFDialog.setLocationRelativeTo(this);
            SDOFDialog.setVisible(true);
    }//GEN-LAST:event_jMenuItem2ActionPerformed

    private void jButton7ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton7ActionPerformed
        // TODO add your handling code here:
    SDOFDialog.setVisible(false);
    }//GEN-LAST:event_jButton7ActionPerformed

    private void jButton10ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton10ActionPerformed
        // TODO add your handling code here:
        jMenuItem12.setEnabled(false);
        double m,k,z;
    
        k=Double.parseDouble(jTextField17.getText()); 
        m=Double.parseDouble(jTextField18.getText()); 
        z=Double.parseDouble(jTextField19.getText());
        
        theStructure = new core.SDOF();

        core.Node aNode;
        core.Element anElement;

        aNode = new core.Node(1,0.0,0.0);
        theStructure.addNode(aNode.getId(), aNode);
        aNode = new core.Node(2,0.0,theStructure.getYLength());
        theStructure.addNode(aNode.getId(), aNode);
        anElement = new core.Element(1, theStructure.getNode(1), theStructure.getNode(2));
        theStructure.addElement(anElement.getId(), anElement);
        double[] data = new double[2];
        data[0]=k; data[1]=m;
        theStructure.setGeometry(data);
        double totalMass=m;

        theStructure.setK();
        theStructure.setM();
        theStructure.setC(z/100.);
//        theStructure.setC(z);
        DecimalFormatSymbols comma =new DecimalFormatSymbols();
        comma.setDecimalSeparator('.');
        DecimalFormat Places = new DecimalFormat("0.000",comma);
        String sd1,sd2 = null,sd3 = null;
        Matrix mat;
        int sit;

        jTextArea1.append("====================================================="+'\n');
        jTextArea1.append(""+'\n');
        jTextArea1.append(resb.getString("Stiffness")+"=");
        mat = theStructure.getK();
        Places = new DecimalFormat("0.000",comma);
        sd1=Places.format(mat.get(0, 0));
        jTextArea1.append(sd1+'\n');

        jTextArea1.append(resb.getString("Mass")+"=");
        mat = theStructure.getM();
        Places = new DecimalFormat("0.000",comma);
        sd1=Places.format(mat.get(0, 0));
        jTextArea1.append(sd1+'\n');
        
        jTextArea1.append(resb.getString("Damping_ratio")+"=");
        mat = theStructure.getM();
        Places = new DecimalFormat("0.000",comma);
        sd1=Places.format(z);
        jTextArea1.append(sd1+'%'+'\n');

        jTextArea1.append(resb.getString("Damping_coefficient")+"=");
        mat = theStructure.getC();
        Places = new DecimalFormat("0.000",comma);
        sd1=Places.format(mat.get(0, 0));
        jTextArea1.append(sd1+'\n');
        
        jTextArea1.append("<"+resb.getString("Dynamic_properties")+">"+'\n');
        Places = new DecimalFormat("0.000",comma);
        sd1=Places.format(2.*Math.PI/Math.sqrt(theStructure.getK().get(0, 0)/theStructure.getM().get(0, 0)));
        jTextArea1.append(resb.getString("Period")+" T = "+sd1+'\n');
        double omega=(Math.sqrt(theStructure.getK().get(0, 0)/theStructure.getM().get(0, 0)));
        sd1=Places.format(omega);
        jTextArea1.append(resb.getString("Frequency")+" ω = "+sd1+'\n');
        sd1=Places.format(omega*Math.sqrt(Math.abs((z/100.)*(z/100.)-1)));
        jTextArea1.append(resb.getString("Frequency")+" ("+resb.getString("Damped")+") ωd = "+sd1+'\n');
        

        drawPanelInput1.setFrame(theStructure);
        specPanel1.setFrame(theStructure);
        drawPanelInput1.setSit(0);
        drawPanelInput1.setDef(false);
        drawPanelInput1.setInit(false);
        drawPanelInput1.setWhichStep(0);
        drawPanelInput1.stop();
        drawPanelInput1.plot();
        jButton_left.setEnabled(false);
        jButton_right.setEnabled(false);
        jMenuItem8.setEnabled(true);
        jMenuItem7.setEnabled(true);
        jMenuItem10.setEnabled(true);
        drawPanelGraph1.setRespAnalysed(false);
        drawPanelGraph1.setWhichStep(0);
        jButton_play.setEnabled(false);
        jButton_stop.setEnabled(false);
//        jComboBox4.setSelectedIndex(6);
        jComboBox4.setEnabled(false);
//        jComboBox3.setSelectedIndex(0);
        jComboBox3.setEnabled(false);
        jSlider2.setEnabled(false);
        jSlider2.setValue(50);
        drawPanelGraph1.plot();
        SDOFDialog.setVisible(false);
    }//GEN-LAST:event_jButton10ActionPerformed

    private void jButton5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton5ActionPerformed
        // TODO add your handling code here:
        newStoreyElemDialog.setVisible(true);
    }//GEN-LAST:event_jButton5ActionPerformed

    private void jButton6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton6ActionPerformed
        // TODO add your handling code here:
        // svise tis epilegmenes grammes tou pinaka stoixeion
        DefaultTableModel tableModel = new DefaultTableModel();
        //while (tableModel.getRowCount() != 0) {
            //    tableModel.removeRow(tableModel.getRowCount() - 1);
            //}

        tableModel.setColumnCount(0);
        //String name= "α/α";
        //tableModel.addColumn(name);
        String name= "x (m)";
        tableModel.addColumn(name);
        name= "y (m)";
        tableModel.addColumn(name);
        name= "bx (m)";
        tableModel.addColumn(name);
        name= "by (m)";
        tableModel.addColumn(name);
        for(int i=0; i<jTable_Spec.getRowCount(); i++){
            if(!jTable_Spec.isRowSelected(i)){
                tableModel.addRow(new Object[]{jTable_Spec.getValueAt(i, 0),jTable_Spec.getValueAt(i, 1),jTable_Spec.getValueAt(i, 2),jTable_Spec.getValueAt(i, 3)});
            }
        }
        jTable_Spec.setModel(tableModel);
    }//GEN-LAST:event_jButton6ActionPerformed

    private void jButton11ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton11ActionPerformed
        // TODO add your handling code here:
        StoreyDialog.setVisible(false);
    }//GEN-LAST:event_jButton11ActionPerformed

    private void jButton12ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton12ActionPerformed
        // TODO add your handling code here:
        //setdata(double Lx, double Ly, double p, double h, double Elast)
        jMenuItem12.setEnabled(false);
        double[] data = new double[5];
        data[0]=Double.parseDouble(jTextField20.getText());
        data[1]=Double.parseDouble(jTextField21.getText());
        data[2]=Double.parseDouble(jTextField22.getText());
        data[3]=Double.parseDouble(jTextField24.getText());
        data[4]=Double.parseDouble(jTextField23.getText());
        this.theStructure.setGeometry(data);
        Map<Integer,StoreyElement> theStElements = new HashMap<Integer,StoreyElement>();
        //DefaultTableModel tableModel = (DefaultTableModel) jTable1.getModel();
        theStructure.clearElements();
        StoreyElement anElement; Node aPoint;
        double x,y,bx,by;
        for(int i=0; i<jTable_Columns.getRowCount(); i++){
            x =Double.parseDouble((String) jTable_Columns.getValueAt(i, 0));
            y =Double.parseDouble((String) jTable_Columns.getValueAt(i, 1));
            bx=Double.parseDouble((String) jTable_Columns.getValueAt(i, 2));
            by=Double.parseDouble((String) jTable_Columns.getValueAt(i, 3));
            aPoint = new Node(i,x,y);
            anElement=new StoreyElement(aPoint,bx,by);
            theStElements.put(anElement.getId(), anElement);
        }
        theStructure.putStElements(theStElements);
        if(StiffRadioButtonStorey.isSelected()){((core.Storey)theStructure).setStiff(true);}else{((core.Storey)theStructure).setStiff(false);}

        if(theStructure.getSizeStElems()>0){
            theStructure.setK(); theStructure.setM();
            theStructure.EigenRun();
            double[] eigs=theStructure.getEigenValues();
            theStructure.setC(Double.parseDouble(jTextField39.getText())/100.);
            DecimalFormatSymbols comma =new DecimalFormatSymbols();
            comma.setDecimalSeparator('.');
            String sd1,sd2,sd3;
            jTextArea1.append("==============================================="+'\n');
            jTextArea1.append(""+'\n');
            jTextArea1.append("<"+resb.getString("msg_022")+">"+'\n');
            jTextArea1.append(""+'\n');
            Matrix mat = theStructure.getK();
            DecimalFormat Places = new DecimalFormat("0.000",comma);
            sd1=Places.format(mat.get(0, 0));
            sd2=Places.format(mat.get(0, 1));
            sd3=Places.format(mat.get(0, 2));
            jTextArea1.append(sd1+" "+sd2+" "+sd3+'\n');
            sd1=Places.format(mat.get(1, 0));
            sd2=Places.format(mat.get(1, 1));
            sd3=Places.format(mat.get(1, 2));
            jTextArea1.append(sd1+" "+sd2+" "+sd3+'\n');
            sd1=Places.format(mat.get(2, 0));
            sd2=Places.format(mat.get(2, 1));
            sd3=Places.format(mat.get(2, 2));
            jTextArea1.append(sd1+" "+sd2+" "+sd3+'\n');

            jTextArea1.append(""+'\n');
            jTextArea1.append("<"+resb.getString("msg_023")+">"+'\n');
            jTextArea1.append(""+'\n');
            mat = theStructure.getM();
            Places = new DecimalFormat("0.000",comma);
            sd1=Places.format(mat.get(0, 0));
            sd2=Places.format(mat.get(0, 1));
            sd3=Places.format(mat.get(0, 2));
            jTextArea1.append(sd1+" "+sd2+" "+sd3+'\n');
            sd1=Places.format(mat.get(1, 0));
            sd2=Places.format(mat.get(1, 1));
            sd3=Places.format(mat.get(1, 2));
            jTextArea1.append(sd1+" "+sd2+" "+sd3+'\n');
            sd1=Places.format(mat.get(2, 0));
            sd2=Places.format(mat.get(2, 1));
            sd3=Places.format(mat.get(2, 2));
            jTextArea1.append(sd1+" "+sd2+" "+sd3+'\n');

            jTextArea1.append(""+'\n');
            jTextArea1.append("<"+resb.getString("msg_024")+">"+'\n');
            jTextArea1.append(""+'\n');
            mat = theStructure.getC();
            Places = new DecimalFormat("0.000",comma);
            sd1=Places.format(mat.get(0, 0));
            sd2=Places.format(mat.get(0, 1));
            sd3=Places.format(mat.get(0, 2));
            jTextArea1.append(sd1+" "+sd2+" "+sd3+'\n');
            sd1=Places.format(mat.get(1, 0));
            sd2=Places.format(mat.get(1, 1));
            sd3=Places.format(mat.get(1, 2));
            jTextArea1.append(sd1+" "+sd2+" "+sd3+'\n');
            sd1=Places.format(mat.get(2, 0));
            sd2=Places.format(mat.get(2, 1));
            sd3=Places.format(mat.get(2, 2));
            jTextArea1.append(sd1+" "+sd2+" "+sd3+'\n');

            jTextArea1.append(""+'\n');
            jTextArea1.append("<"+resb.getString("msg_025")+">"+'\n');
            jTextArea1.append(""+'\n');
            Places = new DecimalFormat("0.000",comma);
            sd1=Places.format(((core.Storey)theStructure).getElastPoint().getX());
            sd2=Places.format(((core.Storey)theStructure).getElastPoint().getY());
            jTextArea1.append("K"+" : "+"x="+sd1+", y="+sd2+'\n');

//            jTextArea1.append(""+'\n');
//            jTextArea1.append("<Συντεταγμένες κέντρου μάζας>"+'\n');
//            jTextArea1.append(""+'\n');
//            Places = new DecimalFormat("0.000",comma);
//            sd1=Places.format(((core.Storey)theStructure).getMassPoint().getX());
//            sd2=Places.format(((core.Storey)theStructure).getMassPoint().getY());
//            jTextArea1.append("M"+" : "+"x="+sd1+", y="+sd2+'\n');

            jTextArea1.append(""+'\n');
            jTextArea1.append("<"+resb.getString("msg_026")+">"+'\n');
            jTextArea1.append(""+'\n');
            Places = new DecimalFormat("0.000",comma);
            sd1=Places.format(((core.Storey)theStructure).getR());
            jTextArea1.append("r"+" : "+sd1+'\n');

            jTextArea1.append(""+'\n');
            jTextArea1.append("<"+resb.getString("msg_027")+">"+'\n');
            jTextArea1.append(""+'\n');
            Places = new DecimalFormat("0.000",comma);
            for(int i=0;i<eigs.length;i++){
                sd1=Places.format(Math.sqrt(1./eigs[i]));
                jTextArea1.append(resb.getString("msg_028")+" ω"+Integer.toString(i+1)+": "+sd1+'\n');
            }
            jTextArea1.append(""+'\n');
            Places = new DecimalFormat("0.00000",comma);
            for(int i=0;i<eigs.length;i++){
                sd1=Places.format(2.*Math.PI/(Math.sqrt(1./eigs[i])));
                jTextArea1.append(resb.getString("msg_029")+" Τ"+Integer.toString(i+1)+": "+sd1+'\n');
            }
            Places = new DecimalFormat("0.000",comma);
            jTextArea1.append(""+'\n');
            jTextArea1.append("<"+resb.getString("msg_030")+">"+'\n');
            jTextArea1.append(""+'\n');
            sd1=Places.format(((core.Storey)theStructure).getOmegaI());
            jTextArea1.append(resb.getString("msg_028")+" ωI"+" : "+sd1+'\n');
            sd1=Places.format(((core.Storey)theStructure).getOmegaII());
            jTextArea1.append(resb.getString("msg_028")+" ωII"+" : "+sd1+'\n');
            sd1=Places.format(((core.Storey)theStructure).getOmegaIII());
            jTextArea1.append(resb.getString("msg_028")+" ωIII"+" : "+sd1+'\n');

            Places = new DecimalFormat("0.00000",comma);
            jTextArea1.append(""+'\n');
            jTextArea1.append("<"+resb.getString("msg_031")+">"+'\n');
            jTextArea1.append(""+'\n');
            sd1=Places.format(theStructure.getEigenVector(1)[0]);
            jTextArea1.append(resb.getString("msg_032")+" 1: φ11="+sd1);
            sd1=Places.format(theStructure.getEigenVector(1)[1]);
            jTextArea1.append(" φ21="+sd1);
            sd1=Places.format(theStructure.getEigenVector(1)[2]);
            jTextArea1.append(" φ31="+sd1+'\n');
            sd1=Places.format(theStructure.getEigenVector(2)[0]);
            jTextArea1.append(resb.getString("msg_032")+" 2: φ12="+sd1);
            sd1=Places.format(theStructure.getEigenVector(2)[1]);
            jTextArea1.append(" φ22="+sd1);
            sd1=Places.format(theStructure.getEigenVector(2)[2]);
            jTextArea1.append(" φ32="+sd1+'\n');
            sd1=Places.format(theStructure.getEigenVector(3)[0]);
            jTextArea1.append(resb.getString("msg_032")+" 3: φ13="+sd1);
            sd1=Places.format(theStructure.getEigenVector(3)[1]);
            jTextArea1.append(" φ23="+sd1);
            sd1=Places.format(theStructure.getEigenVector(3)[2]);
            jTextArea1.append(" φ33="+sd1+'\n');

            jTextArea1.append(""+'\n');
            jTextArea1.append("<"+resb.getString("msg_033")+">"+'\n');
            jTextArea1.append(""+'\n');
            Places = new DecimalFormat("0.00000",comma);
            sd1=Places.format(((core.Storey)theStructure).getPole1().getX());
            sd2=Places.format(((core.Storey)theStructure).getPole1().getY());
            jTextArea1.append("O1"+" : "+"x="+sd1+", y="+sd2+'\n');
            sd1=Places.format(((core.Storey)theStructure).getPole2().getX());
            sd2=Places.format(((core.Storey)theStructure).getPole2().getY());
            jTextArea1.append("O2"+" : "+"x="+sd1+", y="+sd2+'\n');
            sd1=Places.format(((core.Storey)theStructure).getPole3().getX());
            sd2=Places.format(((core.Storey)theStructure).getPole3().getY());
            jTextArea1.append("O3"+" : "+"x="+sd1+", y="+sd2+'\n');
        }

        drawPanelInput1.setFrame(theStructure);
        specPanel1.setFrame(theStructure);
        drawPanelInput1.setSit(1);
        drawPanelInput1.setDef(true);
        drawPanelInput1.setInit(false);
        drawPanelInput1.setWhichStep(0);
        drawPanelInput1.stop();
        drawPanelInput1.plot();
        jButton_left.setEnabled(true);
        jButton_right.setEnabled(true);
        jMenuItem8.setEnabled(true);
        jMenuItem7.setEnabled(true);
        jMenuItem10.setEnabled(true);
        drawPanelGraph1.setRespAnalysed(false);
        drawPanelGraph1.setWhichStep(0);
        jButton_play.setEnabled(false);
        jButton_stop.setEnabled(false);
//        jComboBox4.setSelectedIndex(6);
        jComboBox4.setEnabled(false);
//        jComboBox3.setSelectedIndex(0);
        jComboBox3.setEnabled(false);
        jSlider2.setEnabled(false);
        jSlider2.setValue(50);
        drawPanelGraph1.plot();
        StoreyDialog.setVisible(false);
    }//GEN-LAST:event_jButton12ActionPerformed

    private void FlexRadioButtonStoreyActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_FlexRadioButtonStoreyActionPerformed
        // TODO add your handling code here:
        if(FlexRadioButtonStorey.isSelected()){StiffRadioButtonStorey.setSelected(false);}
        if(!FlexRadioButtonStorey.isSelected()){StiffRadioButtonStorey.setSelected(true);}
    }//GEN-LAST:event_FlexRadioButtonStoreyActionPerformed

    private void StiffRadioButtonStoreyActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_StiffRadioButtonStoreyActionPerformed
        // TODO add your handling code here:
        if(StiffRadioButtonStorey.isSelected()){FlexRadioButtonStorey.setSelected(false);}
        if(!StiffRadioButtonStorey.isSelected()){FlexRadioButtonStorey.setSelected(true);}
    }//GEN-LAST:event_StiffRadioButtonStoreyActionPerformed

    private void jButton22ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton22ActionPerformed
        // TODO add your handling code here:
        int option = theFileChooser.showOpenDialog(this);
        File outFile;
        if (option == JFileChooser.APPROVE_OPTION) {
            outFile = theFileChooser.getSelectedFile();
            parseColumns(outFile);
        }
        StoreyDialog.setVisible(true);
    }//GEN-LAST:event_jButton22ActionPerformed

    private void jButton23ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton23ActionPerformed
        // TODO add your handling code here:
        newStoreyElemDialog.setVisible(false);
    }//GEN-LAST:event_jButton23ActionPerformed

    private void jButton24ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton24ActionPerformed
        // TODO add your handling code here:
        DefaultTableModel tableModel = (DefaultTableModel) jTable_Columns.getModel();
        tableModel.addRow(new Object[]{jTextField_newX.getText(),jTextField_newY.getText(),jTextField_newbx.getText(),jTextField_newby.getText()});
        if(Symetry.isSelected()&& Double.parseDouble(jTextField7.getText())!=0.){
            tableModel.addRow(new Object[]{jTextField_newX.getText(),Double.toString(-1.*Double.parseDouble(jTextField_newY.getText())),jTextField_newbx.getText(),jTextField_newby.getText()});
        }
        newStoreyElemDialog.setVisible(false);
    }//GEN-LAST:event_jButton24ActionPerformed

    private void jMenuItem3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem3ActionPerformed
        // TODO add your handling code here:
        theStructure = new core.Storey();
        DefaultTableModel tableModel = (DefaultTableModel) jTable_Columns.getModel();
        while (tableModel.getRowCount() != 0) {
            tableModel.removeRow(tableModel.getRowCount() - 1);
        }

        jScrollPane3.setBorder(BorderFactory.createTitledBorder(
               BorderFactory.createEtchedBorder(), resb.getString("msg_021")));
        tableModel.setColumnCount(0);
        //String name= "α/α";
        //tableModel.addColumn(name);
        String name= "x (m)";
        tableModel.addColumn(name);
        name= "y (m)";
        tableModel.addColumn(name);
        name= "bx (m)";
        tableModel.addColumn(name);
        name= "by (m)";
        tableModel.addColumn(name);
        Map<Integer,StoreyElement> theElements ;
        theElements = this.theStructure.getStElements();
        for(Iterator<StoreyElement> it=theElements.values().iterator(); it.hasNext();){
            StoreyElement theElement = it.next();
            //tableModel.addRow(new Object[]{theElement.getId(),theElement.getPoint().getX(),theElement.getPoint().getY(),theElement.getbx(),theElement.getby()});
            tableModel.addRow(new Object[]{Double.toString(theElement.getPoint().getX()),Double.toString(theElement.getPoint().getY()),Double.toString(theElement.getbx()),Double.toString(theElement.getby())});
        }
            StoreyDialog.setLocationRelativeTo(this);
            StoreyDialog.setVisible(true);
    }//GEN-LAST:event_jMenuItem3ActionPerformed

    private void jButtonupdfsdofActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonupdfsdofActionPerformed
        // TODO add your handling code here:
        this.dt=Double.parseDouble(jTextField27.getText());
        this.TotalT=Double.parseDouble(jTextField37.getText());
        this.theFParser.setTime(TotalT);
        this.theFParser.setTimeStep(dt);
        if(jCheckBoxsdof.isSelected()){
            this.theFParser.setFunction(this.jTextFieldfsdof.getText());
            this.f1=this.theFParser.getFunctionAnalytic();
            //System.out.println("f1");
            //for(int i=0;i<f1.length;i++){System.out.println(i*dt+" "+f1[i]);}
        }else{
            this.f1=this.theFParser.getFunctionFromFile(File1);
        }
        jTextArea1.append('\n'+"-------------------------------------------------------"+'\n');
        jTextArea1.append(resb.getString("msg_000")+'\n');
        jTextArea1.append("-------------------------------------------------------"+'\n');
        this.ForceDialogSDOF.setVisible(false);
        jMenuItem12.setEnabled(true);
    }//GEN-LAST:event_jButtonupdfsdofActionPerformed

    private void jButtoncnlfsdofActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtoncnlfsdofActionPerformed
        // TODO add your handling code here:
        this.ForceDialogSDOF.setVisible(false);
    }//GEN-LAST:event_jButtoncnlfsdofActionPerformed

    private void jCheckBoxsdofActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxsdofActionPerformed
        // TODO add your handling code here:
        if(jCheckBoxsdof.isSelected()){
            jTextFieldfsdof.setEnabled(true);
            jButtonfsdof.setEnabled(false);
            jLabelsdof.setEnabled(false);
        }else{
            jTextFieldfsdof.setEnabled(false);
            jButtonfsdof.setEnabled(true);
            jLabelsdof.setEnabled(true);
        }
    }//GEN-LAST:event_jCheckBoxsdofActionPerformed

    private void jButtonfsdofActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonfsdofActionPerformed
        // TODO add your handling code here:
    int option = theFileChooser.showOpenDialog(this);
    if (option == JFileChooser.APPROVE_OPTION) {
        this.File1 = theFileChooser.getSelectedFile();
        jLabelsdof.setText(File1.getName());
    }
    }//GEN-LAST:event_jButtonfsdofActionPerformed

    private void jButton25ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton25ActionPerformed
        // TODO add your handling code here:
        jTextFieldbeta.setText(Double.toString(tmp1));
        jTextFieldgamma.setText(Double.toString(tmp2));
        this.jDialogNewmark.setVisible(false);
    }//GEN-LAST:event_jButton25ActionPerformed

    private void jButton27ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton27ActionPerformed
        // TODO add your handling code here:
        this.jDialogNewmark.setVisible(false);
    }//GEN-LAST:event_jButton27ActionPerformed

    private void jMenuItem11ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem11ActionPerformed
        // TODO add your handling code here:
        this.tmp1=Double.parseDouble(jTextFieldbeta.getText());
        this.tmp2=Double.parseDouble(jTextFieldgamma.getText());
        this.jDialogNewmark.setVisible(true);
    }//GEN-LAST:event_jMenuItem11ActionPerformed

    private void jMenuItem12ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem12ActionPerformed
        // TODO add your handling code here:
        dt=Double.parseDouble(jTextFieldNewmark_dt.getText());
        double a[]=new double[8];
        double alpha=Double.parseDouble(jTextFieldbeta.getText());
        double delta=Double.parseDouble(jTextFieldgamma.getText());
        a[0]=1./(alpha*dt*dt); a[1]=delta/(alpha*dt);          a[2]=1./(alpha*dt); a[3]=1./(2.*alpha)-1.;
        a[4]=delta/alpha-1.;   a[5]=delta/2.*(delta/alpha-2.); a[6]=dt*(1.-delta); a[7]=delta*dt;
        double Dt=this.theFParser.getTimeStep();
        if(dt>Dt)dt=Dt;
        double TotalTime=theFParser.getTotalTime();
        int m=(int) Math.floor(TotalTime/dt)+1;
        f0_interp=new double[m];
        f1_interp=new double[m];
        f2_interp=new double[m];
        f3_interp=new double[m];
        if(f0!=null)f0_interp[0]=f0[0];
        if(f1!=null)f1_interp[0]=f1[0];
        if(f2!=null)f2_interp[0]=f2[0];
        if(f3!=null)f3_interp[0]=f3[0];
        for(int i=1;i<m;i++){
            double t=i*dt;
            int q=(int) Math.floor(t/Dt);
            if(q<f1.length-1){
                if(f0!=null)f0_interp[i]=f0[q]+(f0[q+1]-f0[q])*(t-q*Dt)/Dt;
                if(f1!=null)f1_interp[i]=f1[q]+(f1[q+1]-f1[q])*(t-q*Dt)/Dt;
                if(f2!=null)f2_interp[i]=f2[q]+(f2[q+1]-f2[q])*(t-q*Dt)/Dt;
                if(f3!=null)f3_interp[i]=f3[q]+(f3[q+1]-f3[q])*(t-q*Dt)/Dt;
            }else{
                if(f0!=null)f0_interp[i]=f0[q-1]+(f0[q]-f0[q-1])*(t-(q-1)*Dt)/Dt;
                if(f1!=null)f1_interp[i]=f1[q-1]+(f1[q]-f1[q-1])*(t-(q-1)*Dt)/Dt;
                if(f2!=null)f2_interp[i]=f2[q-1]+(f2[q]-f2[q-1])*(t-(q-1)*Dt)/Dt;
                if(f3!=null)f3_interp[i]=f3[q-1]+(f3[q]-f3[q-1])*(t-(q-1)*Dt)/Dt;
            }
            
//            System.out.println(t+" "+fext_interp[i]);
        }
        u1 = new double[f1_interp.length]; u2 = new double[f1_interp.length]; u3 = new double[f1_interp.length];
        v1 = new double[f1_interp.length]; v2 = new double[f1_interp.length]; v3 = new double[f1_interp.length];
        a1 = new double[f1_interp.length]; a2 = new double[f1_interp.length]; a3 = new double[f1_interp.length];
        u0 = new double[f1_interp.length]; v0 = new double[f1_interp.length]; a0 = new double[f1_interp.length];
        Matrix Cm = theStructure.getC();
        int stories = this.theStructure.getNumDOFS();
        if(theStructure.isIsolated())stories+=1;
        Matrix Keff=new Matrix(stories,stories);
        Matrix Reff=new Matrix(stories,1);
        Matrix U=new Matrix(stories,1); U.init();u0[0]=this.u0init; u1[0]=this.u1init;u2[0]=this.u2init;u3[0]=this.u3init;
        Matrix Un=new Matrix(stories,1);
        Matrix V=new Matrix(stories,1); V.init();v0[0]=this.v0init; v1[0]=this.v1init;v2[0]=this.v2init;v3[0]=this.v3init;
        Matrix Vn=new Matrix(stories,1);
        Matrix A=new Matrix(stories,1);
        Matrix An=new Matrix(stories,1);
        
        if(theStructure.isIsolated()){
            U.set(0, 0, u0[0]); U.set(1, 0, u1[0]); if(this.getNumStories()>1)U.set(2, 0, u2[0]); if(this.getNumStories()>2)U.set(3, 0, u3[0]);
            V.set(0, 0, u0[0]); V.set(1, 0, v1[0]); if(this.getNumStories()>1)V.set(2, 0, v2[0]); if(this.getNumStories()>2)V.set(3, 0, v3[0]);
        }else{
            U.set(0, 0, u1[0]); 
            if(this.getNumStories()>1)U.set(1, 0, u2[0]); 
            if(this.getNumStories()>2)U.set(2, 0, u3[0]);
            
            V.set(0, 0, v1[0]); 
            if(this.getNumStories()>1)V.set(1, 0, v2[0]); 
            if(this.getNumStories()>2)V.set(2, 0, v3[0]);
        }

        if(theStructure.isIsolated()){
            Reff.set(0, 0, f0_interp[0]); Reff.set(1, 0, f1_interp[0]); if(this.getNumStories()>1)Reff.set(2, 0, f2_interp[0]); if(this.getNumStories()>2)Reff.set(3, 0, f3_interp[0]);
        }else{
            Reff.set(0, 0, f1_interp[0]); 
            if(this.getNumStories()>1)Reff.set(1, 0, f2_interp[0]); 
            if(this.getNumStories()>2)Reff.set(2, 0, f3_interp[0]);
        }

        A=(theStructure.getM().inverse()).times( (Reff.minus( theStructure.getK().times(U) )).minus(Cm.times(V)));

        if(theStructure.isIsolated()){
            a0[0]=A.get(0, 0); a1[0]=A.get(1, 0);if(this.getNumStories()>1)a2[0]=A.get(2, 0);if(this.getNumStories()>2)a3[0]=A.get(3, 0);
        }else{
            a1[0]=A.get(0, 0);if(this.getNumStories()>1)a2[0]=A.get(1, 0);if(this.getNumStories()>2)a3[0]=A.get(2, 0);
        }


        Keff=theStructure.getK().plus(theStructure.getM().times(a[0]));
        Keff=Keff.plus(Cm.times(a[1]));    
        for(int i=1;i<f1_interp.length;i++){
            Reff.init();
            if(theStructure.isIsolated()){
                Reff.addVal(0, 0, f0_interp[i]); Reff.addVal(1, 0, f1[i]); if(this.getNumStories()>1)Reff.addVal(2, 0, f2_interp[i]); if(this.getNumStories()>2)Reff.addVal(3, 0, f3_interp[i]);
            }else{
                Reff.addVal(0, 0, f1_interp[i]); if(this.getNumStories()>1)Reff.addVal(1, 0, f2_interp[i]); if(this.getNumStories()>2)Reff.addVal(2, 0, f3_interp[i]);
            }

            Reff=Reff.plus(theStructure.getM().times( (U.times(a[0])) ));
            Reff=Reff.plus(theStructure.getM().times( (V.times(a[2])) ));
            Reff=Reff.plus(theStructure.getM().times( (A.times(a[3])) ));

            Reff=Reff.plus(Cm.times(U.times(a[1])));
            Reff=Reff.plus(Cm.times(V.times(a[4])));
            Reff=Reff.plus(Cm.times(A.times(a[5])));

            Un=(Keff.inverse()).times(Reff);
            An=Un.minus(U); An=An.times(a[0]); An=An.minus(V.times(a[2])); An=An.minus(A.times(a[3]));
            Vn=V; Vn=Vn.plus(A.times(a[6])); Vn=Vn.plus(An.times(a[7]));

            if(theStructure.isIsolated()){
                u0[i]=Un.get(0, 0); u1[i]=Un.get(1, 0);if(this.getNumStories()>1)u2[i]=Un.get(2, 0);if(this.getNumStories()>2)u3[i]=Un.get(3, 0);
                v0[i]=Vn.get(0, 0); v1[i]=Vn.get(1, 0);if(this.getNumStories()>1)v2[i]=Vn.get(2, 0);if(this.getNumStories()>2)v3[i]=Vn.get(3, 0);
                a0[i]=An.get(0, 0); a1[i]=An.get(1, 0);if(this.getNumStories()>1)a2[i]=An.get(2, 0);if(this.getNumStories()>2)a3[i]=An.get(3, 0);
            }else{
                u1[i]=Un.get(0, 0);if(this.getNumStories()>1)u2[i]=Un.get(1, 0);if(this.getNumStories()>2)u3[i]=Un.get(2, 0);
                v1[i]=Vn.get(0, 0);if(this.getNumStories()>1)v2[i]=Vn.get(1, 0);if(this.getNumStories()>2)v3[i]=Vn.get(2, 0);
                a1[i]=An.get(0, 0);if(this.getNumStories()>1)a2[i]=An.get(1, 0);if(this.getNumStories()>2)a3[i]=An.get(2, 0);
            }


            U=Un; V=Vn; A=An;
        }
        DecimalFormatSymbols comma =new DecimalFormatSymbols();
        comma.setDecimalSeparator('.');
        DecimalFormat Places = new DecimalFormat("00.###E0",comma);
        String sd1,sd2 = null,sd3 = null,sd4 = null,sd5 = null;
        jTextArea1.append(""+'\n');
        jTextArea1.append("-------------------------"+'\n');
        jTextArea1.append(resb.getString("msg_001")+" \n");
        jTextArea1.append(resb.getString("msg_002")+" \n");
        if(theStructure.getType()==1)jTextArea1.append(resb.getString("msg_005")+" \n");
        if(theStructure.getType()==0)jTextArea1.append(resb.getString("msg_004")+" \n");
        if(theStructure.getType()==2)jTextArea1.append(resb.getString("msg_006")+" \n");
        jTextArea1.append(resb.getString("msg_003")+" \n");
        jTextArea1.append("-------------------------"+'\n');
        for(int i=0;i<f1_interp.length;i++){
            sd1=Places.format(i*dt);
            sd2=Places.format(f1_interp[i]);
            sd3=Places.format(u1[i]);
            sd4=Places.format(v1[i]);
            sd5=Places.format(a1[i]);
            jTextArea1.append(sd1+" "+sd2+" "+sd3+" "+sd4+" "+sd5+" "+'\n');
        }
        if(this.getNumStories()>1){
            jTextArea1.append(""+'\n');
            jTextArea1.append("-------------------------"+'\n');
            jTextArea1.append(resb.getString("msg_001")+" \n");
            jTextArea1.append(resb.getString("msg_002")+" \n");
            if(theStructure.getType()==1)jTextArea1.append(resb.getString("msg_007")+" \n");
            if(theStructure.getType()==2)jTextArea1.append(resb.getString("msg_008")+" \n");
            jTextArea1.append(resb.getString("msg_003")+" \n");
            jTextArea1.append("-------------------------"+'\n');
            for(int i=0;i<f1_interp.length;i++){
                sd1=Places.format(i*dt);
                sd2=Places.format(f2_interp[i]);
                sd3=Places.format(u2[i]);
                sd4=Places.format(v2[i]);
                sd5=Places.format(a2[i]);
                jTextArea1.append(sd1+" "+sd2+" "+sd3+" "+sd4+" "+sd5+" "+'\n');
            }
        }
        if(this.getNumStories()>2){
            jTextArea1.append(""+'\n');
            jTextArea1.append("-------------------------"+'\n');
            jTextArea1.append(resb.getString("msg_001")+" \n");
            jTextArea1.append(resb.getString("msg_002")+" \n");
            if(theStructure.getType()==1)jTextArea1.append(resb.getString("msg_009")+" \n");
            if(theStructure.getType()==2)jTextArea1.append(resb.getString("msg_010")+" \n");
            jTextArea1.append("t "+"f3 "+"u3 "+"v3 "+"a3"+'\n');
            jTextArea1.append("-------------------------"+'\n');
            for(int i=0;i<f1_interp.length;i++){
                sd1=Places.format(i*dt);
                sd2=Places.format(f3_interp[i]);
                sd3=Places.format(u3[i]);
                sd4=Places.format(v3[i]);
                sd5=Places.format(a3[i]);
                jTextArea1.append(sd1+" "+sd2+" "+sd3+" "+sd4+" "+sd5+" "+'\n');
            }
        }
    //    jComboBox1.setEnabled(true);
    //    jComboBox2.setEnabled(true);
        jComboBox3.setEnabled(true);
        jComboBox4.setEnabled(true);
        jButton_play.setEnabled(true);
        theStructure.setDisp0(u0);theStructure.setDisp1(u1);theStructure.setDisp2(u2);theStructure.setDisp3(u3);
        theStructure.setMax();

        this.drawPanelInput1.setNumStep(this.f1_interp.length);
        this.drawPanelInput1.setTimeStep(dt);
        drawPanelInput1.setWhichStep(0);
        drawPanelGraph1.setRespAnalysed(true);
        drawPanelGraph1.setWhichStep(0);
        RespPlot.setSelected(true);
        drawPanelGraph1.plot();
    }//GEN-LAST:event_jMenuItem12ActionPerformed

    private void jButton28ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton28ActionPerformed
        // TODO add your handling code here:
        u1init=Double.parseDouble(jTextField38.getText());
        u2init=Double.parseDouble(jTextField14.getText());
        u3init=Double.parseDouble(jTextField13.getText());

        v1init=Double.parseDouble(jTextField43.getText());
        v2init=Double.parseDouble(jTextField42.getText());
        v3init=Double.parseDouble(jTextField41.getText());
        this.InitialDialog_1.setVisible(false);
    }//GEN-LAST:event_jButton28ActionPerformed

    private void jButton29ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton29ActionPerformed
        // TODO add your handling code here:
        jTextField38.setText(Double.toString(tmp1));
        jTextField14.setText(Double.toString(tmp2));
        jTextField13.setText(Double.toString(tmp3));
        
        jTextField43.setText(Double.toString(tmp4));
        jTextField42.setText(Double.toString(tmp5));
        jTextField41.setText(Double.toString(tmp6));
        
        this.InitialDialog_1.setVisible(false);
    }//GEN-LAST:event_jButton29ActionPerformed

    private void jMenuItem10ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem10ActionPerformed
        // TODO add your handling code here:
        switch(this.theStructure.getType()){
            case 0: this.initialsdof(); 
            tmp1=Double.parseDouble(jTextField44.getText());
            tmp2=Double.parseDouble(jTextField47.getText());
            break;
            case 1: this.initialframe(); 
            tmp1=Double.parseDouble(jTextField38.getText());
            tmp2=Double.parseDouble(jTextField14.getText());
            tmp3=Double.parseDouble(jTextField13.getText());
            
            tmp4=Double.parseDouble(jTextField43.getText());
            tmp5=Double.parseDouble(jTextField42.getText());
            tmp6=Double.parseDouble(jTextField41.getText());
            break;
            case 2: this.initialstorey();
            tmp1=Double.parseDouble(jTextField38.getText());
            tmp2=Double.parseDouble(jTextField14.getText());
            tmp3=Double.parseDouble(jTextField13.getText());
            
            tmp4=Double.parseDouble(jTextField43.getText());
            tmp5=Double.parseDouble(jTextField42.getText());
            tmp6=Double.parseDouble(jTextField41.getText());
            break;
        }
    }//GEN-LAST:event_jMenuItem10ActionPerformed

    private void jButton30ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton30ActionPerformed
        // TODO add your handling code here:
        jTextField44.setText(Double.toString(tmp1));
        jTextField47.setText(Double.toString(tmp2));
        this.InitialDialogSDOF.setVisible(false);
    }//GEN-LAST:event_jButton30ActionPerformed

    private void jButton31ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton31ActionPerformed
        // TODO add your handling code here:
        this.u1init=Double.parseDouble(jTextField44.getText());
        this.v1init=Double.parseDouble(jTextField47.getText());
        this.InitialDialogSDOF.setVisible(false);
    }//GEN-LAST:event_jButton31ActionPerformed

    private void FindFileButtonSCActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_FindFileButtonSCActionPerformed
        // TODO add your handling code here:
        int option = theFileChooser.showOpenDialog(this);
        if (option == JFileChooser.APPROVE_OPTION) {
            this.FileBase = theFileChooser.getSelectedFile();
            jLabelSC11.setText(FileBase.getName());
        }
    }//GEN-LAST:event_FindFileButtonSCActionPerformed

    private void jButton32ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton32ActionPerformed
        // TODO add your handling code here:
        jTextFieldSC1.setText(Double.toString(tmp1));
        jTextFieldSC2.setText(Double.toString(tmp2));
        jTextFieldSC3.setText(Integer.toString((int)tmp3));
        jTextFieldSC4.setText(Double.toString(tmp4));
        jTextFieldSC5.setText(Double.toString(tmp5));
        this.SpecCalcDialog.setVisible(false);
    }//GEN-LAST:event_jButton32ActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        // TODO add your handling code here:
        double T1=Double.parseDouble(this.jTextFieldSC1.getText());
        double T2=Double.parseDouble(this.jTextFieldSC2.getText());
        int numT=Integer.parseInt(this.jTextFieldSC3.getText());
        double zeta=Double.parseDouble(this.jTextFieldSC4.getText())/100.;
        double Dts=Double.parseDouble(this.jTextFieldSC5.getText());
        double dts=10.*Dts;
        if(jCheckBox12.isSelected()){
            dts=Double.parseDouble(jTextFieldNewmark_dt.getText());
        }else{
            try {
                BufferedReader in = new BufferedReader(new FileReader(FileBase.getPath()));
                String str;
                str = in.readLine();
                str = in.readLine();
                dts = Double.parseDouble(str.split(" ")[0]);
                in.close();
            } catch (IOException e) {
            }
        }
        
        boolean check=true;
        if(Dts<dts){
            JOptionPane.showMessageDialog(this.SpecCalcDialog, this.resb.getString("msg_011"));
            check=false;
        }
        if(FileBase == null){
            JOptionPane.showMessageDialog(this.SpecCalcDialog, this.resb.getString("msg_012"));
            check=false;
        }
        if(check){
            this.SpecCalcDialog.setVisible(false);
            try {
                BufferedReader in = new BufferedReader(new FileReader(FileBase.getPath()));
                String str;
                int n=0;
                while ((str = in.readLine()) != null) {
                    ++n;
                }
                in.close();
                in = new BufferedReader(new FileReader(FileBase.getPath()));
                fb = new double[n];
                for(int j=0;j<n;j++)fb[j]=0.0;
                n=0;
                while ((str = in.readLine()) != null) {
                    if(jCheckBox12.isSelected()){
                        if(n<fb.length && isDouble(str) ){
                            fb[n]=Double.parseDouble(str);
                        } 
                    }else{
                        if(n<fb.length && isDouble(str.split(" ")[1]) ){
                            fb[n]=Double.parseDouble(str.split(" ")[1]);
                        } 
                    }
                    
                    ++n;
                }
                in.close();
            } catch (IOException e) {
            }

            this.theSpecCalc = new core.SpecCalc(numT, T1, T2, zeta,fb,Dts,dts);
            double b=Double.parseDouble(this.jTextFieldbeta.getText());
            double g=Double.parseDouble(this.jTextFieldgamma.getText());
            theSpecCalc.set_b_g(b, g);
            theSpecCalc.calc();

            DecimalFormatSymbols comma =new DecimalFormatSymbols();
            comma.setDecimalSeparator('.');
            DecimalFormat Places = new DecimalFormat("00.###E0",comma);
            String sd1,sd2 = null,sd3 = null,sd4 = null,sd5 = null;
            jTextArea1.append(""+'\n');
            jTextArea1.append("-------------------------"+'\n');
            jTextArea1.append(resb.getString("msg_013")+jTextFieldSC4.getText()+"%"+'\n');
            jTextArea1.append(resb.getString("msg_014")+jLabelSC11.getText()+'\n');
            jTextArea1.append("T "+"Sd "+"PSv "+"PSa "+'\n');
            jTextArea1.append("-------------------------"+'\n');
            for(int i=0;i<theSpecCalc.getSize();i++){
                sd1=Places.format(theSpecCalc.get_thePeriods()[i]);
                sd2=Places.format(theSpecCalc.get_Sdisp()[i]);
                sd3=Places.format(theSpecCalc.get_PSvelc()[i]);
                sd4=Places.format(theSpecCalc.get_PSaccl()[i]);
                jTextArea1.append(sd1+" "+sd2+" "+sd3+" "+sd4+" "+" "+'\n');
            }
            
            drawPanelGraph1.setRespAnalysed(true);
            this.SpecPlot.setSelected(true);
            this.drawPanelGraph1.setSpecAnalysed(true);
            
            jComboBox3.setEnabled(true);
            jComboBox4.setEnabled(true);
            
            listModel = new DefaultComboBoxModel();
            listModel.addElement(resb.getString("Time"));
            listModel.addElement(resb.getString("eigenperiod"));
            
            jComboBox3.setModel(listModel);
            jComboBox3.setSelectedIndex(0);
            
            listModel = new DefaultComboBoxModel();
            listModel.addElement(resb.getString("Acceleration"));
            listModel.addElement(resb.getString("Spectral")+resb.getString("Displacement"));
            listModel.addElement(resb.getString("Spectral")+resb.getString("Velocity"));
            listModel.addElement(resb.getString("Spectral")+resb.getString("Acceleration"));
            jComboBox4.setModel(listModel);
            jComboBox4.setSelectedIndex(0);
            
            jButton_play.setEnabled(false);
            this.jButton_stop.setEnabled(false);
            this.jButton_left.setEnabled(false);
            this.jButton_right.setEnabled(false);
            this.jSlider2.setEnabled(false);
            drawPanelGraph1.plot();
        }
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jButton8ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton8ActionPerformed
        // TODO add your handling code here:
        GroundDialog.setVisible(false);
    }//GEN-LAST:event_jButton8ActionPerformed

    private void jButton9ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton9ActionPerformed
        // TODO add your handling code here:
        this.theGround = new core.Ground();
        theGround.setSo(Double.parseDouble(jTextField34.getText()));
        double duration=Double.parseDouble(jTextField50.getText());
        theGround.setT(duration);
        theGround.set_t1(Double.parseDouble(jTextField51.getText())*Double.parseDouble(jTextField50.getText())/100.);
        theGround.set_t2(Double.parseDouble(jTextField52.getText())*Double.parseDouble(jTextField50.getText())/100.);
        theGround.setN(Integer.parseInt(this.jTextField54.getText()));
        theGround.setOm_a(Double.parseDouble(jTextField55.getText()));
        theGround.setOm_b(Double.parseDouble(jTextField56.getText()));
        
        if(this.jCheckBox9.isSelected()){
            theGround.setH_Pfilter(true);
            theGround.setxsi1(Double.parseDouble(jTextField40.getText())/100.);
            theGround.setom1(Double.parseDouble(jTextField35.getText()));
        }
        
        if(this.jCheckBox10.isSelected()){
            theGround.setK_Tfilter(true);
            theGround.setxsi2(Double.parseDouble(jTextField45.getText())/100.);
            theGround.setom2(Double.parseDouble(jTextField46.getText()));
        }
        
        if(this.jCheckBox11.isSelected()){
            theGround.setL_Pfilter(true);
            theGround.setxsi1(Double.parseDouble(jTextField48.getText())/100.);
            theGround.setom1(Double.parseDouble(jTextField49.getText()));
        }
        this.GroundDialog.setVisible(false);
        int tsn=(int) Math.floor(duration/Double.parseDouble(this.jTextField53.getText()));
        theGround.Calc(tsn);
        DecimalFormatSymbols comma =new DecimalFormatSymbols();
        comma.setDecimalSeparator('.');
        DecimalFormat Places = new DecimalFormat("00.###E0",comma);
        String sd1,sd2 = null,sd3 = null,sd4 = null,sd5 = null;
        jTextArea1.append(""+'\n');
        jTextArea1.append("-------------------------"+'\n');
        jTextArea1.append(resb.getString("msg_064")+jTextFieldSC4.getText()+"%"+'\n');
        jTextArea1.append(resb.getString("msg_065")+'\n');
        jTextArea1.append("-------------------------"+'\n');
        
        for(int i=0;i<tsn;i++){
            sd1=Places.format(i*duration/(tsn-1));
            sd2=Places.format(theGround.getSynthAcc()[i]);
            sd3=Places.format(theGround.getSynthVel()[i]);
            sd4=Places.format(theGround.getSynthDis()[i]);
            jTextArea1.append(sd1+" "+sd2+" "+sd3+" "+sd4+" "+" "+'\n');
        }
        
        drawPanelGraph1.setRespAnalysed(true);
        this.SpecPlot.setSelected(true);
        this.drawPanelGraph1.setSpecAnalysed(true);
        
        jComboBox3.setEnabled(true);
        jComboBox4.setEnabled(true);

        listModel = new DefaultComboBoxModel();
        listModel.addElement(resb.getString("Time"));
        
        jComboBox3.setModel(listModel);
        jComboBox3.setSelectedIndex(0);

        listModel = new DefaultComboBoxModel();
        listModel.addElement(resb.getString("Acceleration"));
        listModel.addElement(resb.getString("Velocity"));
        listModel.addElement(resb.getString("Displacement"));
        jComboBox4.setModel(listModel);
        jComboBox4.setSelectedIndex(0);
        
        jButton_play.setEnabled(false);
        this.jButton_stop.setEnabled(false);
        this.jButton_left.setEnabled(false);
        this.jButton_right.setEnabled(false);
        this.jSlider2.setEnabled(false);
        drawPanelGraph1.plot();
    }//GEN-LAST:event_jButton9ActionPerformed

    private void jMenuItem14ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem14ActionPerformed
        // TODO add your handling code here:
        jPanel15.setBorder(BorderFactory.createTitledBorder(
            BorderFactory.createEtchedBorder(), resb.getString("msg_061")));
        jPanel16.setBorder(BorderFactory.createTitledBorder(
            BorderFactory.createEtchedBorder(), resb.getString("msg_055")));
        jPanel17.setBorder(BorderFactory.createTitledBorder(
            BorderFactory.createEtchedBorder(), resb.getString("msg_056")));
        jPanel18.setBorder(BorderFactory.createTitledBorder(
            BorderFactory.createEtchedBorder(), resb.getString("msg_057")));
            GroundDialog.setLocationRelativeTo(this);
            GroundDialog.setVisible(true);
    }//GEN-LAST:event_jMenuItem14ActionPerformed

    private void jCheckBox9ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox9ActionPerformed
        // TODO add your handling code here:
        if(this.jCheckBox9.isSelected()){
            this.jLabel36.setEnabled(true);
            this.jLabel54.setEnabled(true);
            this.jTextField35.setEnabled(true);
            this.jTextField40.setEnabled(true);
        }else{
            this.jLabel36.setEnabled(false);
            this.jLabel54.setEnabled(false);
            this.jTextField35.setEnabled(false);
            this.jTextField40.setEnabled(false);
        }
    }//GEN-LAST:event_jCheckBox9ActionPerformed

    private void jCheckBox10ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox10ActionPerformed
        // TODO add your handling code here:
        if(this.jCheckBox10.isSelected()){
            this.jLabel56.setEnabled(true);
            this.jLabel55.setEnabled(true);
            this.jTextField46.setEnabled(true);
            this.jTextField45.setEnabled(true);
        }else{
            this.jLabel56.setEnabled(false);
            this.jLabel55.setEnabled(false);
            this.jTextField46.setEnabled(false);
            this.jTextField45.setEnabled(false);
        }
    }//GEN-LAST:event_jCheckBox10ActionPerformed

    private void jCheckBox11ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox11ActionPerformed
        // TODO add your handling code here:
        if(this.jCheckBox11.isSelected()){
            this.jLabel62.setEnabled(true);
            this.jLabel57.setEnabled(true);
            this.jTextField49.setEnabled(true);
            this.jTextField48.setEnabled(true);
        }else{
            this.jLabel62.setEnabled(false);
            this.jLabel57.setEnabled(false);
            this.jTextField49.setEnabled(false);
            this.jTextField48.setEnabled(false);
        }
    }//GEN-LAST:event_jCheckBox11ActionPerformed

    private void jCheckBox12ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox12ActionPerformed
        // TODO add your handling code here:
        jLabelSC5.setEnabled(jCheckBox12.isSelected());
        jTextFieldSC5.setEnabled(jCheckBox12.isSelected());
    }//GEN-LAST:event_jCheckBox12ActionPerformed

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        try {
            // Set System L&F
            UIManager.setLookAndFeel(
                    UIManager.getSystemLookAndFeelClassName());
        }
        catch (UnsupportedLookAndFeelException e) {
            // handle exception
        }
        catch (ClassNotFoundException e) {
            // handle exception
        }
        catch (InstantiationException e) {
            // handle exception
        }
        catch (IllegalAccessException e) {
            // handle exception
        }
        final MainGUI myGUI = new MainGUI();
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                myGUI.setExtendedState(JFrame.MAXIMIZED_BOTH);
                myGUI.setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton FindFileButtonSC;
    private javax.swing.JRadioButton FlexRadioButton;
    private javax.swing.JRadioButton FlexRadioButtonStorey;
    private javax.swing.JDialog ForceDialogSDOF;
    private javax.swing.JDialog ForceDialog_1;
    private javax.swing.JDialog FrameDialog;
    private javax.swing.JDialog GroundDialog;
    private javax.swing.JDialog InitialDialogSDOF;
    private javax.swing.JDialog InitialDialog_1;
    private javax.swing.JDialog PlotDialog;
    private javax.swing.JDialog SDOFDialog;
    private javax.swing.JDialog SpecCalcDialog;
    private javax.swing.JDialog SpecDialog;
    private javax.swing.JRadioButton StiffRadioButton;
    private javax.swing.JRadioButton StiffRadioButtonStorey;
    private javax.swing.JDialog StoreyDialog;
    private javax.swing.JCheckBox Symetry;
    private gui.DrawPanelGraph drawPanelGraph1;
    private gui.DrawPanelInput drawPanelInput1;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton10;
    private javax.swing.JButton jButton11;
    private javax.swing.JButton jButton12;
    private javax.swing.JButton jButton13;
    private javax.swing.JButton jButton14;
    private javax.swing.JButton jButton15;
    private javax.swing.JButton jButton16;
    private javax.swing.JButton jButton17;
    private javax.swing.JButton jButton18;
    private javax.swing.JButton jButton19;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton20;
    private javax.swing.JButton jButton21;
    private javax.swing.JButton jButton22;
    private javax.swing.JButton jButton23;
    private javax.swing.JButton jButton24;
    private javax.swing.JButton jButton25;
    private javax.swing.JButton jButton26;
    private javax.swing.JButton jButton27;
    private javax.swing.JButton jButton28;
    private javax.swing.JButton jButton29;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton30;
    private javax.swing.JButton jButton31;
    private javax.swing.JButton jButton32;
    private javax.swing.JButton jButton4;
    private javax.swing.JButton jButton5;
    private javax.swing.JButton jButton6;
    private javax.swing.JButton jButton7;
    private javax.swing.JButton jButton8;
    private javax.swing.JButton jButton9;
    private javax.swing.JButton jButton_left;
    private javax.swing.JButton jButton_play;
    private javax.swing.JButton jButton_right;
    private javax.swing.JButton jButton_stop;
    private javax.swing.JButton jButtoncnlfsdof;
    private javax.swing.JButton jButtonfsdof;
    private javax.swing.JButton jButtonupdfsdof;
    private javax.swing.JCheckBox jCheckBox1;
    private javax.swing.JCheckBox jCheckBox10;
    private javax.swing.JCheckBox jCheckBox11;
    private javax.swing.JCheckBox jCheckBox12;
    private javax.swing.JCheckBox jCheckBox2;
    private javax.swing.JCheckBox jCheckBox3;
    private javax.swing.JCheckBox jCheckBox4;
    private javax.swing.JCheckBox jCheckBox5;
    private javax.swing.JCheckBox jCheckBox6;
    private javax.swing.JCheckBox jCheckBox7;
    private javax.swing.JCheckBox jCheckBox8;
    private javax.swing.JCheckBox jCheckBox9;
    private javax.swing.JCheckBox jCheckBoxsdof;
    private javax.swing.JComboBox jComboBox3;
    private javax.swing.JComboBox jComboBox4;
    private javax.swing.JDialog jDialogNewmark;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel18;
    private javax.swing.JLabel jLabel19;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel20;
    private javax.swing.JLabel jLabel21;
    private javax.swing.JLabel jLabel22;
    private javax.swing.JLabel jLabel23;
    private javax.swing.JLabel jLabel24;
    private javax.swing.JLabel jLabel25;
    private javax.swing.JLabel jLabel26;
    private javax.swing.JLabel jLabel27;
    private javax.swing.JLabel jLabel28;
    private javax.swing.JLabel jLabel29;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel30;
    private javax.swing.JLabel jLabel31;
    private javax.swing.JLabel jLabel32;
    private javax.swing.JLabel jLabel33;
    private javax.swing.JLabel jLabel34;
    private javax.swing.JLabel jLabel35;
    private javax.swing.JLabel jLabel36;
    private javax.swing.JLabel jLabel37;
    private javax.swing.JLabel jLabel38;
    private javax.swing.JLabel jLabel39;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel40;
    private javax.swing.JLabel jLabel41;
    private javax.swing.JLabel jLabel42;
    private javax.swing.JLabel jLabel43;
    private javax.swing.JLabel jLabel44;
    private javax.swing.JLabel jLabel45;
    private javax.swing.JLabel jLabel46;
    private javax.swing.JLabel jLabel47;
    private javax.swing.JLabel jLabel48;
    private javax.swing.JLabel jLabel49;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel50;
    private javax.swing.JLabel jLabel51;
    private javax.swing.JLabel jLabel52;
    private javax.swing.JLabel jLabel53;
    private javax.swing.JLabel jLabel54;
    private javax.swing.JLabel jLabel55;
    private javax.swing.JLabel jLabel56;
    private javax.swing.JLabel jLabel57;
    private javax.swing.JLabel jLabel58;
    private javax.swing.JLabel jLabel59;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel60;
    private javax.swing.JLabel jLabel61;
    private javax.swing.JLabel jLabel62;
    private javax.swing.JLabel jLabel63;
    private javax.swing.JLabel jLabel64;
    private javax.swing.JLabel jLabel65;
    private javax.swing.JLabel jLabel66;
    private javax.swing.JLabel jLabel67;
    private javax.swing.JLabel jLabel68;
    private javax.swing.JLabel jLabel69;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JLabel jLabelAngle;
    private javax.swing.JLabel jLabelSC1;
    private javax.swing.JLabel jLabelSC11;
    private javax.swing.JLabel jLabelSC2;
    private javax.swing.JLabel jLabelSC3;
    private javax.swing.JLabel jLabelSC4;
    private javax.swing.JLabel jLabelSC5;
    private javax.swing.JLabel jLabelSC7;
    private javax.swing.JLabel jLabelfsodf;
    private javax.swing.JLabel jLabelsdof;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenu jMenu2;
    private javax.swing.JMenu jMenu3;
    private javax.swing.JMenu jMenu4;
    private javax.swing.JMenu jMenu5;
    private javax.swing.JMenu jMenu6;
    private javax.swing.JMenu jMenu7;
    private javax.swing.JMenu jMenu8;
    private javax.swing.JMenu jMenu9;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JMenuItem jMenuItem10;
    private javax.swing.JMenuItem jMenuItem11;
    private javax.swing.JMenuItem jMenuItem12;
    private javax.swing.JMenuItem jMenuItem13;
    private javax.swing.JMenuItem jMenuItem14;
    private javax.swing.JMenuItem jMenuItem2;
    private javax.swing.JMenuItem jMenuItem3;
    private javax.swing.JMenuItem jMenuItem4;
    private javax.swing.JMenuItem jMenuItem5;
    private javax.swing.JMenuItem jMenuItem6;
    private javax.swing.JMenuItem jMenuItem7;
    private javax.swing.JMenuItem jMenuItem8;
    private javax.swing.JMenuItem jMenuItem9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel10;
    private javax.swing.JPanel jPanel11;
    private javax.swing.JPanel jPanel12;
    private javax.swing.JPanel jPanel13;
    private javax.swing.JPanel jPanel14;
    private javax.swing.JPanel jPanel15;
    private javax.swing.JPanel jPanel16;
    private javax.swing.JPanel jPanel17;
    private javax.swing.JPanel jPanel18;
    private javax.swing.JPanel jPanel19;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel20;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JPanel jPanelSC1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JSlider jSlider2;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JSplitPane jSplitPane2;
    private javax.swing.JSplitPane jSplitPane3;
    private javax.swing.JTable jTable_Columns;
    private javax.swing.JTable jTable_Spec;
    private gui.myTextArea jTextArea1;
    private javax.swing.JTextField jTextField1;
    private javax.swing.JTextField jTextField10;
    private javax.swing.JTextField jTextField11;
    private javax.swing.JTextField jTextField12;
    private javax.swing.JTextField jTextField13;
    private javax.swing.JTextField jTextField14;
    private javax.swing.JTextField jTextField15;
    private javax.swing.JTextField jTextField16;
    private javax.swing.JTextField jTextField17;
    private javax.swing.JTextField jTextField18;
    private javax.swing.JTextField jTextField19;
    private javax.swing.JTextField jTextField2;
    private javax.swing.JTextField jTextField20;
    private javax.swing.JTextField jTextField21;
    private javax.swing.JTextField jTextField22;
    private javax.swing.JTextField jTextField23;
    private javax.swing.JTextField jTextField24;
    private javax.swing.JTextField jTextField25;
    private javax.swing.JTextField jTextField26;
    private javax.swing.JTextField jTextField27;
    private javax.swing.JTextField jTextField28;
    private javax.swing.JTextField jTextField29;
    private javax.swing.JTextField jTextField3;
    private javax.swing.JTextField jTextField30;
    private javax.swing.JTextField jTextField31;
    private javax.swing.JTextField jTextField32;
    private javax.swing.JTextField jTextField33;
    private javax.swing.JTextField jTextField34;
    private javax.swing.JTextField jTextField35;
    private javax.swing.JTextField jTextField36;
    private javax.swing.JTextField jTextField37;
    private javax.swing.JTextField jTextField38;
    private javax.swing.JTextField jTextField39;
    private javax.swing.JTextField jTextField4;
    private javax.swing.JTextField jTextField40;
    private javax.swing.JTextField jTextField41;
    private javax.swing.JTextField jTextField42;
    private javax.swing.JTextField jTextField43;
    private javax.swing.JTextField jTextField44;
    private javax.swing.JTextField jTextField45;
    private javax.swing.JTextField jTextField46;
    private javax.swing.JTextField jTextField47;
    private javax.swing.JTextField jTextField48;
    private javax.swing.JTextField jTextField49;
    private javax.swing.JTextField jTextField5;
    private javax.swing.JTextField jTextField50;
    private javax.swing.JTextField jTextField51;
    private javax.swing.JTextField jTextField52;
    private javax.swing.JTextField jTextField53;
    private javax.swing.JTextField jTextField54;
    private javax.swing.JTextField jTextField55;
    private javax.swing.JTextField jTextField56;
    private javax.swing.JTextField jTextField6;
    private javax.swing.JTextField jTextField7;
    private javax.swing.JTextField jTextField8;
    private javax.swing.JTextField jTextField9;
    private javax.swing.JTextField jTextFieldAngle;
    private javax.swing.JTextField jTextFieldNewmark_dt;
    private javax.swing.JTextField jTextFieldSC1;
    private javax.swing.JTextField jTextFieldSC2;
    private javax.swing.JTextField jTextFieldSC3;
    private javax.swing.JTextField jTextFieldSC4;
    private javax.swing.JTextField jTextFieldSC5;
    private javax.swing.JTextField jTextField_newX;
    private javax.swing.JTextField jTextField_newY;
    private javax.swing.JTextField jTextField_newbx;
    private javax.swing.JTextField jTextField_newby;
    private javax.swing.JTextField jTextFieldbeta;
    private javax.swing.JTextField jTextFieldfsdof;
    private javax.swing.JTextField jTextFieldgamma;
    private javax.swing.JDialog newStoreyElemDialog;
    private gui.SpecPanel specPanel1;
    private javax.swing.JFileChooser theFileChooser;
    // End of variables declaration//GEN-END:variables

    private void parse(File theFile){
        try {
            BufferedReader in = new BufferedReader(new FileReader(theFile.getPath()));
            String dataLine;
            DefaultTableModel tableModel = (DefaultTableModel) jTable_Spec.getModel();
            while (tableModel.getRowCount() != 0) {
                tableModel.removeRow(tableModel.getRowCount() - 1);
            }

            tableModel.setColumnCount(0);
            String name= "Περίοδος (sec)";
            tableModel.addColumn(name);
            name= "Φασματiκή επιτάχυνση (m/sec^2)";
            tableModel.addColumn(name);
            
            
            //StringTokenizer 
            String st[];
            while ((dataLine = in.readLine()) != null) {
                st = dataLine.split(" ");
                tableModel.addRow(new Object[]{Double.parseDouble(st[0]),Double.parseDouble(st[1])});
            }
            in.close();
        } catch (IOException e) {
        }
    }
    
    private void parseColumns(File theFile){
        try {
            BufferedReader in = new BufferedReader(new FileReader(theFile.getPath()));
            String dataLine;
            DefaultTableModel tableModel = (DefaultTableModel) jTable_Columns.getModel();
            while (tableModel.getRowCount() != 0) {
                tableModel.removeRow(tableModel.getRowCount() - 1);
            }
            
            tableModel.setColumnCount(0);
            String name= "x (m)";
            tableModel.addColumn(name);
            name= "y (m)";
            tableModel.addColumn(name);
            name= "bx (m)";
            tableModel.addColumn(name);
            name= "by (m)";
            tableModel.addColumn(name);
            
            
            //StringTokenizer 
            String st[];
            while ((dataLine = in.readLine()) != null) {
                st = dataLine.split(" ");
                tableModel.addRow(new Object[]{st[0],st[1],st[2],st[3]});
            }
            in.close();
        } catch (IOException e) {
        }
    }
    
    public int getXindex(){
        return this.jComboBox3.getSelectedIndex();
    }
    
    public int getYindex(){
    return this.jComboBox4.getSelectedIndex();
    }
    
    public String getXparameter(){
        int index;
        index=this.jComboBox3.getSelectedIndex();
        String val;
        if(this.RespPlotSelected()){
            switch(index){
                case 0 : val=resb.getString("Time"); break ;
                case 1 : val=resb.getString("External_Force")+" 0"; break ;
                case 2 : val=resb.getString("External_Force")+" 1"; break ;
                case 3 : val=resb.getString("External_Force")+" 2"; break ;
                case 4 : val=resb.getString("External_Force")+" 3"; break ;
                case 5 : val=resb.getString("Displacement")+" 0"; break ;
                case 6 : val=resb.getString("Displacement")+" 1"; break ;
                case 7 : val=resb.getString("Displacement")+" 2"; break ;
                case 8 : val=resb.getString("Displacement")+" 3"; break ;
                case 9 : val=resb.getString("Velocity")+" 0"; break ;
                case 10 : val=resb.getString("Velocity")+" 1"; break ;
                case 11 : val=resb.getString("Velocity")+" 2"; break ;
                case 12 : val=resb.getString("Velocity")+" 3"; break ;
                case 13 : val=resb.getString("Acceleration")+" 0"; break ;
                case 14 : val=resb.getString("Acceleration")+" 1"; break ;
                case 15 : val=resb.getString("Acceleration")+" 2"; break ;
                case 16 : val=resb.getString("Acceleration")+" 3"; break ;
                case 17 : val=resb.getString("Elastic_Force")+" 0"; break ;
                case 18 : val=resb.getString("Elastic_Force")+" 1"; break ;
                case 19 : val=resb.getString("Elastic_Force")+" 2"; break ;
                case 20 : val=resb.getString("Elastic_Force")+" 3"; break ;
                case 21 : val=resb.getString("Inertial_Force")+" 0"; break ;
                case 22 : val=resb.getString("Inertial_Force")+" 1"; break ;
                case 23 : val=resb.getString("Inertial_Force")+" 2"; break ;
                case 24 : val=resb.getString("Inertial_Force")+" 3"; break ;
                case 25 : val=resb.getString("Damping_Force")+" 0"; break ;
                case 26 : val=resb.getString("Damping_Force")+" 1"; break ;
                case 27 : val=resb.getString("Damping_Force")+" 2"; break ;
                case 28 : val=resb.getString("Damping_Force")+" 3"; break ;
                default: val=resb.getString("X_Param"); break ;
            }
        }else{
            switch(index){
                case 0 : val=resb.getString("Time"); break ;
                case 1 : val=resb.getString("eigenperiod"); break ;
                default: val=resb.getString("X_Param"); break ;
            }
        }
        return val;
    }
    
    public String getΥparameter(){
        int index;
        index=this.jComboBox4.getSelectedIndex();
        String val;
        if(this.RespPlotSelected()){
            switch(index){
                case 0 : val=resb.getString("Time"); break ;
                case 1 : val=resb.getString("External_Force")+" 0"; break ;
                case 2 : val=resb.getString("External_Force")+" 1"; break ;
                case 3 : val=resb.getString("External_Force")+" 2"; break ;
                case 4 : val=resb.getString("External_Force")+" 3"; break ;
                case 5 : val=resb.getString("Displacement")+" 0"; break ;
                case 6 : val=resb.getString("Displacement")+" 1"; break ;
                case 7 : val=resb.getString("Displacement")+" 2"; break ;
                case 8 : val=resb.getString("Displacement")+" 3"; break ;
                case 9 : val=resb.getString("Velocity")+" 0"; break ;
                case 10 : val=resb.getString("Velocity")+" 1"; break ;
                case 11 : val=resb.getString("Velocity")+" 2"; break ;
                case 12 : val=resb.getString("Velocity")+" 3"; break ;
                case 13 : val=resb.getString("Acceleration")+" 0"; break ;
                case 14 : val=resb.getString("Acceleration")+" 1"; break ;
                case 15 : val=resb.getString("Acceleration")+" 2"; break ;
                case 16 : val=resb.getString("Acceleration")+" 3"; break ;
                case 17 : val=resb.getString("Elastic_Force")+" 0"; break ;
                case 18 : val=resb.getString("Elastic_Force")+" 1"; break ;
                case 19 : val=resb.getString("Elastic_Force")+" 2"; break ;
                case 20 : val=resb.getString("Elastic_Force")+" 3"; break ;
                case 21 : val=resb.getString("Inertial_Force")+" 0"; break ;
                case 22 : val=resb.getString("Inertial_Force")+" 1"; break ;
                case 23 : val=resb.getString("Inertial_Force")+" 2"; break ;
                case 24 : val=resb.getString("Inertial_Force")+" 3"; break ;
                case 25 : val=resb.getString("Damping_Force")+" 0"; break ;
                case 26 : val=resb.getString("Damping_Force")+" 1"; break ;
                case 27 : val=resb.getString("Damping_Force")+" 2"; break ;
                case 28 : val=resb.getString("Damping_Force")+" 3"; break ;
                default: val=resb.getString("Y_Param"); break ;
            }
        }else{
            if(this.theSpecCalc!=null){
                switch(index){
                    case 0 : val=resb.getString("ground_acceleration"); break ;
                    case 1 : val=resb.getString("Spectral")+resb.getString("Displacement"); break ;
                    case 2 : val=resb.getString("Spectral")+resb.getString("Velocity"); break ;
                    case 3 : val=resb.getString("Spectral")+resb.getString("Acceleration"); break ;
                    default: val=resb.getString("Y_Param"); break ;
                }
            }else{
                switch(index){
                    case 0 : val=resb.getString("ground_acceleration"); break ;
                    case 1 : val=resb.getString("ground_velocity"); break ;
                    case 2 : val=resb.getString("ground_displacement"); break ;
                    default: val=resb.getString("Y_Param"); break ;
                }
            }
        }
        return val;
    }
    
    public double[] getHistory(int ind){
        double History[] = new double[this.f1.length];
        switch(ind){
            case 0 : History=this.getTime(); break ;
            case 1 : History=this.f0_interp; break ;
            case 2 : History=this.f1_interp; break ;
            case 3 : History=this.f2_interp; break ;
            case 4 : History=this.f3_interp; break ;
            case 5 : History=this.u0; break ;
            case 6 : History=this.u1; break ;
            case 7 : History=this.u2; break ;
            case 8 : History=this.u3; break ;
            case 9 : History=this.v0; break ;
            case 10 : History=this.v1; break ;
            case 11 : History=this.v2; break ;
            case 12 : History=this.v3; break ;
            case 13 : History=this.a0; break ;
            case 14 : History=this.a1; break ;
            case 15 : History=this.a2; break ;
            case 16 : History=this.a3; break ;
            case 17 : 
                for(int i=0; i<History.length;i++){
                    History[i]=this.theStructure.getK().get(0, 0)*u0[i];
                    History[i]+=this.theStructure.getK().get(0, 1)*u1[i];
                    if(this.getNumStories()>1)History[i]+=this.theStructure.getK().get(0, 2)*u2[i];
                    if(this.getNumStories()>2)History[i]+=this.theStructure.getK().get(0, 3)*u3[i];
                }
                break ;
            case 18:
                if(this.isIsolated()){
                    for(int i=0; i<History.length;i++){
                        History[i]=this.theStructure.getK().get(1, 0)*u0[i];
                        History[i]+=this.theStructure.getK().get(1, 1)*u1[i];
                        if(this.getNumStories()>1)History[i]+=this.theStructure.getK().get(1, 2)*u2[i];
                        if(this.getNumStories()>2)History[i]+=this.theStructure.getK().get(1, 3)*u3[i];
                    }
                }else{
                    for(int i=0; i<History.length;i++){
                        History[i]=this.theStructure.getK().get(0, 0)*u1[i];
                        if(this.getNumStories()>1)History[i]+=this.theStructure.getK().get(0, 1)*u2[i];
                        if(this.getNumStories()>2)History[i]+=this.theStructure.getK().get(0, 2)*u3[i];
                    }
                }
                break ;
            case 19:
                if(this.isIsolated()){
                    for(int i=0; i<History.length;i++){
                        History[i]=this.theStructure.getK().get(2, 0)*u0[i];
                        History[i]+=this.theStructure.getK().get(2, 1)*u1[i];
                        if(this.getNumStories()>1)History[i]+=this.theStructure.getK().get(2, 2)*u2[i];
                        if(this.getNumStories()>2)History[i]+=this.theStructure.getK().get(2, 3)*u3[i];
                    }
                }else{
                    for(int i=0; i<History.length;i++){
                        History[i]=this.theStructure.getK().get(1, 0)*u1[i];
                        if(this.getNumStories()>1)History[i]+=this.theStructure.getK().get(1, 1)*u2[i];
                        if(this.getNumStories()>2)History[i]+=this.theStructure.getK().get(1, 2)*u3[i];
                    }
                }
                break ;
            case 20:
                if(this.isIsolated()){
                    for(int i=0; i<History.length;i++){
                        History[i]=this.theStructure.getK().get(3, 0)*u0[i];
                        History[i]+=this.theStructure.getK().get(3, 1)*u1[i];
                        if(this.getNumStories()>1)History[i]+=this.theStructure.getK().get(3, 2)*u2[i];
                        if(this.getNumStories()>2)History[i]+=this.theStructure.getK().get(3, 3)*u3[i];
                    }
                }else{
                    for(int i=0; i<History.length;i++){
                        History[i]=this.theStructure.getK().get(2, 0)*u1[i];
                        if(this.getNumStories()>1)History[i]+=this.theStructure.getK().get(2, 1)*u2[i];
                        if(this.getNumStories()>2)History[i]+=this.theStructure.getK().get(2, 2)*u3[i];
                    }
                }
                break ;
            case 21 : 
                for(int i=0; i<History.length;i++){
                    History[i]=this.theStructure.getC().get(0, 0)*v0[i];
                    History[i]+=this.theStructure.getC().get(0, 1)*v1[i];
                    if(this.getNumStories()>1)History[i]+=this.theStructure.getC().get(0, 2)*v2[i];
                    if(this.getNumStories()>2)History[i]+=this.theStructure.getC().get(0, 3)*v3[i];
                }
                break ;
            case 22:
                if(this.isIsolated()){
                    for(int i=0; i<History.length;i++){
                        History[i]=this.theStructure.getC().get(1, 0)*v0[i];
                        History[i]+=this.theStructure.getC().get(1, 1)*v1[i];
                        if(this.getNumStories()>1)History[i]+=this.theStructure.getC().get(1, 2)*v2[i];
                        if(this.getNumStories()>2)History[i]+=this.theStructure.getC().get(1, 3)*v3[i];
                    }
                }else{
                    for(int i=0; i<History.length;i++){
                        History[i]=this.theStructure.getC().get(0, 0)*v1[i];
                        if(this.getNumStories()>1)History[i]+=this.theStructure.getC().get(0, 1)*v2[i];
                        if(this.getNumStories()>2)History[i]+=this.theStructure.getC().get(0, 2)*v3[i];
                    }
                }
                break ;
            case 23:
                if(this.isIsolated()){
                    for(int i=0; i<History.length;i++){
                        History[i]=this.theStructure.getC().get(2, 0)*v0[i];
                        History[i]+=this.theStructure.getC().get(2, 1)*v1[i];
                        if(this.getNumStories()>1)History[i]+=this.theStructure.getC().get(2, 2)*v2[i];
                        if(this.getNumStories()>2)History[i]+=this.theStructure.getC().get(2, 3)*v3[i];
                    }
                }else{
                    for(int i=0; i<History.length;i++){
                        History[i]=this.theStructure.getC().get(1, 0)*v1[i];
                        if(this.getNumStories()>1)History[i]+=this.theStructure.getC().get(1, 1)*v2[i];
                        if(this.getNumStories()>2)History[i]+=this.theStructure.getC().get(1, 2)*v3[i];
                    }
                }
                break ;
            case 24:
                if(this.isIsolated()){
                    for(int i=0; i<History.length;i++){
                        History[i]=this.theStructure.getC().get(3, 0)*v0[i];
                        History[i]+=this.theStructure.getC().get(3, 1)*v1[i];
                        if(this.getNumStories()>1)History[i]+=this.theStructure.getC().get(3, 2)*v2[i];
                        if(this.getNumStories()>2)History[i]+=this.theStructure.getC().get(3, 3)*v3[i];
                    }
                }else{
                    for(int i=0; i<History.length;i++){
                        History[i]=this.theStructure.getC().get(2, 0)*u1[i];
                        if(this.getNumStories()>1)History[i]+=this.theStructure.getC().get(2, 1)*v2[i];
                        if(this.getNumStories()>2)History[i]+=this.theStructure.getC().get(2, 2)*v3[i];
                    }
                }
                break ;
            case 25 : 
                for(int i=0; i<History.length;i++){
                    History[i]=this.theStructure.getM().get(0, 0)*a0[i];
                    History[i]+=this.theStructure.getM().get(0, 1)*a1[i];
                    if(this.getNumStories()>1)History[i]+=this.theStructure.getM().get(0, 2)*a2[i];
                    if(this.getNumStories()>2)History[i]+=this.theStructure.getM().get(0, 3)*a3[i];
                }
                break ;
            case 26:
                if(this.isIsolated()){
                    for(int i=0; i<History.length;i++){
                        History[i]=this.theStructure.getM().get(1, 0)*a0[i];
                        History[i]+=this.theStructure.getM().get(1, 1)*a1[i];
                        if(this.getNumStories()>1)History[i]+=this.theStructure.getM().get(1, 2)*a2[i];
                        if(this.getNumStories()>2)History[i]+=this.theStructure.getM().get(1, 3)*a3[i];
                    }
                }else{
                    for(int i=0; i<History.length;i++){
                        History[i]=this.theStructure.getM().get(0, 0)*a1[i];
                        if(this.getNumStories()>1)History[i]+=this.theStructure.getM().get(0, 1)*a2[i];
                        if(this.getNumStories()>2)History[i]+=this.theStructure.getM().get(0, 2)*a3[i];
                    }
                }
                break ;
            case 27:
                if(this.isIsolated()){
                    for(int i=0; i<History.length;i++){
                        History[i]=this.theStructure.getM().get(2, 0)*a0[i];
                        History[i]+=this.theStructure.getM().get(2, 1)*a1[i];
                        if(this.getNumStories()>1)History[i]+=this.theStructure.getM().get(2, 2)*a2[i];
                        if(this.getNumStories()>2)History[i]+=this.theStructure.getM().get(2, 3)*a3[i];
                    }
                }else{
                    for(int i=0; i<History.length;i++){
                        History[i]=this.theStructure.getM().get(1, 0)*a1[i];
                        if(this.getNumStories()>1)History[i]+=this.theStructure.getM().get(1, 1)*a2[i];
                        if(this.getNumStories()>2)History[i]+=this.theStructure.getM().get(1, 2)*a3[i];
                    }
                }
                break ;
            case 28:
                if(this.isIsolated()){
                    for(int i=0; i<History.length;i++){
                        History[i]=this.theStructure.getM().get(3, 0)*a0[i];
                        History[i]+=this.theStructure.getM().get(3, 1)*a1[i];
                        if(this.getNumStories()>1)History[i]+=this.theStructure.getM().get(3, 2)*a2[i];
                        if(this.getNumStories()>2)History[i]+=this.theStructure.getM().get(3, 3)*a3[i];
                    }
                }else{
                    for(int i=0; i<History.length;i++){
                        History[i]=this.theStructure.getM().get(2, 0)*a1[i];
                        if(this.getNumStories()>1)History[i]+=this.theStructure.getM().get(2, 1)*a2[i];
                        if(this.getNumStories()>2)History[i]+=this.theStructure.getM().get(2, 2)*a3[i];
                    }
                }
                break ;
            default:  ; break ;
        }
        return History;
    }
    
    public double[] getHistoryX(int ind){
        double History[] = null;
        if(this.theSpecCalc!=null){
            switch(ind){
                case 0 : 
                    History=new double[this.theSpecCalc.get_fext().length]; 
                    for(int i=0;i<History.length;i++){
                        History[i]=i*theSpecCalc.get_dt_of_fext();
                    }
                    break ;
                case 1: History=this.theSpecCalc.get_thePeriods(); break;
            }
        }else{
            History=new double[this.theGround.getSynthAcc().length]; 
            double dt = theGround.get_dt();
            for(int i=0;i<History.length;i++){
                History[i]=i*dt;
            }
        }
        return History;
    }
    
    public double[] getHistoryY(int ind){
        double History[] = null;
        if(this.theSpecCalc!=null){
            switch(ind){
                case 0: History=this.theSpecCalc.get_fext(); break;
                case 1: History=this.theSpecCalc.get_Sdisp(); break;
                case 2: History=this.theSpecCalc.get_PSvelc(); break;
                case 3: History=this.theSpecCalc.get_PSaccl(); break;
            }
        }else{
            switch(ind){
                case 0: History=this.theGround.getSynthAcc(); break;
                case 1: History=this.theGround.getSynthVel(); break;
                case 2: History=this.theGround.getSynthDis(); break;
            }
        }
        return History;
    }
    
    public double[] getTime(){
        int len=this.f1_interp.length;
        double[] time=new double[len];
        for(int i=0; i<len; i++){
            time[i]=i*this.dt;
        }
        return time;
    }
    
    public double getDisp1(int wstep){
        return this.u1[wstep];
    }
    
    public double getDisp2(int wstep){
        return this.u2[wstep];
    }
    
    public double getDisp3(int wstep){
        return this.u3[wstep];
    }
    
    public int getNumStories(){
        return this.theStructure.getNumDOFS();
    }
         public boolean isIsolated(){
        return theStructure.isIsolated();
    }
    
    public void inputloadsdof(){
        this.ForceDialogSDOF.setVisible(true);
    }
    
    public void inputloadframe(){
        jCheckBox1.setEnabled(true);
         if(this.theStructure.getNumDOFS()<3){
            jLabel14.setEnabled(false);
            jCheckBox4.setEnabled(false);
            jTextField12.setEnabled(false);
            jButton19.setEnabled(false);
            jLabel17.setEnabled(false);          }
        if(this.theStructure.getNumDOFS()<2){
            jLabel13.setEnabled(false);
            jCheckBox3.setEnabled(false);
            jTextField11.setEnabled(false);
            jButton19.setEnabled(false);
            jLabel16.setEnabled(false);
        }
        if(this.theStructure.getNumDOFS()>2){
            jLabel14.setEnabled(true);
            jCheckBox4.setEnabled(true);
            jTextField12.setEnabled(true);
            //jButton19.set    led(true);
            //jLabel17.setEnabled(true);
        }
        if(this.theStructure.getNumDOFS()>1){
            jLabel13.setEnabled(true);
            jCheckBox3.setEnabled(true);             
            jTextField11.setEnabled(true);
            //jButton18.setEnabled(true);
            //jLa    6.setEnabled(true)
        }
        jLabel12.setText(ResourceBundle.getBundle("misc.bundle", local).getString("msg_094"));
        jLabel13.setText(ResourceBundle.getBundle("misc.bundle", local).getString("msg_095"));
        jLabel14.setText(ResourceBundle.getBundle("misc.bundle", local).getString("msg_096"));
        ForceDialog_1.setVisible(true);
    }
    
    public void inputloadstorey(){
        jCheckBox1.setEnabled(true);         
        jLabel12.setText(ResourceBundle.getBundle("misc.bundle", local).getString("msg_101"));
        jLabel13.setText(ResourceBundle.getBundle("misc.bundle", local).getString("msg_102"));
        jLabel14.setText(ResourceBundle.getBundle("misc.bundle", local).getString("msg_103"));
        ForceDialog_1.setVisible(true);
    }
    
    public void initialsdof(){
        this.InitialDialogSDOF.setVisible(true);
    }
    
    public void initialframe(){         
        jLabel20.setText(ResourceBundle.getBundle("misc.bundle", local).getString("msg_085"));
        jLabel51.setText(ResourceBundle.getBundle("misc.bundle", local).getString("msg_086"));
        jLabel52.setText(ResourceBundle.getBundle("misc.bundle", local).getString("msg_087"));
        
        jLabel58.setText(ResourceBundle.getBundle("misc.bundle", local).getString("msg_088"));
        jLabel59.setText(ResourceBundle.getBundle("misc.bundle", local).getString("msg_089"));
        jLabel60.setText(ResourceBundle.getBundle("misc.bundle", local).getString("msg_090"));
        
        if(theStructure.getNumDOFS()>2){
            this.jLabel52.setEnabled(true); this.jTextField13.setEnabled(true); this.jLabel60.setEnabled(true); this.jTextField41.setEnabled(true);
            this.jLabel51.setEnabled(true); this.jTextField14.setEnabled(true); this.jLabel59.setEnabled(true); this.jTextField42.setEnabled(true);
            this.jLabel20.setEnabled(true); this.jTextField38.setEnabled(true); this.jLabel58.setEnabled(true); this.jTextField43.setEnabled(true);
        }
        if(theStructure.getNumDOFS()==2){
            this.jLabel52.setEnabled(true); this.jTextField13.setEnabled(false); this.jLabel60.setEnabled(false); this.jTextField41.setEnabled(false);
            this.jLabel51.setEnabled(true); this.jTextField14.setEnabled(true); this.jLabel59.setEnabled(true); this.jTextField42.setEnabled(true);
            this.jLabel20.setEnabled(true); this.jTextField38.setEnabled(true); this.jLabel58.setEnabled(true); this.jTextField43.setEnabled(true);
        }
        if(theStructure.getNumDOFS()==1){              this.jLabel52.setEnabled(false); this.jTextField13.setEnabled(false); this.jLabel60.setEnabled(false); this.jTextField41.setEnabled(false);
            this.jLabel51.setEnabled(false); this.jTextField14.setEnabled(false); this.jLabel59.setEnabled(false); this.jTextField42.setEnabled(false);
            this.jLabel20.setEnabled(true); this.jTextField38.setEnabled(true); this.jLabel58.setEnabled(true); this.jTextField43.setEnabled(true);
        }
        InitialDialog_1.setVisible(true);
    }
    
    public void initialstorey(){           
        jLabel20.setText("Αρχική μετακίνηση κατά x:");
        jLabel51.setText("Αρχική μετακίνηση κατά y:");
        jLabel52.setText("Αρχική στρέψη           :");
        
        jLabel58.setText("Αρχική ταχύτητα κατά x  :");
        jLabel59.setText("Αρχική ταχύτητα κατά y  :");
        jLabel60.setText("Αρχική στροφική ταχύτητα:");
        
        this.jLabel52.setEnabled(true); this.jTextField13.setEnabled(true); this.jLabel60.setEnabled(true); this.jTextField41.setEnabled(true);
        this.jLabel51.setEnabled(true); this.jTextField14.setEnabled(true); this.jLabel59.setEnabled(true); this.jTextField42.setEnabled(true);
        this.jLabel20.setEnabled(true); this.jTextField38.setEnabled(true); this.jLabel58.setEnabled(true); this.jTextField43.setEnabled(true);
        
        InitialDialog_1.setVisible(true);
    }
    
    public boolean isDouble( String input ){
        boolean theb=false;
        try{
             Double.parseDouble( input );
            theb= true;
        }catch(Exception e){
            theb= false;
        }
        return theb;
  }
    
    public boolean SpecPlotSelected(){return this.SpecPlot.isSelected();}
    
    public boolean RespPlotSelected(){return this.RespPlot.isSelected();}
    
    public boolean NullStructure(){
        boolean b=false;
        if(theStructure==null)b=true;
        return b;
    }
    
    public boolean NullSpecCalc(){
        boolean b=false;
        if(theSpecCalc==null)b=true;
        return b;
    }
    
    public boolean NullGroundCalc(){
        boolean b=false;
        if(theGround==null)b=true;
        return b;
    }
    
    public ResourceBundle getResourceBundle(){
        return this.resb;
    }
}
